/**	AddDocument.js
*	@author: JAMI
**/

var gDestProjects = new Array(); // Array to store 'Target Projects' data
var gDestProjectFolders = new Array(); //Array to store 'Target Projects' Folders' data

var gProjectID; // Target Project ID
var gInitialProjectName; //Target Project Name (used for initial Upload Page load with a Project Context)
var gDestFolderID; // Target Folder ID
var gIsDestProjIsTemplate = false;
var gCurrentCategoryID =''; 
var gProjectPermissions;

//labels
var langStrings;
var docTypeLabels;

//state flags
var gHasProjectContext = false;
var gHasProjectFolderContext = false;
var gHasApprovalSetup = false;
var gCanChangeApproval = false;
var gCanStartAppCycle = false;
var gStartAppCheckEnabled=true;
var gStartAppDefaultValue=true;
var gUploadControlsShown = false;

var gTempDocWithAttributesSelected = false;

var gCopyProjectsLoaded = false;
var gCopyDocProjectsHTML = null;

var gIsOtherDocTypeEnabled = false;
var gIsComponentDocTypeEnabled = false;
var gIsURLDocTypeEnabled = false;
var gIsCADDesignDocEnabled = false;
var gIsCADManufacturingDocEnabled = false;
var gIsCAD3DDocEnabled = false;
var gIsCADCanvasDocEnabled = false;
var gIsCapeDocEnabled = false;
var gIsGraphicsDocEnabled = false;
var gIsPageListDocEnabled = false;
var gIsZippedColladaDocEnabled = false;
var gIsColladaDocEnabled = false;
var gIsZIPFileAsGraphic = false;
var gIsPDFFileAsGraphic = false;
var gIsChiliDocEnabled = false;
var gIsTextContentDocEnabled = false;
var gBOMEnabled = 1; // does the server have Bill Of Materials enabled. Is set false via XSL in case disabled

var gEnabledDocTypeIDs = new Array();
var gGraphicalFileExtList = new Array();
var gArtiosCADFileExtList = new Array();
var gDocTypeConfigs = new Array(); // array that contains doc type specific configurations

var gknownExtList = new Array();

// is copy document variable
var gIsCopyDocument= false;
var gDocumentID ;
var gDocVersionID ;
var gDocumentName ;
var gDocumentDescription ;
var gDocVersionCatID ;
var gSourceCopyDocumentProjectID ;

// The IDs of various DocTypes
var gOtherDocTypeID = '00001_0000000005';
var gCADDesignDocTypeID = '00001_0000000001';
var gCADManufacturingID = '00001_0000000002';
var gCAD3DDocTypeID = '00001_0000000003';
var gCADCanvasDocTypeID = '00001_0000000020';
var gGraphicsDocTypeID = '00001_0000000004';
var gCapeDocDocTypeID = '00001_0000000008';
var gPageListDocTypeID = '00001_0000000014';
var gZippedColladaDocTypeID = '00001_0000000016';
var gColladaDocTypeID = '00001_0000000017';
var gChiliDocTypeID = '00001_0000000018';
var gTextContentDocTypeID = '00001_0000000019';
var gComponentDocTypeID = '00001_0000000021';

// uses autonaming
var gCurrentlyUseAutoname = false ;

// load EventBasedValidator
require(["utils/EventBasedValidator"],function(EventBasedValidator){
	EventBasedValidator.getInstance();
});



var gDestinationSelectSDrop = null;
var gCopyFromSDrop = null;

/*
* Loads up Document Templates for the current Target Project (if available)
* Fills up the appropriate dropdown box with the returned Template Documents
*/
function LoadDocTemplatesForProject() 
{	
	//alert ("LoadDocTemplatesForProject() start");
	ToggleExtraTemplateDocRow(false);
	$("#doc_upload_type_switch_td").hide();
	
	
	if (gProjectID == "")
	{
		return;	
	}
	
	//change the gTemplateDocsLoaded flag
	gTemplateDocsLoaded = false;	

	// URL Parameters for fetching 'Project Creation Info' --> only Document Templates feedback is interesting in this case
	var URLParam = "&projectID=" + gProjectID;

	//alert("LoadDocTemplatesForProject() > calling AJAX with an URL : GetProjectCreationInfo.jsp?action=LoadTemplateDocuments" + URLParam);
	try {
		ajax({
			url: "GetProjectCreationInfo.jsp?action=LoadTemplateDocuments" + URLParam,
			type: "GET",
			data: "xml",
			debug: false,
			synchronous: false,
			//timeout: 80000,
			onError: function(status,objHdl, description)
			{          
				//window.alert(description);
				if ( description == 'SESSION_EXP')
				{
					uploadAjaxCallSessionExpired();
				}
				else
				{
					window.alert("Unable to load Template Documents linked to the Destination Project. Server status: "+status);
				} 
			},
			onSuccess: function(xml) 
			{	
				//alert("LoadDocTemplatesForProject() > AJAX call returned with an XML reposnse!.");
				// Get Template (not Project) Documents in the project for document selector
				gTemplateDocumentList = new Array();
				gTemplateDocumentThumbnailList= new Array();
				
				var nodeList = xml.getElementsByTagName("template_docs");
				if(nodeList != null && nodeList.length > 0) 
				{
					var node = 0;
					for(node = 0; node < nodeList.length; node++) 
					{
						//alert("LoadDocTemplatesForProject() > AJAX response > Processing found template documents.");
						var projectDocuments = nodeList[node].getElementsByTagName("doc_version_checkout");
						if(projectDocuments != null && projectDocuments.length > 0) 
						{
							//mark the 'hasDocuments' flag
							if (!gHasTemplateDocuments)
							{
								gHasTemplateDocuments = true;
							}
							
							var g = 0;
							for(g = 0; g < projectDocuments.length; g++) 
							{
								var projectDocument = projectDocuments[g].getElementsByTagName("doc_version");
								var documentId = WCXML.GetElementText(projectDocument[0], "document_id", false);
								var docVersionId = WCXML.GetElementAttribute(projectDocument[0], "id");
								var documentElem = projectDocument[0].getElementsByTagName("document");										
								var documentName = WCXML.GetElementText(documentElem[0], "name", false);
								var categoryId = WCXML.GetElementText(projectDocument[0], "category_id", false);
								var docTypeId = WCXML.GetElementText(projectDocument[0], "doctype_id", false);

								// Get the folder; we rely on it sitting two levels outside the doc_version_checkout (if it exists)
								var folderName = "";
								if (projectDocuments[g].parentNode != null) 
								{
									var folderElem = projectDocuments[g].parentNode.parentNode;
									if (folderElem != null && folderElem.nodeName == "folder") 
									{
											folderName = WCXML.GetElementText(folderElem, "name", false);
									}
								}
								
								// Add Info to Array
								gTemplateDocumentList.push({id: documentId, docverid: docVersionId, name: documentName, categoryid: categoryId, foldername: folderName, doctypeid: docTypeId});
							}
						}
						else
						{
							//alert("LoadDocTemplatesForProject() > AJAX response > Not found any template documents.");
							//no template documents were found
							gHasTemplateDocuments = false;
						}
					}
					
					//alert("LoadDocTemplatesForProject() > AJAX response > Processing found template documents. DONE");
				}
				else
				{
					//alert("LoadDocTemplatesForProject() > AJAX response > Not found any template documents.");
					//no template documents were found
					gHasTemplateDocuments = false;
				}
			
			//alert("LoadDocTemplatesForProject() > AJAX response > Post process - HTML GUI handling start.");
			//change the gTemplateDocsLoaded flag
			gTemplateDocsLoaded = true;	
			
			//fill up the appropriate dropdown boxes for selecting template docs
			FillUpDocTempDropDown();

			
			
			
			
			// We have template documents: enable the New document option
			setHasNewDocumentOption(gHasTemplateDocuments);

			// set additional document select options
			setHasLinkBrowseDocumentOption(false); // disabled for simplicity
			setHasLinkSelectDocumentOption(false); // we already selects if documents are to be copied or not (from existing project)
			setHasCopyDocumentOption(true);				
			// For now we do not want the list delete controls
			setHasListDeleteOption(false);

			//add/remove the 'New' upload mode option from the appropriate dropdown box
			ToggleNewDocUploadOption(gHasTemplateDocuments);
			
			//alert("before handling state " + $("#Select_Template_Document").is(':visible'));	
//			if (DoShowExtraTemplateDocsRow())
//			{
//				//show the 'Extra Template Docs' row only for certain 'doc upload source' types	
//				ToggleExtraTemplateDocRow(true);
//			}
//			else
//			{
//				ToggleExtraTemplateDocRow(false);
//			}
			
			// if the type is single upload, show the switch to multi upload
			if (document.actionform.uploadType.value == "single") 
		      	$("#doc_upload_type_switch_td").show();
      	
			
			}//end: AJAX success callback					
		}); // End Ajax code
	} 
	catch (err) 
	{
		alert("Problem in keep session alive: " + err);
	}
	
}


/*
* Fills up the dropdown select box that is used to pick a Document Template for uploading a new Document (id: Select_SourceNewDoc)
*/
function FillUpDocTempDropDown()
{
	//alert("FillUpDocumentTemplatesDropDownSelect started");
	
	//modify the DD listboxes only if
	if (gTemplateDocumentList != null && gTemplateDocumentList.length > 0 && gTemplateDocsLoaded)
	{		
		//alert("FillUpDocumentTemplatesDropDownSelect Template Documents available - adding the options");
		
		//clear the template docs. lists
		$("#Select_SourceNewDoc").empty();
		$("#Select_Template_Document").empty();
		
		//insert the first 'dummy OPTION' item into the appropriate list
		//alert("FillUpDocumentTemplatesDropDownSelect adding 'Please Select' item");
		var pleaseSelectOptionHTML =  '<option value="" selected="selected">'+langStrings.pleaseSelect+'</option>';
		
		//alert ("Option to be inserted - " + pleaseSelectOptionHTML);
		$("#Select_SourceNewDoc").append(pleaseSelectOptionHTML);
		$("#Select_Template_Document").append(pleaseSelectOptionHTML);
		
		//...and now go through the list and add a new OPTION item into the appropriate list
		var curTempDocID, curTempDocName, curTempDocNameLong, curTempDocHTML, curTempDocHTMLLong;
		for (var i = 0; i < gTemplateDocumentList.length; i++)
		{
			//retrieve the basic data for the current Template Document
			curTempDocID = gTemplateDocumentList[i].id;
			curPreprocessedTempDocName = gTemplateDocumentList[i].name;
			
			//process the name length (shrink it if too long)
			curTempDocName = ProcessSelectBoxItemLabel(curPreprocessedTempDocName, 60);
			curTempDocNameLong = ProcessSelectBoxItemLabel(curPreprocessedTempDocName, 90);
			
			//create an <OPTION> item html for the current Template Document
			curTempDocHTML = '<option value="'+curTempDocID+'" >'+curTempDocName+'</option>';
			curTempDocHTMLLong = '<option value="'+curTempDocID+'" >'+curTempDocNameLong+'</option>';
			
					//alert ("Option to be inserted - " + curTempDocHTML);
			
			//...and add it into the appropriate dropdown box
			$("#Select_SourceNewDoc").append(curTempDocHTML);
			$("#Select_Template_Document").append(curTempDocHTMLLong);
		}
//		$("#temp_doc_select_row").show();
		
		//alert("FillUpDocumentTemplatesDropDownSelect Template Documents available - adding the options finished");
	}
}

function LoadProjectsForDocumentCopy()
{
	// show "Copy From" project selector, and do a wildcard search
	gCopyFromSDrop.show();
	gCopyFromSDrop.searchFor('');
}

/*
* Fetches available Documents that can be used to copy (for Project that is currently selected for copying from)
*/
function LoadProjectCopyDocuments(selectElem) 
{
	//get the Project ID of the Project selected to copy document from
	var copyDocProjectID;
	
	copyDocProjectID = selectElem.options[selectElem.selectedIndex].value;
	
	//check if the selected Copy Project matches the currently selected Target Project (which is forbidden)
	if (copyDocProjectID == gProjectID)
	{
		//display feedback to the user
		alert(langStrings.invalidCopyProjectSelected);
		selectElem.selectedIndex = 0;
		ResetCopyDocsSelect();
		
		return;
	}
		
	//handle selection of the first/dummy option
	if (selectElem.selectedIndex == 0)
	{
		ResetCopyDocsSelect();		
	}
	
	//clear the field values on the page
	ResetFormFieldValues(false);
	
	if (copyDocProjectID == null || copyDocProjectID.length == 0)
	{
		return;
	}
	
	//write 'Loading...' message OPTION into the target dropdown box until the data is returned by AJAX
	$("#Select_SourceCopyDoc").hide();	// for IE
	$("#Select_SourceCopyDoc").empty();
		
	var loadingOptionHTML = '<option value="">'+langStrings.loading+'</option>';
	$("#Select_SourceCopyDoc").html(loadingOptionHTML);
	$("#Select_SourceCopyDoc").show();
	
	//fetch the Copy Documents (for the appropriate Project) using AJAX
	try {
		ajax({
		url: "GetProjectCreationInfo.jsp?action=ProjectDocuments&projectID=" + copyDocProjectID,
		type: "GET",
		data: "xml",
		debug: false,
		//timeout: 9280000,
		synchronous: false,
		onError: function(status,objHdl, description) 
        {                           
			//window.alert(description);
			if ( description == 'SESSION_EXP')
			{
				uploadAjaxCallSessionExpired();
			}
			else
			{
				window.alert("Unable to load source documents for copying. Server status: "+status);
			}   	 
        },       
		onSuccess: function(xml) 
		{
			//clear the Select_SourceCopyDoc dropdown options list and fill it up again
			$("#Select_SourceCopyDoc").hide();	// for IE
			$("#Select_SourceCopyDoc").empty();
		
			// parse the returning XML string
			var elements=xml.getElementsByTagName("doc_version");
		
			//no Documents were found -> initialize the dropdown select box with a message saying so
			if(elements.length == 0) 
			{
				//create 'No Documents available' dropdown select option
				var noDocumentsOptionHTML = '<option value="">'+langStrings.noDocuments+'</option>'
				$("#Select_SourceCopyDoc").append(noDocumentsOptionHTML);
				
				//disable the 'Copy Document' dropdown select 
				$("#Select_SourceCopyDoc").prop("disabled", true);
				$("#Select_SourceCopyDoc").show();
			} 
			//some documents were found -> fill up the dropdown box with the data
			else 
			{
				//add the first OPTION item
				var pleaseSelectOptionHTML =  '<option value="" selected="selected">'+langStrings.pleaseSelect+'</option>'
				$("#Select_SourceCopyDoc").append(pleaseSelectOptionHTML);
				
				var curDocOptionHTML;
				//now go through the list of returned Documents and add them as an individual OPTION items to the appropriate dropdown box select
				for ( var i = 0  ; i < elements.length ; i++ )
				 {
					var newDocument = elements[i];
					var documentID = newDocument.getAttribute("id");
					//var documentName = WCXML.GetElementText(newDocument, "original_disk_filename", false);
					var documentElem = newDocument.getElementsByTagName("document")[0];
					
					var documentName = WCXML.GetElementText(documentElem, "name", false);
					var documentTypeId = WCXML.GetElementText(newDocument, "doctype_id", false);
					
					//process the name length (shrink it if too long)
					documentName = ProcessSelectBoxItemLabel(documentName, 50);
					
					//create the OPTION html string
					curDocOptionHTML = '<option value="'+documentID+'" doctype_id="'+documentTypeId+'">'+documentName+'</option>';
					
					//...and add it into the appropriate dropdown select element
					$("#Select_SourceCopyDoc").append(curDocOptionHTML);
				}
				
				//enable the dropdown select element
				$("#Select_SourceCopyDoc").prop("disabled", false);
				$("#Select_SourceCopyDoc").show();
			}
		}
		});  // End Ajax code
	} 
	catch (err) 
	{
		alert("Problem in keep session alive: " + err);
	}
}

/*
* Loads and displays (if available) Document Attributes for a selected Template Document 
*/
function LoadTemplateDocumentAttributes(selectBox) 
{
	var documentAttributesDivId = "DocAttributesContainer";	

	var documentId ;
	var attCategoryFound = false;
	var docVersionId = null;
	var categoryId = null;
	var isDocTemplateString ;
	
	if (!gIsCopyDocument)
	{
		documentId = selectBox.value;

		if (documentId == null || documentId.length == 0) 
		{
			$("#" + documentAttributesDivId).empty();
			ToggleDocumentAttributesRow(false);
			gTempDocWithAttributesSelected = false;
			return; // nothin to do at this moment
		}
	}
	
	if (gIsCopyDocument) // when we copy a document, we might have already an att category
	{
		docVersionId  = gDocVersionID ; 
		categoryId = gDocVersionCatID;
		attCategoryFound = true;
		documentId = gDocumentID ; 
		isDocTemplateString = "doctemplate=0";
	}
	else
	{
		isDocTemplateString = "doctemplate=1";
	
		for(var g = 0; g < gTemplateDocumentList.length; g++) 
		{
			if (gTemplateDocumentList[g].id == documentId) 
			{
				categoryId = gTemplateDocumentList[g].categoryid;
				docVersionId = gTemplateDocumentList[g].docverid;
				
				if ((categoryId != null && categoryId.length > 0) && (docVersionId != null && docVersionId.length > 0))
				{
					attCategoryFound = true;
				}
						
				break;
			}
		}
	}
	
	if (attCategoryFound) 
	{
		//mark the flag to specify that the selected Template Doc. has Attributes linked
		gTempDocWithAttributesSelected = true;
	
		var readURL = "GetAttributeCategoryXML.jsp?categoryid=" + categoryId;
		var valuesURL = "GetAttributes.jsp?" + isDocTemplateString + "&projectid=" + gProjectID + "&documentid=" + documentId + "&docverid=" + docVersionId  + "&categoryid=" + categoryId;

		try{
			tinyMceMgrObj.setInitFlag(); // avoid double initialization of rich text boxes
		}catch(err){}

	
		var aCatOptions = new Object();
		aCatOptions.ACatObj = "DocAttributesContainer";
		aCatOptions.ACatPanel = "DocAttributesContainer";
		aCatOptions.readURL = readURL + "&view=Creation";
		//aCatOptions.actionURL = ""; // TODO - what happens on save?
		
		aCatOptions.valuesURL = valuesURL;
		aCatOptions.view = "Creation"; // TODO - agreed, but not yet used
		aCatOptions.prefix = "doc_"; // TODO - still to be adapted on the server
		//aCatOptions.callbackOnLoad=function() {showDocumentAttributes(documentIndex);};
		aCatOptions.type = "document";
		aCatOptions.projectID = gProjectID;
		// document/version IDs not known as this is creation of a new document (from a doc template)
		
		// Load the attribute category asynchronously.
		require(["attributecategory/AttributeCategory", "utils/ObjectArrayCloneUtil"], function (AttributeCategory, ObjectHandler) {
			
			var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
			currentUser.canEditAttributes = true; // TODO (if reused outside project creation)			
			aCatOptions.currentUser = currentUser;
			myACat = new AttributeCategory(aCatOptions);
		});
		
		ToggleDocumentAttributesRow(true);	
		gCurrentCategoryID = categoryId;
	}
	else 
	{
		//mark the flag to specify that the selected Template Doc. doesnt have any Attributes linked
		gTempDocWithAttributesSelected = false;
		
		//hide the 'Doc. Attributes' row
		$("#DocAttributesContainer").empty();
		ToggleDocumentAttributesRow(false);
		gCurrentCategoryID = '';
	}
}

function ResetCopyDocsSelect()
{
	//clear out all the previous OPTION elements
	$("#Select_SourceCopyDoc").empty();

	//create 'Please select document' dropdown select option
	var noDocumentsOptionHTML = '<option value="">'+langStrings.noProjectSelected+'</option>'
	$("#Select_SourceCopyDoc").append(noDocumentsOptionHTML);
				
	//disable the 'Copy Document' dropdown select 
	$("#Select_SourceCopyDoc").prop("disabled", true);
}
/*
* Fetches the available target projects and folders for document uploading
*/
function EnableTargetProjectSelect()
{
	//hide Upload Controls (as the initial state will have no project selected)
	ToggleShowUploadControls(false);
	
	ToggleExtraTemplateDocRow(false);
	ToggleApprovalCycleControls(false);

	var updateSDrop = function(){
		gDestinationSelectSDrop.searchFor('');
		//show the 'dynamic project select' HTML controls
		$("#static_target_project_container").hide();
		$("#ChangeDestinationLinkTD").hide();
		$("#dynamic_target_project_container").show();
		gDestinationSelectSDrop.redraw();
		
		FillUpDynamicTargetProjectFolderSelectControls(false);	
	};
	
	if (gDestinationSelectSDrop == null){
		require(["component/sdrop/SDrop", "component/sdrop/dataproviders/ProjectWithFoldersDataProvider", "jquery"], function(SDrop, ProjectWithFoldersDataProvider, $){
			window.gDestinationSelectSDrop = new SDrop($("#Select_Project"),null, new ProjectWithFoldersDataProvider(),
					{'onChangedByUser': HandleTargetProjectChange.bind($("#Select_Project")[0]), 'manageStyleAndWidth': false,
					 'maxMatches': 50,
					 'initializeDataProvider': false});
			updateSDrop();
		});
	} else {
		updateSDrop();
	}	
}

/*
* Display a 'Target Project and Folder Selector' based on the initial data set upon opening this page
* global variables used: 
*						gHasProjectContext (boolean)
*						gHasProjectFolderContext(boolean)
*						gDestFolderID(String)
*						gDestProjectFolders(Array > keys: folder_id; folder_name) 
*/
function DisplayDestinationProjectFolder()
{
	if (gDestProjectFolders == null || gDestProjectFolders.length == 0 || !gHasProjectContext)
	{
		//there are no folders to select or even no target project selected!!! should not happen
		//just fall back to a non-project context state
		EnableTargetProjectSelect();
		return;
	}
	else
	//project context is available
	{
		//show the pre-selected Project (as a static text)
		if (gProjectID.length > 0 && gInitialProjectName.length > 0)
		{
			$("#dynamic_target_project_container").hide();
			
			//write the Project Name (as a static text)
			$("#static_target_project_container").html(WCXML.xmlencode(ProcessSelectBoxItemLabel(gInitialProjectName, 50)));
			$("#static_target_project_container").show();
		}
		else
		{
			//there are no folders to select or even no target project selected!!! should not happen
			//aw screw it -> just fall back to a non-project context state
			EnableTargetProjectSelect();
			return;
		}
		
		//handle displaying of 'Project Folder Selection' HTML controls 
		if (gDestProjectFolders.length == 1)
		{
			//we only have a single folder in the list --> just display this one (static label - folder name)
			var curFolderName = gDestProjectFolders[0].folder_name;
			
			//set the Folder ID data
			var curFolderID = gDestProjectFolders[0].folder_id;
			
			if (curFolderID != null)
			{
				//check whether its not a ROOT folder
				if (curFolderID == '')
				{
					curFolderID = 'ROOT';
					curFolderName = langStrings.rootProject;
				}
				
				//update the input and JS variable values
				gDestFolderID = curFolderID;
				document.actionform.targetFolderID.value = curFolderID;
			}
			
			$("#static_target_folder_container").html(WCXML.xmlencode(ProcessSelectBoxItemLabel(curFolderName, 50)));
			$("#static_target_folder_container").show();
			$("#dynamic_target_folder_container").hide();
			
			gHasProjectFolderContext = true;
			
			//show the main upload controls
			if (!gUploadControlsShown)
			{
				ToggleShowUploadControls(true);
			}
		}
		else
		if (gDestProjectFolders.length > 1)
		{
			//fill up the 'Destination Folder' dropdown select box with the set of available Project Folders
			var itemSelected = false;
			var folderDropdownHTMLString = '';
			var dummyFolderOptionHTML = "";
			if(document.actionform.uploadType.value === 'single'){
				//prepare the first 'Please Select...' option
				dummyFolderOptionHTML = '<option value=""';
				
				if(!gHasProjectFolderContext)
				{
					//no Folder Context --> preselect the dummy option
					dummyFolderOptionHTML += ' selected="selected"';
					itemSelected = true;
				} 
				dummyFolderOptionHTML += '>'+WCXML.xmlencode(langStrings.pleaseSelect)+'</option>';
			}else{
				dummyFolderOptionHTML = '<option value="DEFAULT"';
				
				dummyFolderOptionHTML += '>'+WCXML.xmlencode(langStrings.documentDefault)+'</option>';
			}
			
			
			
			
			
			folderDropdownHTMLString += dummyFolderOptionHTML;
			
			//now go through all the Project Folders in the list
			var doMakeSelected;
			for (var i = 0; i < gDestProjectFolders.length; i++)
			{
				doMakeSelected = false;
				
				//get folder ID and name for the currently processed Project Folder
				var curFolderID = gDestProjectFolders[i].folder_id;
				var curFolderName = gDestProjectFolders[i].folder_name;
				
				//handle ROOT folder ID value (needs to be set to 'ROOT' for ProjectActionHelper.DoUploadDocuments())
				if (curFolderID == '')
				{	
					curFolderID = 'ROOT';
					curFolderName = langStrings.rootProject;
				}
				
				//set the 'selected' property if the current Folder should be pre-selected
				if (gHasProjectFolderContext && !itemSelected && curFolderID == gDestFolderID)
				{
					doMakeSelected = true;
					itemSelected = true;
				}
				
				//write the <option> HTML for the currently processed Project Folder
				var curFolderOptionHTMLString = '<option value="'+curFolderID+'"';
				
				if (doMakeSelected)
				{
					curFolderOptionHTMLString += ' selected="selected"';
				}
				
				curFolderOptionHTMLString += '>'+ WCXML.xmlencode(ProcessSelectBoxItemLabel(curFolderName, 50)) + '</option>';
				
				//add the prepared <option> HTML String to the final HTML for the appropriate dropdown list
				folderDropdownHTMLString += curFolderOptionHTMLString;
			}
			
			//insert the constructed HTML string into 'Select_Folder' dropdown list
			$("#Select_Folder").html(folderDropdownHTMLString);
		
			$("#static_target_folder_container").hide();
			$("#dynamic_target_folder_container").show();
			
			if (gHasProjectFolderContext && !gUploadControlsShown)
			{
				ToggleShowUploadControls(true);
			}
		}
	}	
}

function LoadProjectFolderApprovalRule()
{
	//reset the approval controls values (always?)
	$("#doApplyDefApprovalSettings").prop("checked", false);
	$("#doStartApprovalCycle").prop("checked", false);
	
	if (gProjectID == "" || !gHasProjectFolderContext)
	{
		ResetApprovalSetup();
		return;
	}
	
	//check whether the current folder/project has Approval Rules defined
	var ajaxURLString = "GetDocUploadInfo.jsp?action=GetApprovalSetupForProject";
	//add Project and Folder params
	ajaxURLString += "&projectID="+gProjectID;
	if (gDestFolderID != null && gDestFolderID.length > 0 && gDestFolderID != "ROOT")
	{
		ajaxURLString += "&folderID="+gDestFolderID;
	}
	
	
	try {
		ajax({
			url: ajaxURLString,
			type: "GET",
			data: "xml",
			debug: false,
			synchronous: false,
			//timeout: 80000,
			onError: function(status,objHdl, description)
			{
				//window.alert(description);
				if ( description == 'SESSION_EXP')
				{
					uploadAjaxCallSessionExpired();
				}
				else
				{
					window.alert("Unable to load the Approval Setup properties for the Destination Project. Server status: "+status);
				}
			},
			onSuccess: function(xml) 
			{	
				//reset the settings for a re-load of a Target Project data
				ResetApprovalSetup();
				
				//JAMI: since 'Document Author' is always permitted to start/stop app. cycle -> just set the flag to true
				gCanStartAppCycle = true;
				
				//JAMI: disable 'Start App. Cycle' checkbox for TEMPLATE update
				if (gIsDestProjIsTemplate)
				{
					gCanStartAppCycle = false;
				}
				
				//retrieve the 'can_start_app_cycle' param value
				var canStartAppCycle = WCXML.GetElementText(xml, "can_start_app_cycle", false);
				
				if (canStartAppCycle == '1'  )
				{
					//the user is allowed to 'Lock/Update/Start Approval/Stop Approval' --> can display the 'Start Approval Cycle' controls
					gCanStartAppCycle = true;		
				}
				else
				{
					//the user is NOT allowed to 'Lock/Update/Start Approval/Stop Approval' --> dont display the 'Start Approval Cycle' controls
					gCanStartAppCycle = false;
				}

				// retreive the 'checkBoxEnabled' value
				var startAppCheckEnabled = WCXML.GetElementText(xml, "approval_restart_enable_checkbox", false);
				if (startAppCheckEnabled == '0'  )
					gStartAppCheckEnabled = false;		
				else
					gStartAppCheckEnabled= true;
				
				var startAppValue = WCXML.GetElementText(xml, "approval_restart_option", false);
				if (startAppValue  == '1') // only when the option is to always restart the approval cycle, the value is 1
					gStartAppDefaultValue = true;
				else
					gStartAppDefaultValue = false;
					
				
				//retrieve the 'can_change_approval' param value
				var canChangeApproval = WCXML.GetElementText(xml, "can_change_approval", false);
				
				if (canChangeApproval == '1')
				{
					//the user is allowed to 'Change Approval' --> can display the 'Approval Due Date' controls
					gCanChangeApproval = true;		
				}
				else
				{
					//the user is NOT allowed to 'Change Approval' --> dont display the 'Approval Due Date' controls
					gCanChangeApproval = false;
				}
				
			
				//retrieve the 'approval_rule_exists' param value
				var approvalRuleExists = WCXML.GetElementText(xml, "approval_rule_exists", false);
				
				var documentSelected = $("#DocDescriptionRow").is(':visible'); // check if document is selected. Description is always visible if document is selected
				
				if (approvalRuleExists == '1')
				{
					//show the 'Approval Cycle' controls
					gHasApprovalSetup = true;
					if (documentSelected)
					{
						// change only needed if selected document
						ToggleApprovalCycleControls(true);
					}
					
				}
				else
				{
					//no approval rules - hide the controls
					gHasApprovalSetup = false;
					if (documentSelected)
					{
						// change only needed if selected document
						ToggleApprovalCycleControls(false);
					}
				}
				
			}//end: AJAX success callback					
		}); // End Ajax code
	} 
	catch (err) 
	{
		alert("Problem in keep session alive: " + err);
	} 
	
}

function LoadProjectAutonaming()
{	
	// clear autonaming settings
	gDocTypeConfigs = new Array();

	//get autonaming settings for target project from the server
	var ajaxURLString = "GetDocUploadInfo.jsp?action=GetAutonamingSettingsForProject";
	//add Project and Folder params
	ajaxURLString += "&projectID="+gProjectID;	
	
	try {
		ajax({
			url: ajaxURLString,
			type: "GET",
			data: "xml",
			debug: false,
			synchronous: false,
			//timeout: 80000,
			onError: function(status,objHdl, description)
			{
				//window.alert(description);
				if ( description == 'SESSION_EXP')
				{
					uploadAjaxCallSessionExpired();
				}
				else
				{
					window.alert("Unable to load the Autonaming Setings for the Destination Project. Server status: "+status);
				}
			},
			onSuccess: function(xml) 
			{	
			
				var err = WCXML.GetElementText(xml, "error", false);
				if (err) alert(err);
				else{
					var systemSettings = xml.getElementsByTagName("system_autoname")[0];
					var projectSettings = xml.getElementsByTagName("project_autoname")[0];
					var systemSettingsMap = new Array();
					
					var sysdoctypes = systemSettings.getElementsByTagName("doctype_autonaming");
					for(i=0 ; i<sysdoctypes.length ; i++){
						var docType = sysdoctypes[i];
						var docTypeID = WCXML.GetElementText(docType, "doctypeid", false);
						systemSettingsMap[docTypeID] = docType;
					}
					
					var doctypes = projectSettings.getElementsByTagName("doctype_autonaming");
					if(doctypes.length>0){
						for(i=0 ; i<doctypes.length ; i++){
							var docType = doctypes[i];
							var docTypeID = WCXML.GetElementText(docType, "doctypeid", false);
							if(!gDocTypeConfigs[docTypeID]){
								var prefix = ""; var suffix = ""; var categoryID = "";
								
								if (WCXML.GetElementText(docType, "autoname_option", false) == "2"){
									var sysDocType = systemSettingsMap[docTypeID];
									prefix = WCXML.GetElementText(sysDocType, "autoname_prefix", false);
									suffix = WCXML.GetElementText(sysDocType, "autoname_suffix", false);
								}else{
									prefix = WCXML.GetElementText(docType, "autoname_prefix", false);
									suffix = WCXML.GetElementText(docType, "autoname_suffix", false);
								}
								var useAutoNaming = (prefix!=null && prefix.length > 0);
								var freeEditField = suffix.toLowerCase().indexOf("[editfield]") !=-1;
								
								if (WCXML.GetElementText(docType, "category_option", false) == "2"){
									var sysDocType = systemSettingsMap[docTypeID];
									categoryID = WCXML.GetElementText(sysDocType, "category_id", false);
								}else{
									categoryID = WCXML.GetElementText(docType, "category_id", false);
								}
								
								gDocTypeConfigs[docTypeID] = createDocTypeSettingsDictionary(prefix, suffix,useAutoNaming,freeEditField,categoryID);
							}	
						}
					}
				}			
			}//end: AJAX success callback					
		}); // End Ajax code
	} 
	catch (err) 
	{
		alert("Problem in keep session alive: " + err);
	} 
	
}

/*
 * Load the project permissions 
 */
function LoadProjectPermissions() {
	gProjectPermissions = {};
	
	if (gProjectID == "") {
		return;
	}
	
	// Get permissions for target project from the server
	var ajaxURLString = "GetDocUploadInfo.jsp?action=GetPermissionsForProject";
	//add Project params
	ajaxURLString += "&projectID="+gProjectID;	
	
	try {
		ajax({
			url: ajaxURLString,
			type: "GET",
			data: "xml",
			debug: false,
			synchronous: false,
			//timeout: 80000,
			onError: function(status,objHdl, description)
			{
				//window.alert(description);
				if ( description == 'SESSION_EXP')
				{
					uploadAjaxCallSessionExpired();
				}
				else
				{
					window.alert("Unable to load the Project Permissions for the Destination Project. Server status: "+status);
				}
			},
			onSuccess: function(xml) 
			{	
			
				var err = WCXML.GetElementText(xml, "error", false);
				if (err) {
					alert(err);
				} else {
					var permissions = xml.getElementsByTagName("permission")[0];
					
					for(var i = 0; i < permissions.childNodes.length; i++) {
						var permName = permissions.childNodes.item(i).nodeName;
						var permValue = WCXML.GetElementText(permissions, permName, false);
						gProjectPermissions[permName] = permValue === "1"? true : false;
					}
				}			
			}//end: AJAX success callback					
		}); // End Ajax code
	} 
	catch (err) 
	{
		alert("Problem in keep session alive: " + err);
	} 
}



function LoadDocumentUploadConfig()
{
	if (gProjectID == "") {
		return;
	}
	
	// Get document upload configuration for target project from the server
	var ajaxURLString = "GetDocUploadInfo.jsp?action=GetDocCreationSetupForProject";
	//add Project params
	ajaxURLString += "&projectID=" + gProjectID;	
	try {
		require([
			"component/smartnames/savedsearchcontext/SavedSearchContextInfo"
            ], 
            function(SavedSearchContextInfo){
				ajax({
					url: ajaxURLString,
					type: "GET",
					data: "xml",
					debug: false,
					synchronous: false,
					//timeout: 80000,
					onError: function(status, objHdl, description)
					{
						//window.alert(description);
						if ( description == 'SESSION_EXP')
						{
							uploadAjaxCallSessionExpired();
						}
						else
						{
							window.alert("Unable to load the Document Upload Configuration for the Destination Project. Server status: "+status);
						}
					},
					onSuccess: function(xml) 
					{	
						var err = WCXML.GetElementText(xml, "error", false);
						if (err) {
							alert(err);
						} else {
							// Get the document creation setup and inject it to generated HTML (still XML encoded)
							var docCreationSetupXmlNodes = xml.getElementsByTagName("doccreation_setup_xml");
							if (docCreationSetupXmlNodes && docCreationSetupXmlNodes.length > 0) {
								$("#documentSourcesTextArea").val(WCXML.GetElementSelfTextContent(docCreationSetupXmlNodes[0]) );							
							}
							
						}
						
						// read and initialize document upload configuration for given project ('gProjectID')
						// for proper function the global 'i18nDocUConfLangArr' language array must exist
						var prefix = 'AddNewDocuments';
						var savedSearchContextInfo = new SavedSearchContextInfo();
						savedSearchContextInfo.setProjectId(gProjectID);
						var textAreaId = 'documentSourcesTextArea';
						var docSourceHiddenDivId = 'documentSourcesHiddenDiv';
						var linksId = 'AddDocumentGreenLinkTd';
						var section = 'Upload';
						var hasDocumentTemplates = false;
						var hasBillOfMaterials = false;
						var projectId = gProjectID;
						
						var docTableDiv = 'documentsTableContainerDiv';
						var docTableHiddenDiv = 'documentsTableHiddenDiv';
						
						
						initDocTableX(textAreaId, docTableDiv, docSourceHiddenDivId, docTableHiddenDiv, linksId, section, prefix, i18nDocUConfLangArr, hasDocumentTemplates, hasBillOfMaterials, savedSearchContextInfo, projectId);	
						 
					}//end: AJAX success callback					
				}); // End Ajax code
		});// end require
	} 
	catch (err) 
	{
		alert("Problem in function LoadDocumentUploadConfig(): " + err);
	} 
	
}

function initDocTableX(textAreaId, docTableDiv, docSourceHiddenDivId, docTableHiddenDiv, linksId, section, prefix, langArr, hasDocumentTemplates, hasBillOfMaterials, savedSearchContextInfo, projectId, isProjectCreationCtx, sourceDocsInfo, targetFolders) {
	require([        "doctablex/DocTableXFactory",
	                 "doctablex/DocTableXUtils",
	                 "doctablex/DocTableXRenderConfig",
	                 "attributecategory/DocumentSourceHandler"
	                 ], 
	                 function(DocTableXFactory, DocTableXUtils, DocTableXRenderConfig, DocumentSourceHandler){
		
		var docSourceXML = $('#'+ textAreaId).val();
		var dsh = new DocumentSourceHandler({
			docSourceXML : docSourceXML,
			docSourceTableId : docSourceHiddenDivId,
			langArr: langArr,
			functionPrefix : 'javascript:document.getElementById(\'' + docSourceHiddenDivId + '\').dshObj',
			textClass : '',
			//updateCallBack : functionName.bind(context [, args]),
			prefix: '',
			linksId : linksId,
			showSections: false,
			currentLanguage: gCurrentUser.lang,  // language code of the current userAgent
			section: section,
			hasBillOfMaterials: (hasBillOfMaterials===false) ? false : true,
			savedSearchContextInfo: savedSearchContextInfo,
            projectId: projectId
		});
		
		if (!docSourceXML) {
			dsh.setWebCenterDefault(section);
		}
		
		// rendering configuration
		// -----------------------
		// create the documents table rendering configuration object for Project creation page
		var docTableRenderConfigObj = new DocTableXRenderConfig({
			defaultName : 'Custom Rendering Configuration',
			section : section,
			phElemID : docTableHiddenDiv,
			configObj : null   // default configuration will be generated
		});

		var docRenderConfigXML = $('#DocRenderConfigXML').val();
		if (docRenderConfigXML) {
			// load the rendering configuration from provided XML (if any)
			docTableRenderConfigObj.readFromXMLString(docRenderConfigXML);
		}


		// get the configuration itself
		var docTableRenderOptions = docTableRenderConfigObj.getConfigObj();
        docTableRenderOptions.showThumbnails = true;
		docTableRenderOptions.renderMethod = 'table';
        docTableRenderOptions.showGreenLinksOnTop = true;
        docTableRenderOptions.showGreenLinksAtBottom = false;
        
        /*
         * The render configurations modified here to have rendering similar to previous used DocumentsTable
         * for the project creation from documents through search results
         */
        if(sourceDocsInfo && (sourceDocsInfo.length > 0) && docTableRenderOptions.columns && (docTableRenderOptions.columns.length > 0)) {
        	// run the loop in reverse so it doesn't have wrong information after splice operation to remove an object
        	for(var i=docTableRenderOptions.columns.length-1 ; i>0; i--) {
        		var option = docTableRenderOptions.columns[i];
        		if(((option.type === "DocumentProperty") && (option.typeDetail === "VersionRevision")) || (option.type === "DocumentActions")) {
        			docTableRenderOptions.columns.splice(i, 1);
        		}
        	}
        }
        
        // documents table
		// ---------------
	    docTablePromise = DocTableXFactory.createDocTableX({
	        dshObj : dsh,   // link between DocTableX and DocumentSourceHandler objects
	        prefix : prefix,   // main prefix to be used by this DocTableX instance
	        phElemID : docTableDiv,   // HTML element ID, where this doc table will be put
	        // aCatView : this.taskTypeName,   // this is the only supported view (in context of TEP)
	        saveXMLRootTag : 'drs',
	        // onChangeCallback : function() {this.setModified(true);}.bind(this),
	        autoExpandAllRows : true,
	        currentUser : gCurrentUser,
	        isEditable : true,
	        allowMultiple : true,
	        showGreenLinksOnTop : true,   // specific for document reference attributes. normal upload has the "green links" only at the bottom
	        projectID : gProjectID,
            projectCreationContext: isProjectCreationCtx,
	        renderOptions : docTableRenderOptions,
	        targetFolders: targetFolders
	    });

		
	    docTablePromise.then(function(docTableObj){
	    	window.docTableObj = docTableObj;
	    	try {
		    	// Now more dedicated click methods for the advanced use cases
				dsh.setAdvancedClickMethods(section, docTableObj.thisInDOM);
				
				// If some documents are preselected to add documents during project creation
				// like selecting documents from search results and create project
				if(sourceDocsInfo && sourceDocsInfo.length > 0) {
					docTableObj.addSearchDocRows(sourceDocsInfo, false).then(function() {
						this.dataLoadingFinished();
						this.displayTable();
					}.bind(docTableObj))
					.catch(function() {
						this.dataLoadingFailed();
					}.bind(docTableObj));
				} else {
					docTableObj.dataLoadingFinished();
					docTableObj.displayTable();
				}
	    	} catch (ex) {
	    		if (docTableObj) {
	    			docTableObj.dataLoadingFailed();
	    		}
	    	}
	    });
	});
}


/*
* Fills up the dropdown boxes for available target projects and folders
*/
function FillUpDynamicTargetProjectFolderSelectControls(processFoldersOnly)
{
		
		///////////////////////////
		// TARGET FOLDER HANDLING//
		///////////////////////////
		
		//if there in no 'Project Context' (target Project not yet/again selected) -> just write 'Please Select...' label and disable the 'Target Folder' select box
		if (!gHasProjectContext)
		{
			//insert a dummy 'Please Select...' option
			var dummyFolderOptionHTML = '<option value="">'+WCXML.xmlencode(langStrings.pleaseSelect)+'</option>';
			$("#Select_Folder").html(dummyFolderOptionHTML);
			
			//...and disable the whole dd list control -> invalid until a Project has been selected
			$("#Select_Folder").prop("disabled", true);
			
			//show the 'dynamic folder select' controls
			$("#static_target_folder_container").hide();
			$("#dynamic_target_folder_container").show();
			
			//update the Destination Folder values
			SetCurrentProjectFolderIDFormValue();
		}
		//Project Context is set --> prepare Target Folder selection
		else
		{
			//enable the control as the controls is valid when having a selected Project
			$("#Select_Folder").prop("disabled", false);
			
			var targetFolderDropdownOptionsHTML = "";
			
			//check whether we have a 'Folder Context'
			var hasFolderContext = false;
			alreadySelected = false;
			
			if (((gDestFolderID != null && gDestFolderID.length > 0) || gHasProjectFolderContext) && !processFoldersOnly)
			{
				hasFolderContext = true;
			}
			
			//get the folders list for the currently selected project
			//selectedProjectID = gProjectID;
			var projectData = gDestinationSelectSDrop.dataProvider.getById(gProjectID);
			var projFoldersList = null;

			if (projectData != null){
				projFoldersList = projectData.folders;
			}
			
			if (projFoldersList != null && projFoldersList.length > 0)
			{
				var curFolderID, curFolderName;
				var curFolderOptionHTML = "";
				
				//only one Target Folder is available --> static string
				if (projFoldersList.length == 1)
				{
					//get the only folder name and id
					curFolderID = projFoldersList[0].id;
					curFolderName = projFoldersList[0].name;
					
					
					if (curFolderID != null)
					{
						//check whether its not a ROOT folder
						if (curFolderID == '')
						{
							curFolderID = 'ROOT';
							curFolderName = langStrings.rootProject;
						}
						
						//update the input and JS variable values
						gHasProjectFolderContext = true;
						gDestFolderID = curFolderID;
						document.actionform.targetFolderID.value = curFolderID;
					}
					
					$("#static_target_folder_container").html(WCXML.xmlencode(ProcessSelectBoxItemLabel(curFolderName, 50)));
					$("#static_target_folder_container").show();
					$("#dynamic_target_folder_container").hide();
					
					LoadProjectFolderApprovalRule();
					
					//show the main upload controls
					if (!gUploadControlsShown)
					{
						ToggleShowUploadControls(true);
					}
				}
				else
				//multiple folders are available --> display dropdown select with the avaialble Target Folders as options
				{
					//write out a dummy 'Please Select...' option
					curFolderOptionHTML = '<option value=""';
					
					//no Folder Context is set at this moment --> pre-select the dummy value
					if (!hasFolderContext)
					{
						curFolderOptionHTML += ' selected="selected">';
						alreadySelected = true;
					}	
					
					curFolderOptionHTML += WCXML.xmlencode(langStrings.pleaseSelect)+'</option>';
					
					//append the current <option> HTML to the final string
					targetFolderDropdownOptionsHTML += curFolderOptionHTML;
					
		
					//now go process the list of folders individually
					i = 0;
					for (i; i < projFoldersList.length; i++)
					{
						keepSelected = false;
		
						curFolderID = projFoldersList[i].id;
						curFolderName = projFoldersList[i].name;
					
						//set 'ROOT' value if the current folder has blank ID 
						if (curFolderID == "")
						{
							curFolderID = "ROOT";
							curFolderName = langStrings.rootProject;
						}
					
					//make sure the folder name isnt too long
					curFolderName = ProcessSelectBoxItemLabel(curFolderName, 50);
			
					//check whether the currently processed Target Project Folder <option> should be selected
					if (!alreadySelected && hasFolderContext && curFolderID == gDestFolderID)
					{
						keepSelected = true;
						alreadySelected = true;
					}
			
					//create an <option> html string for this Target Folder
					curFolderOptionHTML = '<option value="'+curFolderID+'"';
			
					//add 'selected attribute' if needed
					if (keepSelected)
					{
						curFolderOptionHTML += ' selected="selected"';
					}
			
					curFolderOptionHTML += '>'+WCXML.xmlencode(curFolderName)+'</option>';
			
					//append the current <option> HTML to the final string
					targetFolderDropdownOptionsHTML += curFolderOptionHTML;
				}
				
				//add the final HTML with the <option> element to 'Select_Folder' dropdown box (contained in addnewdocument.xsl)
				$("#Select_Folder").html(targetFolderDropdownOptionsHTML);
				
				//show 'dynamic folder select'HTML controls
				$("#static_target_folder_container").hide();
				$("#dynamic_target_folder_container").show();
			
				//set the value of the hidden field
				SetCurrentProjectFolderIDFormValue();
			}
		}
	}	 
}


//handle 'Template Document selected' event
function ProcessSelectedTemplateDoc(elem, useAsTargetDoc, counter)
{	
	var template = $('#Select_Template_Document').val();
	if((template != null && template != '') || useAsTargetDoc){
		//handle document type details
		if (useAsTargetDoc)
		{
			ProcessDocMimeType(elem, true);
		}
		
		//set the index of the selected option in the other dd list
		SetTemplateDocSelOptionIndex(elem);
		
		//handle Doc. Attributes when selecting a Template Document
		LoadTemplateDocumentAttributes(elem);
	}else{
		// if no template is selected, reset to the default attributes (doctype category)
		var getText = false;
		var docElemID = "";
		var selector = "";
		if (!isNaN(counter)){
			//selector = "documentType" + counter;
			//selectorVal = $(selector).val();
			docElemID = "documentFileNameId" + counter;
		}else{
			selector = "#Select_Source_Type";
			selectorVal = $(selector).val();
			if(selectorVal){
				if (selectorVal.toLowerCase() == "doc_source_browse"){
					docElemID = "docFileInput";
				}else if (selectorVal.toLowerCase() == "doc_source_copy"){
					docElemID = "Select_SourceCopyDoc";
					getText = true;
				}else if (selectorVal.toLowerCase() == "doc_source_component"){
					docElemID = "Doc_Name";
					getText = false;
				}
			}
		}
		
		var docElem = document.getElementById(docElemID);
		// load the attributes as if there were no templates
		if (docElem) ProcessDocMimeType(docElem, getText, true);
	}
}

/**
* Copies the selected index of one of the 'Template Document Selector' dd list items to have them share their state
**/
function SetTemplateDocSelOptionIndex(elem)
{
	if (elem)
	{
		var elemID = elem.id;
		var elemSelIndex = elem.selectedIndex;
		
		if (elemSelIndex > -1)
		{
			//see what SELECT object will need to get modified;
			if (elemID == "Select_SourceNewDoc")
			{
				$("#Select_Template_Document").prop("selectedIndex", elemSelIndex);
			}
			else
			if (elemID == "Select_Template_Document")
			{
				$("#Select_SourceNewDoc").prop("selectedIndex", elemSelIndex);
			}
		}
	}
	
}

function ResetTemplateDocSelectors()
{
	//set both the SELECT object's selectedIndex to 0 --> reset their state
	$("#Select_Template_Document").prop("selectedIndex", 0);
	$("#Select_SourceNewDoc").prop("selectedIndex", 0);
	
	gTempDocWithAttributesSelected = false;
}

/*
* Shows the only the 'Static Project Context' row - the 'Dynamic Project Selector' row is hidden
*/
/*function ShowProjectContextInfo()
{
	//hide all table rows except the 'Static Destination Project Context' one
	$(DestinationSelectRowow").hide();
	$("#DestinationSelectLoadingRow td").empty();
	$("#DestinationSelectLoadingRow").hide();
	$("#StaticDestinationSelectRow").show();
	//show action buttons
	$(".ActionButtonsRow").show();  	
} */

/*
* Shows/hides the appropriate 'Doc. Upload Type' form fields (MultiDocUpload VS SingleDocUpload) 
*/    
function SwitchDocUploadType(){
	var uploadTypeVal = document.actionform.uploadType.value;
      
	if (uploadTypeVal == "single"){
		if (HaveFormFieldValues()){
			OpenProjectChangePopup(true);
		} else {
			//hide the the 'Single Doc. Upload' row
			toggleDocUploadDetailsRow(false, 'SingleDocUploadFieldsRow');
  
			//show the 'Multi Doc. Upload' row
			toggleDocUploadDetailsRow(true, 'MultiDocUploadFieldsRow');
	  		
			//remove the link to switch 'doc upload type' -> one direction switch only (single to multi)
			$("#doc_upload_type_switch_td").hide();
	  	
			//hide the 'Doc. Attributes' row, as it is irrelevant for 'MultiDocUpload'
			ToggleDocumentAttributesRow(false);
	  		
			//hide the 'extra doc template selector' row as it irrelevant for multidoc upload mode
			ToggleExtraTemplateDocRow(false);
  		
			//change the 'doc upload type' indicator
			document.actionform.uploadType.value = 'multi';
	  	
			// Show upload button
			$("#UploadButton").show();
			$("#UploadButtonSpacer").show();
			
			// Set the selection to the default options
			var option = $($("#Select_Folder")[0][0]);
			document.actionform.targetFolderID.value ="DEFAULT"; 
			//change the selector overwrite the please select with the  default 
			option.val("DEFAULT");
			option.text(langStrings.documentDefault);
			
			$("#Select_Folder").val("DEFAULT");
			
		}
	} else {
		// there is currently no way in GUI how to go back from multiple upload to single upload
	}
	
	// set the documents table to the initial state
	resetDocumentsTable();
}

/*
* Shows/hides the appropriate 'Doc. Upload Type' form fields (MultiDocUpload VS SingleDocUpload) 
* What will be shown/hidden is based on the current flag (actionform.uploadType) value
*/     
function ShowCurrentDocUploadType()
{
	var uploadTypeVal = document.actionform.uploadType.value;
      
    if (uploadTypeVal == "single")
    {	
    	//hide the 'Multi Doc. Upload' row
     	toggleDocUploadDetailsRow(false, "MultiDocUploadFieldsRow");
      
	    //show the the 'Single Doc. Upload' row
    	toggleDocUploadDetailsRow(true, "SingleDocUploadFieldsRow");
    }  	
    else
    {
    	//hide the the 'Single Doc. Upload' row
    	toggleDocUploadDetailsRow(false, 'SingleDocUploadFieldsRow');
      
    	//show the 'Multi Doc. Upload' row
    	toggleDocUploadDetailsRow(true, 'MultiDocUploadFieldsRow');
    }
}

function ToggleShowUploadControls(show)
{
	if (!show)
	{
		//reset global variables
		gHasTemplateDocuments = false;
		gHasApprovalSetup = false;
		gTempDocWithAttributesSelected = false;
						
		//hide the 'Multi Doc. Upload' row
     	toggleDocUploadDetailsRow(false, "MultiDocUploadFieldsRow");
      
	    //hide the the 'Single Doc. Upload' row
    	toggleDocUploadDetailsRow(false, "SingleDocUploadFieldsRow");
   		$("#single_doc_divider_row").hide();
  		$("#single_doc_spacer_row").hide();	
  		
  		//hide action buttons
		$(".ActionButtonsRow").show();
		$("#UploadButton").hide();
		$("#headerButtonSecondary").hide();
		$("#headerButtonPrimary").hide();
    	
    	//hide approval cycle controls
    	ToggleApprovalCycleControls(false);
    	
    	//hide show Doc. Attribute value row
    	ToggleDocumentAttributesRow(false);
    	
    	//hide Doc. Name Row
    	ToggleDocNameRow(false);
    	
    	//hide Doc. Type Label Row
    	ToggleDocTypeLabelRow(false);
    	
    	//hide Template Doc. Select Row
    	ToggleExtraTemplateDocRow(false);
    	
    	gUploadControlsShown = false;
	}
	else
	{
		ShowCurrentDocUploadType();
		
		//show action buttons
		$(".ActionButtonsRow").show(); 
		$("#headerButtonSecondary").show();
		$("#headerButtonPrimary").show();
    	
		
		if(gCopyFromSDrop)gCopyFromSDrop.redraw();
		
    	gUploadControlsShown = true;
	}
}


function toggleDocUploadDetailsRow(toggleFlag, rowElemID)
{
	var elemID = '.' + rowElemID;
      
    if (toggleFlag)
    {
    	HideAllExtraDetails();
    	
    	//for Single Doc Upload Fields - also show the divider and spacer row
    	if (rowElemID == "SingleDocUploadFieldsRow")
    	{
    		$("#single_doc_divider_row").show();
    		$("#single_doc_spacer_row").show();
    	}
    	else
    	{
    		// Show upload button			
    		$("#single_doc_divider_row").hide();
    		$("#single_doc_spacer_row").hide();	
    		$('#headerButtonPrimary').addClass("hidden");
    		$('#UploadButton').show();
    	}
    	
    	// show documents table
    	$(elemID).show();
    	if (window.docTableObj) {
    		docTableObj.displayTable();
    	}
    	
		ToggleGeneralDocTypeDetails(false);
    }
    else
    {
    	$(elemID).hide();
    }    	
}




/**
** Fills up the 'Document Name' form field with the filename of the selected Document
**/
function PrefillDocName(fileName)
{

	//get the 'Document Name' field element reference
	var docNameInput = $("#Doc_Name");

	//check whether we're not handling URL, Prodcut or Copy upload (in that case no value processing needs to be done)
	var curValue = $("#Select_Source_Type").val();
	if (curValue == "doc_source_component" || curValue == "doc_source_url" || curValue == "doc_source_copy")
	{
		//just copy the value over (if a real value was entered)
		if (fileName != null && fileName.length > 0)
		{
			//alert("Document Name field value - " + docNameInput.val());
			docNameInput.val(fileName);
		}
	}
	else
	//only fill up the field if the new value isnt the same as the current one and the new one isnt blank
	if (fileName != "" && docNameInput.val() != fileName) 
	{
	  if (fileName.lastIndexOf("\\") != -1)
	    fileName = fileName.substring(fileName.lastIndexOf("\\") + 1);
	  else if (fileName.lastIndexOf(":") != -1)
	    fileName = fileName.substring(fileName.lastIndexOf(":") + 1);
	  else if (fileName.lastIndexOf("/") != -1)
	    fileName = fileName.substring(fileName.lastIndexOf("/") + 1);
	  if (fileName.length > 0)
		docNameInput.val(fileName);
	}

}

/*
* Reads the file name and handles displaying of specific document-type details upon selecting a new document
*/
function ProcessDocMimeType(inputElem, getText, skipTemplate)
{	
	if (inputElem)
	{
		//get the currently selected document file name
		var fileName;
		var docTypeId;
		var isRealValue = true;
		
		if (!getText)
		{
			fileName = inputElem.value;
		}
		else
		{
			fileName = inputElem.options[inputElem.selectedIndex].text;
			isRealValue = inputElem.options[inputElem.selectedIndex].value != null && inputElem.options[inputElem.selectedIndex].value != "";
			// Get the docTypeId, necesarry for example in the case when we have to distinguish between CHILI ZIP files and normal ZIP files
			docTypeId = inputElem.options[inputElem.selectedIndex].getAttribute("doctype_id");
		}
		
		var sourceValue = $("#Select_Source_Type").val();

		//check ID of the input element -> to see whether we're not processing URL textfield (needs special handling)
		var isURLField = false;
		if (inputElem.id == 'Input_SourceURLDoc')
		{
			isURLField = true;
		}
			
		//get the MIME type (file exentsion)
		var mimeType; 
		
		if (fileName != null && fileName != "")
		{
			mimeType = fileName.substr(fileName.lastIndexOf('.')).toUpperCase();
			
			//WCR-20113: SAHI spotted a reset in the Source Project>Source Document sDrops when selecting a Source Document. 
			//Not effective when triggering manually, though.
			var sourceCopyDocSelected = inputElem.id == "Select_SourceCopyDoc";
			ToggleGeneralDocTypeDetails(true, sourceCopyDocSelected);
		}
			
		//fill the 'Document Name' field
		PrefillDocName(fileName);
		
		//Show/hide Document Approval Cycle controls
		if (gHasApprovalSetup)
		{
			ToggleApprovalCycleControls(true);
		}
		else
		{
			ToggleApprovalCycleControls(false);
		}
		
		if (mimeType != null && mimeType != "" && !isURLField && isRealValue)
		{
			HideAllExtraDetails();
			var isCurFileExtGraphic = IsGraphicalExtension(mimeType);
				
			//check for supported MIME types
			//GRAPHIC DOCUMENT
			if 
			(gIsGraphicsDocEnabled && isCurFileExtGraphic && mimeType != ".ZIP" && mimeType != ".PDF")
			{
				ChangeDocTypeLabel(0);
				
				SetDocTypeParamValue("graphic");
			}
			else
			//PDF - Graphic Document / MultiPage PDF Document
			if (mimeType == ".PDF" && ( ( gIsGraphicsDocEnabled &&  isCurFileExtGraphic ) || gIsPageListDocEnabled ) )
			{
				//ChangeDocTypeLabel(0);
				//show dropdown box for PDF document (can stand for three different document types, so the user should pick his desired one)
				ShowPDFDocTypeOption(true);
			}
			else
			//ZIP FILE
			if (mimeType == ".ZIP" && gIsChiliDocEnabled && docTypeId==gChiliDocTypeID) {
					
				ChangeDocTypeLabel(8);
				SetDocTypeParamValue("chili");
			}
			else 
			if ( mimeType == ".ZIP" && ( ( gIsGraphicsDocEnabled && isCurFileExtGraphic ) || gIsOtherDocTypeEnabled ))
			{
				//ChangeDocTypeLabel(5);
				
				//show the additional details rows
				//ToggleZipFileDetailsRow(true);
				
				//show dropdown box for ZIP document (can stand for three different document types, so the user should pick his desired one)
				ShowZipDocTypeOption(true);
			}
			else
			//ARTIOS CAD DESIGN DOCUMENT
			if (IsArtiosCADDocument(mimeType))
			{
				ChangeDocTypeLabel(2);
				
				SetDocTypeParamValue("artioscad");
			}
			else
			//CAPE DOCUMENT
			if (mimeType == ".CLF" && gIsCapeDocEnabled)
			{
				ChangeDocTypeLabel(3);
					
				//show the additional details rows
				ToggleCapeDocDetailsRow(true);
				
				SetDocTypeParamValue("cape");
			}
			else
			//ZIPPED CAPE DOCUMENT
			if (mimeType == ".ZCP" && gIsCapeDocEnabled)
			{
				ChangeDocTypeLabel(3);
				
				SetDocTypeParamValue("cape");
			}
			else
			//ZIPPED COLLADA DOCUMENT
			if (mimeType == ".ZAE" && gIsZippedColladaDocEnabled)
			{
				ChangeDocTypeLabel(6);
									
				SetDocTypeParamValue("zippedcollada");
			}
			else
			//COLLADA DOCUMENT
			if (mimeType == ".DAE" && gIsColladaDocEnabled)
			{
				ChangeDocTypeLabel(7);
									
				SetDocTypeParamValue("collada");
			}
			else
			//CHILI DOCUMENT
			if (mimeType == ".CHP" && gIsChiliDocEnabled) {
				
				ChangeDocTypeLabel(8);
				
				SetDocTypeParamValue("chili");
			}
			else
			//TEXT CONTENT DOCUMENT
			if ((mimeType == ".WCC" || mimeType == ".WTC") && gIsTextContentDocEnabled && window.webcenterConfig.isPCMEnabled) {
					ChangeDocTypeLabel(9);
				
					SetDocTypeParamValue("Text Content");
			}
			else
			// self definied document type
			if (isKnownDocType(mimeType))
			{
				// get document type
				var docType = getKnownDocType(mimeType);
				// set the label and set the doctypeID 
				document.actionform.selectedDocType.value = docType[0] ;
				setDocTypeLabel(docType[2]);
				
			}
			else			
			//OTHER DOCUMENT
			if (gIsOtherDocTypeEnabled)
			{
				ChangeDocTypeLabel(4);
				
				SetDocTypeParamValue("other");
			}
			else
			//UNKNOWN DOCUMENT TYPE -> let the User know that he cannot upload such a file
			{
				//inform the user that the selected document is not supported
				alert(langStrings.unsupportedDocumentType);
				
				//reset the form fields
				ResetFormFieldValues();
			}
			
				ProcessDocType(mimeType); // this function will hide the doc name field when autonaming is turned on
		}else if(!isRealValue){
			//nothing selected, reset the form fields
			ResetFormFieldValues();
		}
		//special processing for URL field (can only be 'OTHER')
		else if (sourceValue == "doc_source_url")
		{
			ChangeDocTypeLabel(4);
				
			SetDocTypeParamValue("other");
			
			//hid the approval cycle controls as its invalid for URL doc. upload
			ToggleApprovalCycleControls(false);
			
			//also hide Document Name row as its invalid for URL doc. upload
			ToggleDocNameRow(false);
		}
		//special processing for Component field (can only be 'COMPONENT')
		else if (sourceValue == "doc_source_component")
		{
			ChangeDocTypeLabel(10);
				
			SetDocTypeParamValue("component");

			ProcessDocType(null, gComponentDocTypeID); // this function will hide the doc name field when autonaming is turned on
		}
		else
		{
			//inform the user that the selected document is not supported
			alert(langStrings.unsupportedDocumentType);
				
			//reset the form fields
			ResetFormFieldValues();
		}
		
		if(skipTemplate != true){
			//auto-select document template
			var curUploadSourceTypeValue = $("#Select_Source_Type").val();
			if (curUploadSourceTypeValue != 'doc_source_new')
				autoSelectTemplateDocument(fileName, '#Select_Template_Document');	
		}
	}
}

// Process the selected doc type (autoname option, default category id)
function getDocTypeID(ext)
{
	// get the mime type and convert it to the doc type ID 
	var docType = document.actionform.selectedDocType.value ;
	
	var docTypeId = gOtherDocTypeID ; // other doc type 
	
	
	// determine the doc type id, then check the config options 
	if (docType == null )
	{
	 // do nothing
	}
	else if (docType == 'artioscad'  ) // oh, check the extension and determine the design sub-type
	{
		if ( ext.toLowerCase() == '.a3d'  ) 
		{
			docTypeId = gCAD3DDocTypeID ;
		}
		else if (ext.toLowerCase() == '.acd')
		{
			docTypeId = gCADCanvasDocTypeID;
		}
		else if (ext.toLowerCase() == '.mfg')
		{
			docTypeId = gCADManufacturingID;
		}
		else 
		{
			docTypeId = gCADDesignDocTypeID;
		}
	}
	else if (docType == 'cape' ) // cape 
	{
		docTypeId = gCapeDocDocTypeID;
	}
	else if ( docType == 'collada' ) // collade DAE type 
	{
		docTypeId = gColladaDocTypeID;
	}
	else if ( docType == 'zippedcollada' ) // zipped collada file 
	{
		docTypeId = gZippedColladaDocTypeID;
	}
	else if (docType == 'pagelist'  ) // page list 
	{
		docTypeId = gPageListDocTypeID;
	}
	else if (docType == 'graphic'  ) // graphic
	{
		docTypeId = gGraphicsDocTypeID;
	}
	else if (docType == 'chili'  ) // graphic
	{
		docTypeId = gChiliDocTypeID;
	}
	else if (docType == 'Text Content'  ) // Text Content
	{
		docTypeId = gTextContentDocTypeID;
	}
	else if (docType.indexOf('00002_0000000') > -1 ) // user defined 
	{
		docTypeId = docType; // the doc type id is already in teh docType
	} 
	return docTypeId ;
}


// Process the selected doc type (autoname option, default category id)
function ProcessDocType(ext, doctype)
{
 	 var docTypeId;
 	 
 	 if (doctype)
 		docTypeId = doctype;
 	 else
 		docTypeId = getDocTypeID(ext);

	 // we have the doc type, now look up the doc type settings 
	 var docTypeSettings = gDocTypeConfigs[docTypeId];
	 var curValue = $("#Select_Source_Type").val();
	 if (docTypeSettings!=null)
	 {
	 	checkAutoNameOption(docTypeSettings['Autoname On'], docTypeSettings['Autoname Edit Field'] );
	 	checkCategoryID(docTypeSettings['categoryID']);
	 } 	
	
}

// show the category id (header view)
function checkCategoryID(categoryID)
{
// alert('checkCategoryID ' + categoryID);

	// there is a loop when selecting a document and keeping the focus on the doc selection box. On each keydown, this function is called.
	// when it's a copy, reload the new values anyway
	if (gCurrentCategoryID == categoryID && $("#Select_Source_Type").val() != "doc_source_copy") 
		return ; 
		
	gCurrentCategoryID = categoryID;
	

	if (categoryID!=null && categoryID.length>0) 
	{
		//mark the flag to specify that the selected Template Doc. has Attributes linked
		gTempDocWithAttributesSelected = true;
	
		var readURL = "GetAttributeCategoryXML.jsp?categoryid=" + categoryID;
		var valuesURL = "GetAttributes.jsp?categoryid=" + categoryID;
		
		if($("#Select_Source_Type").val() == "doc_source_copy"){
			var copydoc = $("#Select_SourceCopyDoc").val();
			if(copydoc) valuesURL += "&docverid="+copydoc;
		}

	
		var aCatOptions = new Object();
		aCatOptions.ACatObj = "DocAttributesContainer";
		aCatOptions.ACatPanel = "DocAttributesContainer";
		aCatOptions.readURL = readURL;
		//aCatOptions.actionURL = ""; // TODO - what happens on save?
		aCatOptions.valuesURL = valuesURL;
		aCatOptions.view = "Creation"; // TODO - agreed, but not yet used
		aCatOptions.loadViewOnly = true;
		aCatOptions.prefix = "doc_"; // TODO - still to be adapted on the server
		//aCatOptions.callbackOnLoad=function() {showDocumentAttributes(documentIndex);};
		aCatOptions.type = "document";
		aCatOptions.projectID = gProjectID;  
		
		// Load the attribute category asynchronously.
		require(["attributecategory/AttributeCategory", "utils/ObjectArrayCloneUtil"], function (AttributeCategory, ObjectHandler) {
			
			var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
			currentUser.canEditAttributes = true; // TODO (if reused outside project creation)			
			aCatOptions.currentUser = currentUser;
			myACat = new AttributeCategory(aCatOptions);
		});
		
		ToggleDocumentAttributesRow(true);	
	}
	else 
	{
		// there is a jQuery issue where jQuery's .empty() does not work properly
		// all JS elements must be removed manually
		var docACatObj = $("#DocAttributesContainer")[0];
		if(docACatObj && docACatObj.ACatObj){
			docACatObj.ACatObj.destroy();
			docACatObj.ACatObj = null;
		}
		$("#DocAttributesContainer").empty();
		ToggleDocumentAttributesRow(false);
	}
	
}
		

// function that determines the visibility of the doc name GUI controls 
function checkAutoNameOption(useAutoName, hasFreeEditablePart)
{
	if ((!useAutoName) || hasFreeEditablePart) // only when no autoname option is used, or when there is a free-editable part, show the doc name field
	{
		if(!useAutoName){
			// name label
			ToggleDocNameRow(true, false);
		}else{
			// namesuffix label
			ToggleDocNameRow(true, true);
		}
	}
	else
	{
		ToggleDocNameRow(false);		
	}
}



// check whether this is a known document type
function isKnownDocType(ext)
{
	if (ext == null)
		return false; 

	// check the list with the upload hints
	var docTypeID = getKnownDocType(ext);
	if (docTypeID!=null)
		return true;
	else
		return false; 	
	
}

function getKnownDocType(ext)
{
	if (ext == null)
		return null ; 

	// check the list with the upload hints
	for (var i = 0; i < gknownExtList.length; i++ ) 
	{
		var docType = gknownExtList[i] ;
		if ( docType[1]!= null ) 
		{
			if ( docType[1].toLowerCase() == ext.toLowerCase() ) 
			{
				return docType;
			}
		} 
	}	
	return null ; // not known
}


function IsArtiosCADDocument(ext)
{
	var result = false;
	
	if (gArtiosCADFileExtList != null && gArtiosCADFileExtList.length > 0)
	{
		var curFileExt;
		for (var i = 0; i < gArtiosCADFileExtList.length; i++)
		{
			curFileExt = gArtiosCADFileExtList[i];
				
			//compare the current supported extension with the processed one
			if (ext.toLowerCase() == curFileExt.toLowerCase())
			{
				result = true;
				break;
			}
		}
	}
	
	return result;
}

function IsGraphicalExtension(ext)
{
	var result = false;

	//go through the whole list of supported 'Graphical Documents' and try to find a match
	if (gGraphicalFileExtList != null && gGraphicalFileExtList.length > 0)
	{
		var curFileExt;
		for (var i = 0; i < gGraphicalFileExtList.length; i++)
		{
			curFileExt = gGraphicalFileExtList[i];
				
			//compare the current supported extension with the processed one
			if (ext.toLowerCase() == curFileExt.toLowerCase())
			{
				result = true;
				break;
			}
		}
	}
	
	return result;
}

function IsPDFDocumentEnabled(ext)
{
	var result = false;
	
	if ((gIsGraphicsDocEnabled && isGraphicalExtension(ext)) || gIsPageListDocEnabled)
	{
		result = true;
	}
	
	return result;
}

/*
* Toggles 'New' option in the 'Doc Upload Mode' selector dropdown box
*/
function ToggleNewDocUploadOption(flag)
{
	//check whether the 'New' option exists in the appropriate
	var newOptionExists = false;
	if ($("#docSourceNewOption").length > 0)
	{
		newOptionExists = true;
	}
	
	//add the option, if required
	if (flag && !newOptionExists)
	{
		//create the appropriate string
		var newOptionHTML = '<option id="docSourceNewOption" value="doc_source_new">'+langStrings.newString+'</option>';
		
		//add the new option HTML to the target dropdown box
		if ($("#Select_Source_Type").length > 0)
		{
			var x = $("#Select_Source_Type").append(newOptionHTML);
		}	
	}
	//remove the option, if required
	else if (!flag && newOptionExists)
	{
		$("#docSourceNewOption").remove();
	}
}

function ToggleGeneralDocTypeDetails(show, copyDocSelected)
{	
	var curUploadMode = document.actionform.uploadType.value;

	if (show && curUploadMode == 'single')
	{
		$("#DocNameSpacerRow").show();
		$("#DocDescriptionSpacerRow").show();
		$("#DocDescriptionRow").show();
		
		// BOM count (reset values first: bug in firefox when pressing back button)
		if (gProjectPermissions["change_bom"]) {
			$("#AddToBOM").prop("checked", false);
			$("#AddToBOMCount").hide();
			$("#countBOM").val(1);
			$("#dec_countBOM").val(1.0);
			$("#DocAddToBOMRow").show();
		} else {
			$("#DocAddToBOMRow").hide();
		}
		
		$("#UploadButton").show();
		$("#UploadButtonSpacer").show();
		$("#OtherUploadsLinkRow").hide();
		$("#OtherUploadsLinkSpacerRow").hide();		
	
		ToggleDocUploadSourceType(false, copyDocSelected);
	}
	else
	{	
		$("#DocTypeInfo_Spacer_Row").hide();
		$("#DocTypeInfo_Row").hide();
		$('#DocDetails').hide();
		$("#DocNameSpacerRow").hide();
		$("#DocNameRow").hide();
		$("#DocDescriptionSpacerRow").hide();
		$("#DocDescriptionRow").hide();
		$("#DocAddToBOMRow").hide();
		//hide the Template Doc select row
		ToggleExtraTemplateDocRow(false);
		//hide Approval Cycle controls (if available)
		ToggleApprovalCycleControls(false);
		// hide doc Attributes controls
		ToggleDocumentAttributesRow(false);
		if (curUploadMode == 'single'){
			$("#UploadButton").hide();
		}
		$("#UploadButtonSpacer").hide();
		$("#OtherUploadsLinkRow").show();
		$("#OtherUploadsLinkSpacerRow").show();		
	}
}

/**
 * Show needed input fields for component input type
 */
function HandleComponentInputSelect() 
{
	var curUploadSourceTypeValue = $("#Select_Source_Type").val();
	if (curUploadSourceTypeValue == 'doc_source_component') {
		$("#DocNameSpacerRow").show();
		$("#DocDescriptionSpacerRow").show();
		$("#DocDescriptionRow").show();
		
		// BOM count (reset values first: bug in firefox when pressing back button)
		if (gProjectPermissions["change_bom"]) {
			$("#AddToBOM").prop("checked", false);
			$("#AddToBOMCount").hide();
			$("#countBOM").val(1);
			$("#dec_countBOM").val(1.0);
			$("#DocAddToBOMRow").show();
		} else {
			$("#DocAddToBOMRow").hide();
		}
		
		ToggleDocNameRow(true);
		
		var docNameElem = document.actionform.Doc_Name;
		docNameElem.value = '';

		ProcessDocMimeType(docNameElem, false);
		
		//show the 'Extra Temp. Doc.' select row
		ToggleExtraTemplateDocRow(true);

		// Show upload button
		$("#UploadButton").show();
		$("#UploadButtonSpacer").show();	  	
	}
}


	
function ToggleDocTypeLabelRow(flag)
{
	var curUploadMode = document.actionform.uploadType.value;

	if (flag && curUploadMode == 'single')
	{
		$("#DocTypeInfo_Spacer_Row").show();
		$("#DocTypeInfo_Row").show();
		$('#DocDetails').show();
	}
	else
	{
		$("#DocTypeInfo_Spacer_Row").hide();
		$("#DocTypeInfo_Row").hide();
		$('#DocDetails').hide();
	}
}

function ToggleDynamicDocTypeLabelRow(flag)
{
	if (flag)
	{
		$("#DocTypeInfo_Spacer_Row").show();
		$("#DocTypeInfo_Row").show();
		$('#DocDetails').show();
	}
	else
	{
		$("#DocTypeInfo_Spacer_Row").hide();
		$("#DocTypeInfo_Row").hide();
		$('#DocDetails').hide();
	}
}

function ToggleDocumentAttributesRow(flag)
{
	if (flag && gTempDocWithAttributesSelected)
	{
		$("#doc_attributes_divider_row_top").show();
		$("#doc_attributes_spacer_row_top1").show();
		$("#doc_attributes_spacer_row_top2").show();
		$("#doc_attributes_divider_row_bottom").show();
		$("#doc_attributes_spacer_row_bottom").show();
		$("#doc_attributes_row").show();
	}
	else
	{
		$("#doc_attributes_divider_row_top").hide();
		$("#doc_attributes_spacer_row_top1").hide();
		$("#doc_attributes_spacer_row_top2").hide();
		$("#doc_attributes_divider_row_bottom").hide();
		$("#doc_attributes_spacer_row_bottom").hide();
		$("#doc_attributes_row").hide();
	}
}

function ToggleZipFileDetailsRow(flag)
{
	//get the current 'Upload Source Mode'
	var curUploadSourceTypeValue = $("#Select_Source_Type").val();

	if (flag && curUploadSourceTypeValue != 'doc_source_new')
	{
		$("#zip_spacer_pagelist_toggle_row").show();
		$("#unzip_file_toggle_row").show();
		
		if (curUploadSourceTypeValue == 'doc_source_browse')
		{
			if ($("#zip_type_select_TD").find('option').length > 1) {
				$("#zip_tip_row").show();
			}	
		}
	}
	else
	{
		$("#zip_spacer_pagelist_toggle_row").hide();
		$("#unzip_file_toggle_row").hide();
		$("#zip_tip_row").hide();
	}
}

function ToggleCapeDocDetailsRow(show)
{	
	if (show)
	{
		$("#cape_spacer_xml_row").show();
		$("#cape_doc_xml_row").show();
		$("#cape_spacer_report_row").show();
		$("#cape_doc_report_row").show();
	}
	else
	{	
		$("#cape_spacer_xml_row").hide();
		$("#cape_doc_xml_row").hide();
		$("#cape_spacer_report_row").hide();
		$("#cape_doc_report_row").hide();
	}
}
	
function TogglePagelistDocDetailsRow(show)
{		
	if (show)
	{	
		$("#pdf_spacer_pagelist_index_row").show();
		$("#pdf_pagelist_index_row").show();
	}
	else
	{
		$("#pdf_spacer_pagelist_index_row").hide();
		$("#pdf_pagelist_index_row").hide();
	}
}

function ToggleDocNameRow(show, showsuffix)
{
	var curUploadMode = document.actionform.uploadType.value;

	if (show && curUploadMode == 'single')
	{	
		$("#DocNameRow").show();
		$("#DocDetails").show();
		//$("#pdf_pagelist_index_row").show();
		if(showsuffix){
			$("#DocNameRowName").hide();
			$("#DocNameRowNameSuffix").show();
			$("#Doc_Name")[0].value = '';
			gCurrentlyUseAutoname = true;
		}else{
			var fileInputValue = document.actionform.docFileInput.value;
			$("#DocNameRowNameSuffix").hide();
			$("#DocNameRowName").show();
			PrefillDocName(fileInputValue);
			gCurrentlyUseAutoname = false;
		}
	}
	else
	{
		$("#DocNameRow").hide();
		$("#DocDetails").hide();
		gCurrentlyUseAutoname = true;
		//$("#pdf_pagelist_index_row").hide();
	}
	
}
	
function toggleUnzipArchive(elem)
{	
	if (elem && elem.checked)
	{
		$("#Doc_Name").prop("disabled", true);
		$("#doc_description").prop("disabled", true);
	}
	else
	{
		$("#Doc_Name").prop("disabled", false);
		$("#doc_description").prop("disabled", false);
	}
}

function ToggleApprovalCycleControls(show)
{
	if (show && gHasApprovalSetup)
	{		
		$(".ApprovalSetupRow").show();
		
		if (!gCanStartAppCycle)
		{
			$("#start_approval_cycle_row").hide();
			$("#start_approval_cycle_spacer_row").hide();
		}
		
		//hide 'Approval Due Date' controls if not valid in the current situtation
		if (!document.actionform.doStartApprovalCycle.checked || !gCanChangeApproval)
		{
			$("#approval_due_date_row").hide();
			$("#approval_due_date_spacer_row").hide();
		}
		ShowStartStopApprovalFeedbackString();
	}
	else
	{	
		$(".ApprovalSetupRow").hide();
	}
	
	
	
}

function ToggleExtraTemplateDocRow(show)
{	
	if (show && gHasTemplateDocuments)
	{	
		$("#temp_doc_spacer_row").show();
		$("#temp_doc_select_row").show();
		$("#Select_Template_Document").show();
	}
	else
	{
		$("#temp_doc_spacer_row").hide();
		$("#temp_doc_select_row").hide();
	}
}

/**
 * Switching of document source in a single upload (in existing project).
 * @param isReset {boolean} - flag whether to reset form fields/parameters when changing document source
 * @param skipLoadCopyProjs {boolean} - flag; if true, will not be resetting the "Copy Doc - Source Projects" sDrop dataset
 */
function ToggleDocUploadSourceType(isReset, skipLoadCopyProjs)
{
	if (isReset)
	{
		//reset all current values before switching the 'doc upload type'
		ResetFormFieldValues(true);
	}

	var curValue = $("#Select_Source_Type").val();
	
	if (curValue == "doc_source_browse")
	{
		//show the 'File Input Select' TD
		$("#docFileInputTD").show();
		$("#docCopySelectTD").hide();
		$("#docNewSelectTD").hide();
		$("#docURLSelectTD").hide();
		
		//show 'Document Type' row
		ToggleDocTypeLabelRow(true);	
		
		//show the 'Extra Temp. Doc.' select row
		ToggleExtraTemplateDocRow(true);

		//show Doc Name field		
		ToggleDocNameRow(true);
		
		//show Approval Cycle controls (if available)
		ToggleApprovalCycleControls(true);
	}
	else
	if (curValue == "doc_source_copy")
	{
		//show the 'Select Doc to be Copied' TD
		$("#docFileInputTD").hide();
		$("#docCopySelectTD").show();
		$("#docNewSelectTD").hide();
		$("#docURLSelectTD").hide();
		
		gCopyFromSDrop.show();
		$("#Select_SourceCopyDoc").show();
		
		//attempt to load the appropriate list of Projects to copy from
		if (!skipLoadCopyProjs) {
			LoadProjectsForDocumentCopy();	
		};

		//show 'Document Type' row
		ToggleDocTypeLabelRow(false); // we do not change the type
		
		//show the 'Extra Temp. Doc.' select row
		ToggleExtraTemplateDocRow(true); // but we change the attribute category
		
		//show Doc Name field		
		ToggleDocNameRow(true);
		
		//show Approval Cycle controls (if available)
		ToggleApprovalCycleControls(true);
	}
	else
	if (curValue == "doc_source_new")
	{
			//show the 'Select Doc to be Copied' TD
		$("#docFileInputTD").hide();
		$("#docCopySelectTD").hide();
		$("#docNewSelectTD").show();
		$("#docURLSelectTD").hide();
		
		//do not show 'Document Type' row
		ToggleDocTypeLabelRow(false);
		
		//hide the 'Extra Temp. Doc.' select row (as it is redundant in this upload mode)	
		ToggleExtraTemplateDocRow(false);
		
		//show Doc Name field		
		ToggleDocNameRow(true);
		
		//show Approval Cycle controls (if available)
				
		if (isReset)
		{
			// bring up the selection dialog
			if (!gIsCopyDocument)
				OpenDocTemplateSelection(-1);
		}
	}
	else
	if (curValue == "doc_source_url")
	{
		//show the 'URL Input' TD
		$("#docFileInputTD").hide();	
		$("#docCopySelectTD").hide();
		$("#docNewSelectTD").hide();
		$("#docURLSelectTD").show();
		
		//hide 'Document Type' row as URL is a doc. type itself
		ToggleDocTypeLabelRow(false);
		
		//hide Doc Name field		
		ToggleDocNameRow(false);
		
		//hide Approval Cycle controls as its not valid for URL doc upload
		ToggleApprovalCycleControls(false);

		// set focus in the URL field
		$("#Input_SourceURLDoc").trigger("focus");
	}
	else
	if (curValue == "doc_source_component")
	{
		//no separate parameters are needed
		$("#docFileInputTD").hide();	
		$("#docCopySelectTD").hide();
		$("#docNewSelectTD").hide();
		$("#docURLSelectTD").hide();

		
		//reset TemplateDoc selectors -> reset the 'Doc Attributes' area of the page
		ResetTemplateDocSelectors();
		ToggleDocumentAttributesRow(false);
		
	}
}

/**
* Determine whether to show 'Extra Template Documents' row 
* Based on the currently selected 'Document Upload Source' type
**/
function DoShowExtraTemplateDocsRow()
{
	var uploadTypeVal = document.actionform.uploadType.value;
	if (uploadTypeVal != null && uploadTypeVal == 'multi')
	{
		return false;
	}
	
	var curValue = $("#Select_Source_Type").val();
	
	if ((curValue == "doc_source_new") || !gHasProjectFolderContext)
	{
		return false;
	}
	else
	{
		return true;
	}
		
	
}

function ToggleZipDocTypeSelector(show)
{
	if (show)
	{
		$("#zip_doc_type_label_row").show();
	}
	else
	{
		$("#zip_doc_type_label_row").hide();
	}	
}

function TogglePdfDocTypeSelector(show)
{
	if (show)
	{
		$("#pdf_doc_type_label_row").show();
	}
	else
	{
		$("#pdf_doc_type_label_row").hide();
	}	

}

function HideAllExtraDetails()
{
	ToggleCapeDocDetailsRow(false);
	TogglePagelistDocDetailsRow(false);
	ToggleZipFileDetailsRow(false);
	ShowPDFDocTypeOption(false);
	ToggleZipDocTypeSelector(false);
	TogglePdfDocTypeSelector(false);
}


function setDocTypeLabel(labeltext)
{
	var docTypeLabelSpan = document.getElementById("doc_type_label");
	if (docTypeLabelSpan)
		docTypeLabelSpan.innerHTML = labeltext;
}


function ChangeDocTypeLabel(targetLabelIndex)
{
	var docTypeLabelSpan = document.getElementById("doc_type_label");
	
	if (docTypeLabelSpan)
	{
		var targetLabel = docTypeLabels[targetLabelIndex];
		
		if (targetLabel != null && targetLabel != "")
			docTypeLabelSpan.innerHTML = targetLabel;
	}
}

function ShowPDFDocTypeOption(show)
{
	//get the current 'Upload Source Type' value
	var curUploadSourceTypeValue = $("#Select_Source_Type").val();

	if (show)
	{	
		var curDocTypeValue;
		var pdfSelectElem =	document.getElementById("pdf_type_select");
		if (pdfSelectElem && pdfSelectElem.options.length > 0)
		{
			//reset the index of selected option for the select prior to the actual toggle action
			pdfSelectElem.selectedIndex = 0;
			
			//get the 'doctype code' from the currently selected option
			curDocTypeValue = pdfSelectElem.options[pdfSelectElem.selectedIndex].value;
		}
		else
		{
			curDocTypeValue = document.actionform.singlePDFDocType.value;
		}
		
		if (curDocTypeValue != null && curDocTypeValue.length > 0)
		{
			SetDocTypeParamValue(curDocTypeValue);
		}
		
		//show the correct PDF doc details controls
		TogglePDFDocType(pdfSelectElem, curDocTypeValue);
		
		//show the dynamic Doc Type selector
		$("#doc_type_label_row").hide();
		$("#pdf_doc_type_label_row").show();
		
		if (curUploadSourceTypeValue == 'doc_source_browse')
		{
			$("#pdf_tip_index_row").show();
		}
	}
	else
	{
		$("#doc_type_label_row").show();
		$("#pdf_doc_type_label_row").hide();
		$("#pdf_tip_index_row").hide();
	}
}

function ShowZipDocTypeOption(show)
{
	if (show)
	{
		var curDocTypeValue;
		var zipSelectElem =	document.getElementById("zip_type_select");
		
		if (zipSelectElem && zipSelectElem.options.length > 0)
		{
			//reset the index of selected option for the select prior to the actual toggle action
			zipSelectElem.selectedIndex = 0;
			
			//get the 'doctype code' from the currently selected option
			curDocTypeValue = zipSelectElem.options[zipSelectElem.selectedIndex].value;
		}
		else
		{
			curDocTypeValue = document.actionform.singleZIPDocType.value;
		}
		
		if (curDocTypeValue != null && curDocTypeValue.length > 0)
		{
			SetDocTypeParamValue(curDocTypeValue);
		}
		
		//show the correct PDF doc details controls
		ToggleZipDocType(zipSelectElem, curDocTypeValue);
		
		$("#doc_type_label_row").hide();
		$("#zip_doc_type_label_row").show();
	}
	else
	{
		$("#doc_type_label_row").show();
		$("#zip_tip_row").hide();
		$("#zip_doc_type_label_row").hide();
	}
}

function TogglePDFDocType(elem, curValue, fromTemplate)
{	
	if (curValue == "pagelist")
	{
		TogglePagelistDocDetailsRow(true);
	}
	else
	{
		TogglePagelistDocDetailsRow(false);
	}
	
	//set the current value of the DocType param
	SetDocTypeParamValue(curValue);
	if(fromTemplate != true) ProcessDocType('.pdf');
}

function ToggleZipDocType(elem, curValue, fromTemplate)
{	
	//toggle extra elements to be shown/hidden when selecting a zip file
	var showChckbx = true;
	if (curValue == "chili" || curValue == "graphic") {
		showChckbx = false;
	}
	
	ToggleZipFileDetailsRow(showChckbx);

	//set the current value of the DocType param
	SetDocTypeParamValue(curValue);
	if(fromTemplate != true) ProcessDocType('.zip');
}

function HandleTargetProjectChange(elem)
{
	// when this is the copy document functionality, we do not ask for confirmation since we will not change the values. 
	if (HaveFormFieldValues() && !gIsCopyDocument)
	{
		OpenProjectChangePopup(false);
	}
	else
	{
		var sel_project = document.getElementById("Select_Project");
		if (gIsCopyDocument && gProjectID!='' ) 
		{
			var ok = confirm(langStrings.resetProjectWarning);
			if (!ok )
			{
				sel_project.value = gProjectID;// reset
				return ; 
			}
		}
	
		//nothing prevents from simply changing the Target Project -> go ahead
		SetCurrentProjectIDFormValue();
		FillUpDynamicTargetProjectFolderSelectControls(true);
		
		if (gIsCopyDocument ) 
		{	
			// check whether this is the onlt thing we need to specify.
			// If we need to specify the folder - return here
			// if there is only one folder, show the rest of the elements
 			SetCurrentProjectIDFormValue();
			
	 		if (gHasProjectFolderContext)
		 		showDocumentElements();
	
			return ;		
		}
		else
		{
			//load the 'Template Documents' setup for the currently selected Destination Project
			LoadDocTemplatesForProject(false); 
		}
		
		
		//reset TemplateDoc selectors -> reset the 'Doc Attributes' area of the page
		ResetTemplateDocSelectors();
		ToggleDocumentAttributesRow(false);
		
		// set the documents table to the initial state
		// (we can fully destroy the documents table here, because it's guaranteed no data are in the table in this code branch...)
		resetDocumentsTable(true);

		//load the 'Project/Folder Approval Cycle' setup for the currently selected Destination Project
		LoadProjectFolderApprovalRule(); 	
		
		//load the autonaming setup for the currently selected Destination Project
		LoadProjectAutonaming();
		
		//load project permissions
		LoadProjectPermissions();
		
		// load Document upload configuration and initialize document upload links (actually the whole DocTableX)
		LoadDocumentUploadConfig();

	}	
}

function HandleTargetProjectFolderChange()
{
	SetCurrentProjectFolderIDFormValue();
	
	// check whether we are in copy document mode
	if ( gIsCopyDocument) 
		showDocumentElements();
	
	LoadProjectFolderApprovalRule();
	
}

function SetCurrentProjectIDFormValue()
{
	//get the reference to the Target Project dropdown box
	var projectSelectElem = document.getElementById("Select_Project");
	if (projectSelectElem)
	{
		//get the current 'ID' value of the selected Project
		var curProjectID = projectSelectElem.options[projectSelectElem.selectedIndex].value;
		
		//mark the index of the selected project
		document.actionform.curProjectSelectedIndex.value = projectSelectElem.selectedIndex;
		
		if (curProjectID != null)
		{			
			//set the value into the appropriate input field
			document.actionform.targetProjectID.value = curProjectID;
			gProjectID = curProjectID;
			
			//update the projectID for doctablex if it exists on the page.
			if (window.docTableObj && window.docTableObj.dshObj) {
				window.docTableObj.updateTargetProject(curProjectID);
				window.docTableObj.updateTargetFolders();
			}
			
			if (curProjectID.length > 0)
			{
				//a project currently selected -> show the Upload Controls
				gHasProjectContext = true;
			}
			else if (curProjectID.length == 0)
			{
				//no project currently selected -> hide the Upload Controls
				ToggleShowUploadControls(false);
				gHasProjectContext = false;
				
				//update the Project Folder value
				//SetCurrentProjectFolderIDFormValue();
			}
		}
	}
}

function SetCurrentProjectFolderIDFormValue()
{
	//get the reference to the Target Project Folder dropdown box
	var projectFolderSelectElem = document.getElementById("Select_Folder");
	if (projectFolderSelectElem)
	{
		//get the current 'ID' value of the selected Project
		var curFolderID = projectFolderSelectElem.options[projectFolderSelectElem.selectedIndex].value;
		
		//set the value into the appropriate input field
		if (curFolderID != null)
		{
			var oldFolderID = document.actionform.targetFolderID.value;
			document.actionform.targetFolderID.value = curFolderID;
			gDestFolderID = curFolderID;
			
			var folderName = "";
			if(curFolderID === "DEFAULT"){
				folderName = undefined;
			}else if(curFolderID !== "ROOT"){
				folderName = projectFolderSelectElem.options[projectFolderSelectElem.selectedIndex].text;
			}
			
			if(document.actionform.uploadType.value !== 'single'){
				OpenFolderChangePopup(folderName,oldFolderID,projectFolderSelectElem);
			}
			
			
			
		
			if (curFolderID.length > 0)
			{
				gHasProjectFolderContext = true;
				
				if (!gUploadControlsShown)
				{
					ToggleShowUploadControls(true);
					ToggleGeneralDocTypeDetails(false);
				}
			}
			else
			{
				gHasProjectFolderContext = false;
				ToggleShowUploadControls(false);	
			}
		}
	}
}

function HaveFormFieldValues()
{
	var uploadTypeVal = document.actionform.uploadType.value;
      
    if (uploadTypeVal == "single")
    {
    	//check the SINGLE DOC UPLOAD form fields
    	var fileInputValue = document.actionform.docFileInput.value;
    	var docNameInputValue = document.actionform.Doc_Name.value;
    	var docDescInputValue = document.actionform.doc_description.value;
    	
    	if ((fileInputValue != null && fileInputValue.length > 0) || 
    	    (docNameInputValue != null && docNameInputValue.length > 0) ||
    	    (docDescInputValue != null && docDescInputValue.length > 0) ||
    	    gTempDocWithAttributesSelected
    	   )
    	   {
    	   		return true;
    	   }
    }
    //else check for 'document rows' in the MultiDoc Upload area of the page
    else {
    	// (note window.docTableObj can be not only undefined, but also null when DocTableX is destroyed...)
    	if (window.docTableObj && window.docTableObj.docRows && window.docTableObj.docRows.length > 0)
        {
        	return true;
        }
    	if(typeof $(".documentList").html() != "undefined" && $(".documentList").html().length > 0){
    		return true;
    	}
    	
    }
    
    
    //got here... no form values/document rows were found
    return false;
}

function RevertBackToPreviousTargetProject()
{
	//get the value of the previous object
	var previousSelectedProjectIndex = document.actionform.curProjectSelectedIndex.value;
	
	//set the selected index of the 'Target Project' selector back to the previous value
	var targetProjectSelectElem = document.getElementById("Select_Project");
	if (targetProjectSelectElem)
	{
		targetProjectSelectElem.selectedIndex = previousSelectedProjectIndex;
	}
}

/**
 * Open the popup that has to be shown when changing the folder
 * @param {string} folderName
 * @param {string} oldFolderId
 * @param {DOM element} projectFolderSelector
 */
function OpenFolderChangePopup(folderName,oldFolderId,projectFolderSelector){
	require(["jquery", "jqueryUI"], function($){
		var yesButton = langStrings.yes;
		var noButton = langStrings.no;
		var cancelButton = langStrings.cancel;
		
		//create the HTML
		var dialog = $("<div>").addClass("form-group add-spacing");
		dialog.css("display:none");
		
		//add the title 
		dialog.attr("title",langStrings.FolderChangeDialogTitle);
		
		var dialogButtons = {};
		
		if(HaveFormFieldValues()){
			dialog.append($("<p>").text(langStrings.ChangeFolderDialogMessage));
		
			dialog.append($("<p>").text(langStrings.ChangeFolderDialogQuestion));

			

			dialogButtons[yesButton] = function(){
				//handle the yes event
				window.docTableObj.updateSelectedTargetFolder(folderName);
				window.docTableObj.updateDefaultTargetFolder(folderName);

				dialog.dialog("destroy").remove();
			};

			dialogButtons[noButton] = function(){
				window.docTableObj.updateDefaultTargetFolder(folderName);
				dialog.dialog("destroy").remove();
			};

			dialogButtons[cancelButton] = function(){
				//restore the old value of the select
				$(projectFolderSelector).val(oldFolderId);
				document.actionform.targetFolderID.value = oldFolderId;
				dialog.dialog("destroy").remove();
			};
		}else{
			dialog.append($("<p>").text(langStrings.ChangeFolderDialogMessage));
		
			dialog.append($("<p>").text(langStrings.ChangeFolderDialogNoDocumentsQuestion));
			
			dialogButtons[yesButton] = function(){
				window.docTableObj.updateDefaultTargetFolder(folderName);
				dialog.dialog("destroy").remove();
			};
			
			dialogButtons[noButton] = function(){
				//restore the old value of the select
				$(projectFolderSelector).val(oldFolderId);
				document.actionform.targetFolderID.value = oldFolderId;
				dialog.dialog("destroy").remove();
			};
		}
		
		
		
		
		dialog.dialog({ 
			autoOpen: false, 
			modal: true, 
			width: 400,
			closeOnEscape: false,
			closeText: "",
			buttons: dialogButtons 
		});
		
		//hide the close button
		$(".ui-dialog-titlebar-close").hide();
		
		//dialog is prepared - open it up		   
		dialog.dialog("open"); 	
	});
}

function OpenProjectChangePopup(multiDocUploadTypeSwitch)
{
	require(["jquery", "jqueryUI"], function($){
		var yesButton = langStrings.yes;
		var noButton = langStrings.no;
		
		//prepare the action buttons and their action handlers
		var dialog_buttons = {};
		
		//buttons for 'Project Change' dialog
		if (!multiDocUploadTypeSwitch)
		{
			dialog_buttons[yesButton] = function()
				{ 
					//YES button clicked -> reset the form field values
					ResetFormFieldValues(true);
					
					
					//...and load data for the current Target Project
					SetCurrentProjectIDFormValue();
					FillUpDynamicTargetProjectFolderSelectControls(true);
					
					LoadDocTemplatesForProject(false);
					
					//reset TemplateDoc selectors -> reset the 'Doc Attributes' area of the page
					ResetTemplateDocSelectors();
					ToggleDocumentAttributesRow(false);
					
					//set the appropriate 'single doc upload mode' controls
					$("#Select_Source_Type").prop("selectedIndex", 0);
					
					if (gProjectID != null && gProjectID.length > 0)
					{
						LoadProjectPermissions();
						ToggleDocUploadSourceType(true);
					}
					
					if (gDestFolderID != null && gDestFolderID.length > 0 && gHasProjectFolderContext)
					{
						LoadProjectFolderApprovalRule();
					}
					else
					{
						ToggleShowUploadControls(false);
					}
					
					ToggleGeneralDocTypeDetails(false);
		
					// set the documents table to the initial state
					resetDocumentsTable();
					
					
					//...and close the dialog
					$("#projectChangeResetDialog").dialog("close");
					$('select').not('.sdrop').show();	
					gCopyFromSDrop.show();
				};
							
			dialog_buttons[noButton] = function()
				{ 
					//user doesnt want to lose his doc. values -> revert back to the previous Target Project
					RevertBackToPreviousTargetProject();
		
					//...and close the dialog
					$("#projectChangeResetDialog").dialog("close");
					$('select').not('.sdrop').show();
					gCopyFromSDrop.show();
					$("#temp_doc_select_row").hide();	
											
				};
		}
		else
		//switching from single-doc to multi-doc upload mode
		{
			dialog_buttons[yesButton] = function()
					{ 
						//hide the the 'Single Doc. Upload' row
						toggleDocUploadDetailsRow(false, 'SingleDocUploadFieldsRow');
						
						//YES button clicked -> reset the form field values
						ResetFormFieldValues(true);
						
						//handle ProjectID value callback only if the dropdown is actually in a valid state
						if (gDestProjects != null && gDestProjects.length > 1)
						{
							SetCurrentProjectIDFormValue();
							FillUpDynamicTargetProjectFolderSelectControls(true);
						}
							
						//hide the 'document attributes' row as it irrelevant for multidoc upload mode
						ToggleDocumentAttributesRow(false);
						
						//hide the 'extra doc template selector' row as it irrelevant for multidoc upload mode
						ToggleExtraTemplateDocRow(false);
	
									//show the 'Multi Doc. Upload' row
						toggleDocUploadDetailsRow(true, 'MultiDocUploadFieldsRow');
								
						//remove the link to switch 'doc upload type' -> one direction switch only (single to multi)
						$("#doc_upload_type_switch_td").hide();

						//change the 'doc upload type' indicator
						document.actionform.uploadType.value = 'multi';
						
						//...and close the dialog
						$("#projectChangeResetDialog").dialog("close");
						$('select').not('.sdrop').show();	
						gCopyFromSDrop.show();
					};
									
			dialog_buttons[noButton] = function()
				{
						//user doesnt want to lose his doc. values -> revert back to the previous Target Project
						RevertBackToPreviousTargetProject();
						
						//just close the dialog (no changes in this case)
						$("#projectChangeResetDialog").dialog("close");
						$('select').not('sdrop').show();		
						gCopyFromSDrop.show();
				};
		}

		$("#projectChangeResetDialog").dialog(
				{ autoOpen: false, 
				modal: true,
				width: 400,
				closeOnEscape: false,
				buttons: dialog_buttons
				});
		
		//define event handler when the User closes the dialog window
		$(".ui-dialog-titlebar-close").hide();
		
		//change the colors(css style class) of the buttons
		//$('.ui-dialog-buttonpane button:contains(yes)').attr("class", "xxx");
		//$('.ui-dialog-buttonpane button:contains(no)').attr("id", "xxx");
			
		//JAMI > IE error with overlaying dropdown boxes --> just hide them for when the dialog is opened
		$('select').not('sdrop').hide();
		gCopyFromSDrop.hide();
		
		//dialog is prepared - open it up		   
		$("#projectChangeResetDialog").dialog("open"); 	
	});
}




function ResetFormFieldValues(complete)
{
	//SINGLE DOC FORM FIELDS
	
	//file selector
	/*$("#docFileInputTD").empty();
	var newFileInputHTML = '<input type="file" name="docFileInput" id="docFileInput" size="60" onchange="CheckTextInput(this.value, "", "DocFileRow"); ProcessDocMimeType(this);" onkeyup="CheckTextInput(this.value, "", "DocFileRow"); ProcessDocMimeType(this);" onpropertychange="CheckTextInput(this.value, "", "DocFileRow"); ProcessDocMimeType(this);"/>';
	$("#docFileInputTD").html(newFileInputHTML);*/
	
	var inputElemParent = document.getElementById("docFileInput").parentNode;
	if (inputElemParent)
	{
		inputElemParent.innerHTML = inputElemParent.innerHTML; 
	}
	
	//clear out secondary CAPE file fields
	var inputCapeXMLElemParent = document.getElementById("capeDocXMLFile").parentNode;
	if (inputCapeXMLElemParent)
	{
		inputCapeXMLElemParent.innerHTML = inputCapeXMLElemParent.innerHTML; 
	}
	
	var inputCapeReportElemParent = document.getElementById("capeDocReportFile").parentNode;
	if (inputCapeReportElemParent)
	{
		inputCapeReportElemParent.innerHTML = inputCapeReportElemParent.innerHTML; 
	}
	
	//URL textbox
	$("#Input_SourceURLDoc").val("");
	
	//doc name
	$("#Doc_Name").val("");
	
	//doc description
	$("#doc_description").val("");
	
	//document type label
	$("#doc_type_label").text("");
	
	//also set the dropdown select boxes
	if (complete)
	{
		$("#Select_SourceCopyProject").val('');
		$("#Select_SourceCopyDoc").val('');
	}
	
	//hide all extra information
	HideAllExtraDetails();
	
	//MULTIDOC - DOC ROWS
	ClearDocumentList();
	
	//clear the doc type param values
	SetDocTypeParamValue("none");
	SetPDFDocTypeParamValue("none");
	SetZIPDocTypeParamValue("none");
	
	//reset the 'Temp. Doc with Attributes linked' flag
	gTempDocWithAttributesSelected = false;
}

/*
* Clears all the 'New Document Rows' in the MultiDocUpload table
*/
function ClearDocumentList()
{
	if(window.docTableObj){
		window.docTableObj.reset(true);
		window.docTableObj.view.render();
	}else{
		$(".documentsList").empty();
	}
}

function SetDocTypeParamValue(val)
{
	if (val != null && val.length > 0)
	{
		if (val == 'none')
		{
			document.actionform.selectedDocType.value = '';
		}
		else
		{
			document.actionform.selectedDocType.value = val;
		}	
	}
}

function SetPDFDocTypeParamValue(val)
{
	if (val != null && val.length > 0)
	{
		if (val == 'none')
		{
			document.actionform.singlePDFDocType.value = '';
		}
		else
		{
			document.actionform.singlePDFDocType.value = val;
		}	
	}
}

function SetZIPDocTypeParamValue(val)
{
	if (val != null && val.length > 0)
	{
		if (val == 'none')
		{
			document.actionform.singleZIPDocType.value = '';
		}
		else
		{
			document.actionform.singleZIPDocType.value = val;
		}	
	}
}


function ShowStartStopApprovalFeedbackString()
{
	
	if (!gStartAppCheckEnabled  )
	{
		if (!$("#doApplyDefApprovalSettings")[0].checked)
		{
			$("#AppAlwaysStart").hide();
			$("#AppNeverStart").hide();
		}
		else
		{
			if (gStartAppDefaultValue)
			{
				// show the text that the approval cycle will be started
				$("#AppAlwaysStart").show();
			}
			else
			{
				// show the text that the approval cycle will not be started 
				$("#AppNeverStart").show();
			}	
		}
		
		
		// hide the checkbox
		$("#start_approval_cycle_row").hide();
	}
	
}


function ToggleApplyApprovalSettings(elem)
{
	
	ShowStartStopApprovalFeedbackString();
	
	
	if (elem.checked)
	{
		//set the value of the param
		document.actionform.ApprovalRequiredCheck.value = 'on';
		
		if (gCanStartAppCycle && gStartAppCheckEnabled)
		{
			//enable the secondary controls
			$("#doStartApprovalCycle").prop("disabled", false);
		}
		
		//show the 'App. Due Date' controls only if the User is allowed to Change Approval
		if (gCanChangeApproval)
		{
			$("#approval_due_date_row").show();
			$("#approval_due_date_spacer_row").show();
		}
	}
	else
	{
		document.actionform.ApprovalRequiredCheck.value = '';
		
		//disable the secondary controls
		$("#doStartApprovalCycle").prop("disabled", true);
		$("#approval_due_date_row").hide();
		$("#approval_due_date_spacer_row").hide();
		
		// hide the different feedback rows
		$("#AppAlwaysStart").hide();
		$("#AppNeverStart").hide();
		
	}
	
	// init the default value of the approval cycle 
	if (gStartAppDefaultValue)		
	{
		$("#doStartApprovalCycle")[0].checked = 1;
		document.actionform.StartApprovalCycle.value = 'on';	
	}
		
	
}

function ToggleStartApprovalCycle(elem)
{
	if (elem.checked)
	{
		//set the value of the param
		document.actionform.StartApprovalCycle.value = 'on';
	}
	else
	{
		document.actionform.StartApprovalCycle.value = '';
	}
	
	
}

function ResetApprovalSetup()
{
	gCanChangeApproval = false;
	gCanStartAppCycle = false; 
	gStartAppCheckEnabled = true;
	
	//reset the parameter values
	document.actionform.ApprovalRequiredCheck.value = '';
	document.actionform.StartApprovalCycle.value = '';
	
	//uncheck both the checkboxes
	$("#doApplyDefApprovalSettings").prop("checked", false);
	$("#doStartApprovalCycle").prop("checked", false);
	
	//clear values of the fields
	$("#longFormat_due_date").val("");
			
	//disable the secondary controls
	$("#doStartApprovalCycle").prop("disabled", true);
	$("#approval_due_date_row").hide();
	$("#approval_due_date_spacer_row").hide();
}



/*
* Set correct flag values to let the script know what document types are enabled on the server
* NOTE: the values in the list are compared to a hardcoded string based on the current implementation!!! 
* 
* Add extra options to the 'Doc Type' electors for special files
*/
function ProcessEnabledDocTypes()
{
	if (gEnabledDocTypeIDs != null && gEnabledDocTypeIDs.length > 0)
	{
		var curDocTypeID;
		for (var i = 0; i < gEnabledDocTypeIDs.length; i++)
		{
			curDocTypeID = gEnabledDocTypeIDs[i];
			
			//OTHER && URL
			if (curDocTypeID == gOtherDocTypeID)
			{
				gIsOtherDocTypeEnabled = true;
				gIsURLDocTypeEnabled = true;
			}
			else
			//COMPONENT
			if (curDocTypeID == gComponentDocTypeID)
			{
				gIsComponentDocTypeEnabled = true;
			}
			else
			//ARTIOS CAD DESIGN
			if (curDocTypeID == gCADDesignDocTypeID)
			{
				gIsCADDesignDocEnabled = true;
			}
			else
			//ARTIOS CAD MANUFACTURING
			if (curDocTypeID == gCADManufacturingID)
			{
				gIsCADManufacturingDocEnabled = true;
			}
			else
			//ARTIOS CAD 3D
			if (curDocTypeID == gCAD3DDocTypeID)
			{
				gIsCAD3DDocEnabled = true;
			}
			else
			//ARTIOS CAD CANVAS
			if (curDocTypeID == gCADCanvasDocTypeID)
			{
				gIsCADCanvasDocEnabled = true;
			}
			else
			//GRAPHIC 
			if (curDocTypeID == gGraphicsDocTypeID)
			{
				gIsGraphicsDocEnabled = true;
			}	
			else
			//CAPE
			if (curDocTypeID == gCapeDocDocTypeID)
			{
				gIsCapeDocEnabled = true;
			}
			else
			//PAGE LIST
			if (curDocTypeID == gPageListDocTypeID)
			{
				gIsPageListDocEnabled = true;
			}
			else
			//ZIPPED COLLADA
			if (curDocTypeID == gZippedColladaDocTypeID)
			{
				gIsZippedColladaDocEnabled = true;
			}
			else
			//COLLADA
			if (curDocTypeID == gColladaDocTypeID)
			{
				gIsColladaDocEnabled = true;
			}
			// CHILI PACK
			else
			if (curDocTypeID == gChiliDocTypeID)
			{
				gIsChiliDocEnabled = true;
			}
			else
			// Text Content
			if (curDocTypeID == gTextContentDocTypeID) {
				gIsTextContentDocEnabled = true;
			}
		}	
	}
	
	//also handle Graphical Document extension list
	if (gGraphicalFileExtList != null && gGraphicalFileExtList.length > 0 && gIsGraphicsDocEnabled)
	{	
		var g;
		
		//run through the list of extensions (two times)
		//ZIP runthrough
		var curGraphFileExtension;
		for (g = 0; g < gGraphicalFileExtList.length; g++)
		{
			curGraphFileExtension = gGraphicalFileExtList[g];
			
			//ZIP file
			if (curGraphFileExtension == '.ZIP')
			{
				gIsZIPFileAsGraphic = true;
				break;
			}
		}
		
		//PDF runthrough		
		for (g = 0; g < gGraphicalFileExtList.length; g++)
		{
			curGraphFileExtension = gGraphicalFileExtList[g];
			
			//PDF file
			if (curGraphFileExtension == '.PDF')
			{
				gIsPDFFileAsGraphic = true;
				break;
			}
		}
	}
	
	//handle the extra options for ZIP and PDF documents
	var zipDocTypeCount = 0;
	var pdfDocTypeCount = 0;
	
	if (gIsPDFFileAsGraphic && gIsGraphicsDocEnabled)
	{
		//add 'GRAPHIC Doc Type' option for the Pdf file doc type drop down selector
		var PdfAsGraphicOptionHTML = '<option value="graphic">'+docTypeLabels[0]+'</option>';	
		$("#pdf_type_select").append(PdfAsGraphicOptionHTML);
	
		//raise the options counter
		pdfDocTypeCount++;
	}
	
	if (gIsPageListDocEnabled)
	{
		//add 'PAGE LIST Doc Type' option for the Pdf file doc type drop down selector
		var PdfAsPageListOptionHTML = '<option value="pagelist">'+docTypeLabels[1]+'</option>';	
		$("#pdf_type_select").append(PdfAsPageListOptionHTML);
		
		//raise the options counter
		pdfDocTypeCount++;
	}
	
	if (gIsOtherDocTypeEnabled)
	{
		//add 'OTHER' doc type to the 'ZIP Doc Type' selector options
		var ZipAsOtherOptionHTML = '<option value="other">'+docTypeLabels[4]+'</option>';	
		$("#zip_type_select").append(ZipAsOtherOptionHTML);
					
		//raise the options counter
		zipDocTypeCount++;
		
		//add 'OTHER' doc type to the 'PDF Doc Type' selector options
		var PdfAsOtherOptionHTML = '<option value="other">'+docTypeLabels[4]+'</option>';	
		$("#pdf_type_select").append(PdfAsOtherOptionHTML);
		
		//raise the options counter
		pdfDocTypeCount++;	
	}
	
	if (gIsZIPFileAsGraphic && gIsGraphicsDocEnabled)
	{
		//add an extra 'GRAPHIC Doc Type' option for the Zip file doc type drop down selector
		var ZipAsGraphicOptionHTML = '<option value="graphic">'+docTypeLabels[0]+'</option>';	
		$("#zip_type_select").append(ZipAsGraphicOptionHTML);
		
		//raise the options counter
		zipDocTypeCount++;
	}
	
	
	// chili pack 
	if (gIsChiliDocEnabled)
	{
		//add an extra 'Chili Doc Type' option for the Zip file doc type drop down selector
		var chiliOptionHTML = '<option value="chili">'+docTypeLabels[8]+'</option>';	
		$("#zip_type_select").append(chiliOptionHTML);
		
		//raise the options counter
		zipDocTypeCount++;
	}	
	
	//now expose a valid doc type controls for ZIP/PDF doc type
	if (pdfDocTypeCount == 1)
	{
		//as there is only a single option -> just show the appropriate label instead of a selector
		$("#pdf_type_select_TD").empty();
		
		//get helper hidden input to write the current doc type value
		var actualLabel = "";
		var hiddenPDFDocTypeInput = document.getElementById("singlePDFDocType");
		
		if (hiddenPDFDocTypeInput)
		{
			if (gIsPDFFileAsGraphic && gIsGraphicsDocEnabled)
			{
				actualLabel = docTypeLabels[0];
				hiddenPDFDocTypeInput.value = 'graphic';
			}
			else
			if (gIsPageListDocEnabled)
			{
				actualLabel = docTypeLabels[1];
				hiddenPDFDocTypeInput.value = 'pagelist';
			}
			else
			if (gIsOtherDocTypeEnabled)
			{
				actualLabel = docTypeLabels[4];
				hiddenPDFDocTypeInput.value = 'other';
			}
		
			//write the appropriate label into the container TD
			if (actualLabel.length > 0)
			{
				$("#pdf_type_select_TD").text(actualLabel);
			}	
		}
	}
	
	if (zipDocTypeCount == 1)
	{
		//as there is only a single option -> just show the appropriate label instead of a selector
		$("#zip_type_select_TD").empty();
		
		//get helper hidden input to write the current doc type value
		var actualLabel = "";
		var hiddenZIPDocTypeInput = document.getElementById("singleZIPDocType");
		
		if (hiddenZIPDocTypeInput)
		{
			if (gIsZIPFileAsGraphic && gIsGraphicsDocEnabled)
			{
				actualLabel = docTypeLabels[0];
				hiddenZIPDocTypeInput.value = 'graphic';
			}
			else
			if (gIsOtherDocTypeEnabled)
			{
				actualLabel = docTypeLabels[4];
				hiddenZIPDocTypeInput.value = 'other';
			}
		
			//write the appropriate label into the container TD
			if (actualLabel.length > 0)
			{
				$("#zip_type_select_TD").text(actualLabel);
			}
		}		
	}
	
	//build up a list of supported ArtiosCAD Document file extensions
	if (gIsCADDesignDocEnabled)
	{
		//add all the generally supported Artios CAD Design File extensions
		gArtiosCADFileExtList.push('.ARD');
		gArtiosCADFileExtList.push('.CF2');
		gArtiosCADFileExtList.push('.CFF2');
		gArtiosCADFileExtList.push('.DS2');
		gArtiosCADFileExtList.push('.DD3');
		gArtiosCADFileExtList.push('.DXF');
		gArtiosCADFileExtList.push('.DWG');
		gArtiosCADFileExtList.push('.SCB');
		gArtiosCADFileExtList.push('.VLM');
	}
	
	if (gIsCADManufacturingDocEnabled)
	{
		gArtiosCADFileExtList.push('.MFG');
	}
	
	if (gIsCAD3DDocEnabled)
	{
		gArtiosCADFileExtList.push('.A3D');	
	} 
	
	if (gIsCADCanvasDocEnabled)
	{
		gArtiosCADFileExtList.push('.ACD');	
	} 
	
	//add URL option to the dropdown list of potential Upload Types
	if (gIsURLDocTypeEnabled)
	{
		var uploadTypeOptionHTML = '<option value="doc_source_url">'+langStrings.urlSourceType+'</option>';	
		$("select#Select_Source_Type").append(uploadTypeOptionHTML);
	} 
	//add Component option to the dropdown list of potential Upload Types
	if (gIsComponentDocTypeEnabled)
	{
		var uploadTypeOptionHTML = '<option value="doc_source_component">'+langStrings.componentSourceType+'</option>';	
		$("select#Select_Source_Type").append(uploadTypeOptionHTML);
	} 
}

/**
* Performs frontend validation of 'Add Document' page form fields.
* 
* This function assumes all asynchronous work is already done! 
* Make sure window.docTableObj and attribute category in document.getElementById("DocAttributesContainer") are fully loaded
* before calling this method!
**/
function ValidateUploadFormParams()
{  
	//first validate whether some target Project and Folder was selected
	if (!ValidateDestinationValues()) 
	{
		return false;
	}
	

	//check document source fields (based on the current 'Upload Doc. Source Type')
    var curUploadDocSourceTypeValue = document.actionform.uploadType.value;
	
    //validate 'Single Doc. Upload' form fields  
    if (curUploadDocSourceTypeValue == "single")
    {
    	//check what Upload Mode is currently in effect (single/multi)
    	var uploadTypeVal = $("#Select_Source_Type").val();
 
    	//validate description
    	if (!validateDocDescription(document.actionform.doc_description.value))
		{
    		alert(langStrings.errdescription);
    		return false;
    	}

		if (uploadTypeVal == "doc_source_browse")
		{
			if (isWhitespace(document.actionform.docFileInput.value))
			{
				//'doc file BROWSE field' is empty
				alert(langStrings.emptyFileUploadField);
       			return false;
			}
			else
			{
				//check for special doc type upload 
				var curUploadDocType = document.actionform.selectedDocType.value;
				
				//PAGELIST doc type upload
				if (curUploadDocType == "pagelist")
				{
					//check value of the 'Index of first page' field
					if (isWhitespace(document.actionform.Pagelist_Index.value))
					{
						//no value at all
						alert(langStrings.invalidPagelistStartIndexVal);
       					return false;
					}
					else
					//do have value - validate it! - has to be a positive INT (erroMsg is already )
					if (!validateStrictPositiveInt(document.actionform.Pagelist_Index, langStrings.invalidPagelistStartIndexVal))
					{
						return false;
					}
				}
				else
				//CAPE doc type upload
				if (curUploadDocType == "cape")
				{
					var ClfName = document.actionform.docFileInput.value;
					
					// Check for zipped cape file.
					var zippedcape = false;
					if ( (ClfName.toUpperCase()).lastIndexOf(".ZCP") === ClfName.length-4 )  
        			{
						zippedcape = true;
        			}
					
					//an additional 'XML File' needs to be specified as well (-> the 'Report/Diagram' file is optional though)
					if (!zippedcape && isWhitespace(document.actionform.capeDocXMLFile.value))
					{
						//'Cape XML File' input is empty
						alert(langStrings.emptyCapeXMLFileField);
       					return false;
					}
					
					if(!zippedcape) {
	        			var XmlName = document.actionform.capeDocXMLFile.value;
	        			var ReportName = document.actionform.capeDocReportFile.value; 
						
						// Check extensions of the Cape files
	        			if ( (ClfName.toUpperCase()).lastIndexOf(".CLF") != ClfName.length-4 )  
	        			{
	          				window.alert(langStrings.badCapeCLFZCPFileExt);
	          				return false;        
	        			}
	        			if ( (XmlName.toUpperCase()).lastIndexOf(".XML") != XmlName.length-4 )  
	        			{
	            			window.alert(langStrings.badCapeXMLFileExt);
	            			return false;        
	        			}        
	        			if ( !isWhitespace(ReportName) )
	        			{
	          				// If a report was specified, it must have a PDF or JPG extension
	          				if ( (ReportName.toUpperCase()).lastIndexOf(".JPG") != ReportName.length-4 
	          					 &&
	          					 (ReportName.toUpperCase()).lastIndexOf(".PDF") != ReportName.length-4
	          				   )  
	          				{
								window.alert(langStrings.badCapeReportFileExt);
					            return false;
	            			}          
				        }
					}
				}
				
			}
		}
		else
		if (uploadTypeVal == "doc_source_copy" && isWhitespace(document.actionform.Select_SourceCopyDoc.value))
		{
			//'Copy Document Source' field is empty
			alert(langStrings.emptyCopyDocField);
       		return false;
		}
		else
		if (uploadTypeVal == "doc_source_new" && isWhitespace(document.actionform.Select_SourceNewDoc.value))
		{
			//'Template Document Source' field is empty
			alert(langStrings.emptyTemplateDocField);
       		return false;
		}
		else
		if (uploadTypeVal == "doc_source_url" && isWhitespace(document.actionform.Input_SourceURLDoc.value))
		{
			//'URL Document String' field is empty
			alert(langStrings.emptyTDocURLField);
       		return false;
		}
		
        // Check BOM count
        if ($('#AddToBOM').prop('checked')) {
        	if (!validateBOMCounts()) {
        		return false;
        	}
        }
        
        //also check attributes, whether they are all OK before handling the doc. upload
        var docACatObj = document.getElementById("DocAttributesContainer");
		if (gTempDocWithAttributesSelected && docACatObj && docACatObj.ACatObj){
			if (!docACatObj.ACatObj.syncPrepareForSubmit()){
				//attributes were not validated successfully (alert window was already displayed - just bail out)
				return false;
			}
		}
		
		//check for a value within the 'NAME' field (valid only for some 'upload sourcew types')
		// put this check as last (where validation can no longer fail), as it changes the name field when successful. 
		var unzipArchive = document.getElementById("doUnzipArchive") && document.getElementById("doUnzipArchive").checked;
		
		// check unique document names
		if(window.eventBasedValidator){
			var validObj = window.eventBasedValidator.createUniqueNamesObj();
			
			if($("#Doc_Name").val() && !gCurrentlyUseAutoname && !unzipArchive){
				validObj.addDoc($("#Doc_Name"), document.actionform.targetProjectID.value);
			}

			window.eventBasedValidator.validateNamesGlobally(validObj);
			if(!validObj.isOk()){
				return false;
			}
		}

        if ((uploadTypeVal == "doc_source_browse" || uploadTypeVal == "doc_source_copy" || uploadTypeVal == "doc_source_new" || uploadTypeVal == "doc_source_component") && (!gCurrentlyUseAutoname  && !unzipArchive && isWhitespace(document.actionform.Doc_Name.value)))
        {
        	alert(langStrings.blankDocName);
        	return false;
        }else if((gCurrentlyUseAutoname || unzipArchive) && isWhitespace(document.actionform.Doc_Name.value)){
        	document.actionform.Doc_Name.style.color = "#FFFFFF";
        	document.actionform.Doc_Name.value = "[Name Suffix]";
        }
    }
    else {
    	var debug = false;
    	if(window.docTableObj){
    		var validObj = {
    			isTemplate : this.isTemplate,   // support for special behavior in a template (context)
   	    		errors : [],   // array of error objects containing: 
   	    					   // 'level', 'element', docRowObj and 'msg' or 'attrLabel' members
	    		isOK : function() {   // function returning true if no problem found during validation
	    			return (this.errors.length == 0);
	    		}, 
	    		newDocs: [],
	    		newDocsDOMElems: {}
	    	};
    		window.docTableObj.validateDocTable(validObj);
    		if (!validObj.isOK()) {
    			return false;
    		}
    		if(window.docTableObj.getNumberOfRows() === 0){
    			//validateDocTable doesn't check whether it actually has rows or not
    			alert(langStrings.selectAtLeastOneDoc);
    			return false;
    		}
    	} else {
    		// the old documents table implementation is no more used on (multi)Document Upload page!
		}
    }
    
    return true;
}

function ValidateDestinationValues()
{
	if (isWhitespace(document.actionform.targetProjectID.value))
	{
		//'Target Project' ID reference is empty
		alert(langStrings.emptyTargetProjectField);
       	return false;
	}
	
	if (isWhitespace(document.actionform.targetFolderID.value))
	{
		//'Target Project Folder' ID reference is empty
		alert(langStrings.emptyTargetProjectFolderField);
       	return false;
	}
	
	return true;
}

//
// Multi Doc Upload mode --> validates document row whether the selected document is of a known/supported document type
// needs the follwing global vars. to be initialized (done in addnewdocument.xsl): gIsGraphicsDocEnabled; gIsPageListDocEnabled; gIsOtherDocTypeEnabled; gIsCapeDocEnabled; gArtiosCADFileExtList; gGraphicalFileExtList
//
function validateDocTypeSupport(type, index)
{
	if ( type == 'Browse' ) // browse
	{
		var docfile = document.getElementById("documentFileNameId"+ index );
		if (docfile)
		{
			var docFileName = docfile.value;
			//get the MIME type (file exentsion)
			var mimeType = docFileName.substr(docFileName.lastIndexOf('.')).toUpperCase(); 

			if (mimeType != null && mimeType != "")
			{
				//now check the actual extension whether it matches the supported doc types
				var isCurFileExtGraphic = IsGraphicalExtension(mimeType);
				
				//check for supported MIME types
				//GRAPHIC DOCUMENT
				if 
				(gIsGraphicsDocEnabled && isCurFileExtGraphic && mimeType != ".ZIP" && mimeType != ".PDF")
				{
					return true;
				}
				else
				//PDF - Graphic Document / MultiPage PDF Document
				if (mimeType == ".PDF" && ( ( gIsGraphicsDocEnabled &&  isCurFileExtGraphic ) || gIsPageListDocEnabled ) )
				{
					return true;
				}
				else
				//ZIP FILE
				if ( mimeType == ".ZIP" && ( ( gIsGraphicsDocEnabled && isCurFileExtGraphic ) || gIsOtherDocTypeEnabled ) )
				{
					return true;
				}
				else
				//ARTIOS CAD DESIGN DOCUMENT
				if (IsArtiosCADDocument(mimeType))
				{
					return true;
				}
				else
				//CAPE DOCUMENT
				if (mimeType == ".CLF" && gIsCapeDocEnabled)
				{
					return true;
				}
				else
				//ZIPPED CAPE DOCUMENT
				if (mimeType == ".ZCP" && gIsCapeDocEnabled)
				{
					return true;
				}
				else
				//OTHER DOCUMENT
				if (gIsOtherDocTypeEnabled)
				{
					return true;
				}
				else
				//UNKNOWN DOCUMENT TYPE -> let the User know that he cannot upload such a file
				{
					return false;
				}
			}
			else
			{
				//cannot process file extension 
				return false;
			}
		} 
		else
		{
			//cannot process file extension 
			return false;
		}
	}
	
	return true;
}

//
// Multi Doc Upload mode --> validates document row whether the selected document is of a known/supported document type
// needs the follwing global vars. to be initialized (done in addnewdocument.xsl): gIsGraphicsDocEnabled; gIsPageListDocEnabled; gIsOtherDocTypeEnabled; gIsCapeDocEnabled; gArtiosCADFileExtList; gGraphicalFileExtList
//
function getDocType(type, index)
{
	if ( type == 'Browse' ) // browse
	{
		var docfile = document.getElementById("documentFileNameId"+ index );
		if (docfile)
		{
			var docFileName = docfile.value;
			//get the MIME type (file exentsion)
			var mimeType = docFileName.substr(docFileName.lastIndexOf('.')).toUpperCase(); 

			if (mimeType != null && mimeType != "")
			{
				return getDocTypeID(mimeType);				
			}
			else
			{
				//cannot process file extension 
				return '';
			}
		} 
		else
		{
			//cannot process file extension 
			return '';
		}
	}
	return '';
}


function CancelButtonClicked()
{
	//set the action value of the actionform
	document.actionform.actionVal.value = "CancelDocumentUpload";
	document.actionform.action = "doprojectactions.jsp";
	// keep POST as the form can have too many parameters for a GET (will fail in IIS) if there is an advanced attribute category
	// document.actionform.method = "get";
	
	// Firefox has problems with submitting forms without clicking a submit button.
	// It only seems to go wrong when using document references as it uses removing of DOM elements heavily and it seems to trigger the problem.
	// Because forms are consistently being used wrongly in WebCenter, we cannot fix it everywhere, so we add a hack on affected places.
	var mainForm = $(document.actionform);
	if (mainForm.find(".forceSubmit").length === 0) {
		mainForm.append('<input type="submit" class="forceSubmit displayNone" />');
	}
	mainForm.find(".forceSubmit").trigger("click");
}

function FollowUploadAppletLink()
{
	if (ValidateDestinationValues())
	{
		var targetProjectID = document.actionform.targetProjectID.value;
		var targetProjectFolderID = document.actionform.targetFolderID.value;
		var menuFileValue = document.actionform.menu_file.value;
		var targetTaskID = document.actionform.targetTaskID.value;

		
		//forward to the 'Java Upload Applet' container page
		var appletJspURL;
		if (targetTaskID != null && targetTaskID.length > 0)
			appletJspURL = "projdetailswctaskuploadmultidocs.jsp?curProjTaskID=" + targetTaskID + "&";
		else
			appletJspURL = "projdetailsdocsadddocapplet.jsp?";
		appletJspURL += "projectID=" + targetProjectID;
		if (targetProjectFolderID != null && targetProjectFolderID.length > 0 && targetProjectFolderID != 'ROOT' && targetProjectFolderID !== 'DEFAULT')
		{
			if (targetTaskID != null && targetTaskID.length > 0)
				appletJspURL += "&curFolderID=" + targetProjectFolderID;
			else
				appletJspURL += "&folderID=" + targetProjectFolderID;
		}
		if (menuFileValue != null && menuFileValue.length > 0)
		{
			appletJspURL += "&menu_file=" + menuFileValue;
		}
		
		window.location.href = appletJspURL;
	}	
}

/**
* If the original label exceeds $labelLengthLimit characters, modify it (drop the middle part) to slim the size to an acceptable level
**/
function ProcessSelectBoxItemLabel(originalLabel, labelLengthLimit)
{
	try 
	{
		var resultLabel = "";
	
		if (originalLabel != null && labelLengthLimit != null)
		{
			//if the original label doesnt exceed the 'label length limit', return it as it is
			if (originalLabel.length < labelLengthLimit+1)
			{
				//dont need to modify the label
				resultLabel = originalLabel;
			}
			else
			if (originalLabel.length > labelLengthLimit)
			{
				//compute the preffered length of the start and finish parts of the label
				var startLabelLength = labelLengthLimit / 2;
				var finishLabelLength = (labelLengthLimit / 2) - 3;
			
				var labelStart = originalLabel.substring(0, startLabelLength);
				var labelFinish = originalLabel.substring(originalLabel.length-finishLabelLength, originalLabel.length);
			
				//alert ("Orig. label length - " + originalLabel.length + "; start label part length - " + labelStart.length + "; finish label part length - " + labelFinish.length);
			
				//create the result label
				resultLabel = labelStart + "..." + labelFinish;
			}
		}
	
		return resultLabel;
	}
	catch (err) 
	{
		//HADW: whatever goes wrong, send back the original thing
		return originalLabel;  
	}
}

function uploadAjaxCallSessionExpired()
{
	//construct the "source page" URL
	var urlWantedString = "addnewdocument.jsp";
			
	var firstParamAdded = false;

	//try to append the ProjectID parameter
	if (gProjectID != null && gProjectID.length > 0)
	{
		firstParamAdded = true;
		urlWantedString += "?projectID=" + gProjectID;
					
		//try to append the FolderID parameter
		if (gDestFolderID != null && gDestFolderID.length > 0)
		{
			urlWantedString += "&folderID=" + gDestFolderID;
		}
	}
				
	//try to append the menu_file parameter
	if (document.actionform.menu_file.value.length > 0)
	{
		var connector = "";
		if (firstParamAdded)
		{
			connector = "&";
		}
		else
		{
			connector = "?";
		}
					
		urlWantedString += connector + "menu_file=" + document.actionform.menu_file.value;
	}
				
	var loginPageURL = "login.jsp?urlwanted="+ WCXML.urlencode(urlWantedString);
            
	//forward to the login page
	window.location.href = loginPageURL;
}

/* 
* This function shows the following form fields - depending on the doucment: 
*  - document name form field
*  - attribute when category is known
*  - approval toggles. There is a project dependency here. If the target project does not have approval rule, we should not show the approval fields
*  - doc type (browse, source): in this case, it is always the new type, and we do not show the controls
**/ 
function showDocumentElements()
{
	if (!gIsCopyDocument)
		return ; // we should not come here
		
	// only when project is selected 
	// LoadProjectFolderApprovalRule(); 	
    
    ToggleDocNameRow(true);	 // show doc name row
    
    ToggleDocTypeLabelRow(false);
	
	
	
	//hide the 'Multi Doc. Upload' row
   	toggleDocUploadDetailsRow(false, "MultiDocUploadFieldsRow");
      
    //show the the 'Single Doc. Upload' row
   	toggleDocUploadDetailsRow(true, "SingleDocUploadFieldsRow");
	
		//show the 'Select Doc to be Copied' TD
		$("#DocSourceRow").hide();
		$("#docFileInputTD").hide();
		$("#docCopySelectTD").hide();
		$("#docNewSelectTD").hide();
		$("#docURLSelectTD").hide();
		
		
		//show Doc Name field		
		ToggleDocNameRow(true);
		
		//show Approval Cycle controls (if available)
		ToggleApprovalCycleControls(true);
		
		//do not show 'Document Type' row
		ToggleDocTypeLabelRow(false);
		
		//hide the 'Extra Temp. Doc.' select row (as it is redundant in this upload mode)	
		ToggleExtraTemplateDocRow(false);
		
		//show Doc Name field		
		ToggleDocNameRow(true);
		
		//show Approval Cycle controls (if available)
		ToggleApprovalCycleControls(true);
	
	
	var docName = $("#Doc_Name")[0].value;
	if (docName == '')
		// initialize it with the document name
		$("#Doc_Name")[0].value = gDocumentName;
	
	var docDescription = $("#doc_description")[0].value;
	if (docDescription == '')
		// initialize it with the document name
		$("#doc_description")[0].value = gDocumentDescription;
	
	
	// show the att category when there is one given
	if (gDocVersionCatID!=null && gDocVersionCatID.length > 0 ) 
	{
		LoadTemplateDocumentAttributes(null);
		ToggleDocumentAttributesRow(true);
	}
	else 
		ToggleDocumentAttributesRow(false);
	
	// load the document thumbnail 
	

	// Show upload button
	$("#UploadButton").show();
	$("#UploadButtonSpacer").show();	  	
	
	ToggleTextContentCheckBox();
	
	return ;
	
}


/* 
* This function shows the checkbox to 'retain text content status' - depending on the doucment: 
*/ 

function ToggleTextContentCheckBox()
{	
	var docNameInputValue = document.actionform.Doc_Name.value;
	if (null != docNameInputValue) {
		var lowerCased = docNameInputValue.toLowerCase();
		if (lowerCased.indexOf('.wcc') > -1 || lowerCased.indexOf('.wtc') > -1) {
			$('#retainTextContentElementId').show();
		} else {
			$('#retainTextContentElementId').hide();
		}
	}
}


/*
* author: JAMI
* since: 17.5.2011
*
* This functions enables/disables 'main form control buttons' (Submit + Cancel)
* NOTE: the buttons are referenced by their ID : for HTML definition please see addnewdocument.xsl
*/
function EnableMainButtons(enable)
{
	$('#UploadButton').prop('disabled', !enable);
	$('#CancelButton').prop('disabled', !enable);
}

