/**
*	@author: RIMC, JAMI, JANH. 
* 	recently commented by HADW
**/
var gDocumentCounter = 0;
var gDocumentRowIds = new Array(); // Array containing a list of all the checkboxes
var gProjectOptionsHTML = null;
var gHasNewDocumentOption = false;
var gHasLinkBrowseDocumentOption = true;
var gHasLinkSelectDocumentOption=false;
var gHasCopyDocumentOption = true;
var gHasListDeleteOption = true;
var gExistingProjectContext = false;

var gCharacteristicsTree = null ; 

var gTemplateDocsLoaded = false;
var gTemplateDocumentList = null; // Array to store Template Documents. Will be accessed by Documents table
var gTemplateProjectID; // The Id of the 'template documents container project'
var gUploadProjectID = null; // Id of the target Project where Documents should be uploaded (null if Project Creation context)
var gHasTemplateDocuments = false;

var gDocumentTemplateSelectionInitialized = false ;
var gTemplateDocumentThumbnailList = null ; 
var gVisibleSelects = null; // remember which selects were visible when hiding them to avoid IE popup shine-through

var gDocTypeConfigUseCategory = false;
var gDocTypeConfigs = new Array();

var gProjectsWithDocumentsDataProvider = null;
var gDocumentDataProviders = {};
var gTargetFolderActions = [];  // array of default folders to be set when the folders are loaded  (in projdetailsbom.js, there is a brother gBOMTargetFolderActions

//adding reference to TaskExecutionPage JS Object (used only on TEP)
var taskExPage;

//load EventBasedValidator
require(["utils/EventBasedValidator"],function(EventBasedValidator){
	EventBasedValidator.getInstance();
});

/** Add a document row to the document table
 * @param {String} docSourceType - the type of the upload
 *  0 : Browse
 *  1 : Copy
 *  2 : New	
 *  3 : Link	
 *  4 : CreationCopy: copy from parameter value (create project from search results)	
 *  5 : Search
 * @param {DOM element} greenLinkElem - DOM element of Document Link (often green) that was clicked by the user. (if known)
 * 		It contains Document Link Object (from DocumentSourceHandler.docSources array) defining current doc. source.
 * @param {Object} dlsObj - Document Link Object (from DocumentSourceHandler.docSources array) defining current doc. source. (if known)
 */
function addRow(docSourceType, greenLinkElem, dlsObj) {	
	try {
		var targetFolderName = "";
		var label = "";
		var docTemplateType = "";
		var docTemplateName = "";
		
		// get the particular Document Link Source, stored in one of the function params
	    if (!dlsObj && greenLinkElem) dlsObj = greenLinkElem.dlsObj;
	    if (dlsObj) {
			targetFolderName = dlsObj.targetFolder;
			label = dlsObj.label.getLabel();	
			docTemplateType = dlsObj.docTemplateType;
			docTemplateName = dlsObj.docTemplateName;
	    }
	
		gDocumentCounter++;
		gDocumentRowIds.push("documentRowId" + gDocumentCounter);
		
		var htmlString = '<tr id="documentRowId' + gDocumentCounter + '">';
		if (gHasListDeleteOption) {
			htmlString += '<td class="hideShowListDelete" align="center" valign="middle" width="25"><input type="checkbox" value="ON" onclick="updateDocumentAllSelection();"/></td>';
		}
		htmlString += '<td align="center" valign="middle" width="25"><i id="documentAttributesShowIconId' + gDocumentCounter + '" class="icon icon-normal icon-WCR_Plus-square12" title="' + WCXML.xmlencode(langStrings.expand) + '" onclick="showDocumentAttributes(' + gDocumentCounter + ');"></i><i id="documentAttributesHideIconId' + gDocumentCounter + '" class="icon icon-normal icon-WCR_Minus-square12" title="' + WCXML.xmlencode(langStrings.collapse) + '" onclick="hideDocumentAttributes(' + gDocumentCounter + ');" style="display:none"></i></td>';
		
		// Show source selector. Contains the dropdown but also a placeholder for the remaining controls (initialized always to browse controls, then changed at the end of addRow by setDocumentType
		// Also adds the template selector column if applicable
		//htmlString += documentColumn(gDocumentCounter, gHasCopyDocumentOption, gHasLinkBrowseDocumentOption, gHasLinkSelectDocumentOption, gHasNewDocumentOption, gHasNewDocumentOption);	
		htmlString += documentColumnNew(gDocumentCounter, gHasNewDocumentOption, docTemplateType, docTemplateName, docSourceType);
		
		// Folder column
		// if the given page doesn't support "Folder" column, simply don't initialize it
		if (typeof gProjectFolders != "undefined") 
		{
			htmlString += '<td class="hideShowFolderColumn"><select name="documentFolder' + gDocumentCounter + '" id="documentFolderId' + gDocumentCounter + '" class="filter" style="font-size:10px;" onchange="changeDocumentFolder(this, ' + gDocumentCounter + ');">' + makeProjectFoldersOptionsString(gDocumentCounter) + '</select>';
			htmlString += '<input type="hidden" name="selectedDocumentFolderName' + gDocumentCounter + '" id="selectedDocumentFolderName' + gDocumentCounter + '" value="Default"/>';
			htmlString += '</td>';
		}
		
		// document Name column
		htmlString += '<td ><input name="documentName' + gDocumentCounter + '" id="documentNameId' + gDocumentCounter + '"';
		if (!gHasNewDocumentOption)htmlString += ' size="40"';
		htmlString += '/><input type="hidden" name="documents" value="' + gDocumentCounter + '"/><input type="hidden" name="folderName' + gDocumentCounter + '" id="folderNameId' + gDocumentCounter + '" value=""/></td>';
		
		// document description column
		htmlString += '<td><input name="documentDescription' + gDocumentCounter + '" id="documentDescriptionId' + gDocumentCounter + '"';
		if (!gHasNewDocumentOption) htmlString += ' size="40"';
		htmlString += '/></td>';
		htmlString += '<td align="center" valign="middle" width="25"><a href="#" onclick="javascript:deleteEntry(\'documentRowId' + gDocumentCounter + '\'); return false;"><i class="icon icon-normal icon-WCR_Remove12 btn btn-no-border" title="' + WCXML.xmlencode(langStrings.del) + '" width="15" height="15"></i></a></td>';
		htmlString += '</tr>';
	
		showHideAddDocumentOptions();
		
		if (gHasNewDocumentOption || gDocTypeConfigUseCategory )
		{
			htmlString += '<tr id="documentRowId' + gDocumentCounter + 'Attributes" style="display:none">';
			if (gHasListDeleteOption)
				htmlString += '<td/>';
	
			var attrcolspan = 6;
			if (gHasListDeleteOption) attrcolspan++;
			if (gHasNewDocumentOption) attrcolspan++;
			if (typeof gProjectFolders != "undefined") attrcolspan++;
			htmlString += '<td id="documentAttrsCellSpanId' + gDocumentCounter + '" colspan="'+attrcolspan+'"><div id="documentDivId' + gDocumentCounter + 'Attributes" /></td></tr>';
		}
		
		$("#documentsTableId > tbody").filter(".documentsList").append(htmlString);
		$("#documentsTableId > tbody").filter(".documentsList").show();
			
		// store Document Link Source object in the row <tr> element in property 'dlsObj'
		var rowIDElem = document.getElementById("documentRowId" + gDocumentCounter);
		if (rowIDElem && dlsObj) rowIDElem.dlsObj = dlsObj;
			
		// update the folder name hidden field
		if ($('#documentFolderId' + gDocumentCounter).length > 0)
			$('#documentFolderId' + gDocumentCounter).trigger("change");
		
		// handle visibility of "Folder" column appropriately
		hideShowFolderColumns();
	
		// switch to the correct type
		var docSourceTypeValue = "Browse"; // default value
		if (docSourceType === 1)
			docSourceTypeValue = "Copy" ;
		else if (docSourceType === 2 )
			docSourceTypeValue = "New" ;
		else if (docSourceType === 3 )
			docSourceTypeValue = "Select" ;  // source currentProject, Link to task type or Link to BOM depending on context
		else if (docSourceType === 4 )
			docSourceTypeValue = "CreationCopy" ; // when doing create project from an asset browser
		else if (docSourceType === 5 )
			docSourceTypeValue = "Search" ; 
		else if (docSourceType === 6 )
			docSourceTypeValue = "Move" ; 
		else if (docSourceType === 7 )
			docSourceTypeValue = "Link" ;   // Copy as link
	
		setDocumentType(docSourceTypeValue, gDocumentCounter, label);

		// Specifically used for Browse and Select from Project Fixed Template	
		if ((docSourceType == 0 || docSourceType == 1) && dlsObj.docTemplateType == 'FixedDocTemplate') {
			var templId = $("#documentTemplateId" + gDocumentCounter)[0];
			// If there's been an invalid template name typed in the config page
			// we don't want to attempt to get any attributes
			if (templId) {
				getDocumentAttributes(templId, gDocumentCounter);
			}
		}
		
		if (targetFolderName) {
			if ((typeof gProjectFolders != "undefined") && gProjectFolders) {
				$("#documentFolderId" + gDocumentCounter + " option").each ( function (index) {
					if ( $(this).text() && $(this).text().toLowerCase() == targetFolderName.toLowerCase()) {
						$(this).prop('selected', true);
						$("#selectedDocumentFolderName" + gDocumentCounter).val($(this).text());  // set hidden field, but only when you find a match
					}
				});
			} else {
				// dropdown with projects and folders is not yet loaded --> add to the list of things to do after it loads
				gTargetFolderActions.push({id: 'documentFolderId' + gDocumentCounter , folder:targetFolderName, hiddenId: 'selectedDocumentFolderName' + gDocumentCounter} );
			}
		}
	} catch (err) {
		alert('Problem in DocumentsTable.addRow() method at line ' + err.lineNumber + ' : ' + err.message);
	}
}


/**
* creates HTML for the document table columns
* Called both for BOM as normal document tables. In case of BOM, counter will typically start with BOM
* @param {String} counter - suffix for id's and names of the elements, typically containing an enumeration Number
* @param {Boolean} hasselecttemplate - true if a document template selector must be created
* @param {String} docTemplateType - 'NoDocTemplate', 'FixedDocTemplate', 'ListDocTemplate', 'AnyDocTemplate' 
* @param {String} docTemplateName - For 'FixedDocTemplate' & 'ListDocTemplate' contains template name(s)
* @param {Integer} docSourceType
*/
function documentColumnNew(counter, hasselecttemplate, docTemplateType, docTemplateName, docSourceType){
	var htmlString = '';
	try {
		// placeholder for the operator (Copy, Move, Link, ...)
		htmlString = '<td nowrap="nowrap" id=documentType' + counter + ' valign="center"/>';	
			
		// Placeholder for the specific document selection fields
		htmlString += '<td id="documentSelectionColId' + counter + '">' + generateDocInputField(counter) + '</td>';

		// template selector column. 
		if (hasselecttemplate) {
			if (docSourceType == 6 || docSourceType == 7) {
				// Not required for Move (6) or Link (7). 
				// Not sure why hasselecttemplate is true for 6 or 7, but it is. 	
				htmlString += '<td></td>';			
			}
			else if (docSourceType == 2) { 
				// New (2) = Document Template Selector has been chosen
				// Don't allow a drop down to be displayed as we don't want users changing the template
				if (docTemplateType == 'NoDocTemplate') {
					// The project has templates but the template selector for the row may be set to 'NoDocTemplate' 
					htmlString += '<td></td>';			
				} else {
					// No need to set values for the span or hidden field here as they're done in the preSelectSourceDocument() function
					htmlString += '<td nowrap="nowrap" class="hideShowAttribute" id=\"documentTemplateNameTD' + counter + '">';
					htmlString +=  '<span id="documentTemplateName' + counter + '" class="darktext_greenlink_11 nobr" />';														
					htmlString += '<input type="hidden" name="documentTemplate' + counter + '" id="documentTemplateId' + counter + '" value=""/></td>';
				}				
			} else if (docTemplateType == 'FixedDocTemplate') { 
				// Other Non Document Template Selectors with a fixed template
				var found = false;
				var allowedTemplateName =  docTemplateName.replace(/^\s+|\s+$/g, '').toLowerCase();
				for(var i = 0; i < gTemplateDocumentList.length; i++) {
					var curPreprocessedTempDocNameLower = gTemplateDocumentList[i].name.toLowerCase();
					if (allowedTemplateName == curPreprocessedTempDocNameLower) { 
						$("#documentTemplateName" + counter).text(gTemplateDocumentList[i].name);
						htmlString += '<td nowrap="nowrap" class="hideShowAttribute" id=\"documentTemplateNameTD' + counter + '">';
						htmlString +=  '<span id="documentTemplateName' + counter + '" class="darktext_greenlink_11 nobr" >' + gTemplateDocumentList[i].name + '</span>';														
						htmlString += '<input type="hidden" name="documentTemplate' + counter + '" id="documentTemplateId' + counter + '" value="' + gTemplateDocumentList[i].id + '"/></td>';
						found = true;
						break;
					}
				}
				if (found === false) {
					htmlString += '<td></td>';
				}
			} else { 
				// All other templates. Display a dropdown as users may want to change the template
				if (docTemplateType == 'NoDocTemplate') {
					// The project has templates but the template selector for the row may be set to 'NoDocTemplate' 
					htmlString += '<td></td>';			
				} else if (docTemplateType == 'ListDocTemplate') {
					// The project has one or more specified document templates to choose from
					var docArr = new Array();
					if (gTemplateDocumentList != null && gTemplateDocumentList.length > 0) { 
						var nameArr = docTemplateName.split(",");						
						if (nameArr.length == 1) namelArr = docTemplateName.split(';');  // allow splitting with , or ;
						if (nameArr != null && nameArr.length > 0) { 
							for (var i = 0 ; i < nameArr.length ; i++ )
							{
								var allowedTemplateName = nameArr[i];
								allowedTemplateName = allowedTemplateName.replace(/^\s+|\s+$/g, '').toLowerCase();
								for (var j = 0 ; j < gTemplateDocumentList.length ; j++ )
								{
									var curPreprocessedTempDocNameLower = gTemplateDocumentList[j].name.toLowerCase();
									if (allowedTemplateName == curPreprocessedTempDocNameLower) { 
										docArr.push(gTemplateDocumentList[j]);
										break;
									}
								}						
							}
						}
					}
					if (docArr.length > 0) {
							htmlString += '<td nowrap="nowrap" class="hideShowAttribute" id=\"documentTemplateNameTD' + counter + '">';
							htmlString += '<select name="documentTemplate' + counter + '" id="documentTemplateId' + counter + '" class="filter" onchange="getDocumentAttributes(this, \'' + counter + '\'); setFolderName(this, \'' + counter + '\');">' + makeDocumentsOptionsString(docArr) + '</select></td>';						
					} else {
						htmlString += '<td></td>';							
					}
				}
				else {
					// AnyDocumentTemplate chosen
					htmlString += '<td nowrap="nowrap" class="hideShowAttribute" id=\"documentTemplateNameTD' + counter + '">';
					htmlString += '<select name="documentTemplate' + counter + '" id="documentTemplateId' + counter + '" class="filter" onchange="getDocumentAttributes(this, \'' + counter + '\'); setFolderName(this, \'' + counter + '\');">' + makeTemplateDocumentsOptionsString() + '</select></td>';
				}
			}
		}
	} catch (err) {
		alert('Problem in DocumentsTable, documentColumn at line ' + err.lineNumber + ': ' +  err.message );
	} 
	
	return htmlString;
}

/**
 * Helper function to generate HTML for file input field. 
 * It's in a separate method, because it's used in changeFileName() function to reset file input field 
 * after wrong user input too. 
 * @param {String} counter - suffix for id's and names of the elements, typically containing an enumeration Number
 */
function generateDocInputField(counter) {
	return '<input type="file" name="documentFileName' + counter + '" id="documentFileNameId' + counter + '" size="30" onchange="changeFileName(\'' + counter + '\');"/>';
}


function showHideAddDocumentOptions() {
	if ($("#newDocument") !=null) {
		if (gHasNewDocumentOption == true ) {
			$("#newDocument").show();
		} else {
			$("#newDocument").hide();
	}
	}
	
	if ($("#LinkDocument") !=null) {
		if ( gHasLinkSelectDocumentOption == true ) {
			$("#LinkDocument").show();		
		} else {
			$("#LinkDocument").hide(); 	
	}
	}
	
	if ($("#CopyDocument") !=null) {
		if ( gHasCopyDocumentOption == true ) {
			$("#CopyDocument").show();		
		} else {
			$("#CopyDocument").hide(); 	
	}
	}
}



// This function will update the 'Name' according to the selection in the drop down box (typically needed for New)
function updateNameToTemplateSelection (counter) {
	var documentTemplateId = "#documentTemplateId" + counter ;  
	var documentNameId = "#documentNameId" + counter ;  
	var documentTemplateName = "#documentTemplateName" + counter ;  

	var sourceDocumentID =$(documentTemplateId)[0].value;
	var sourceDocumentVersionID = getTemplateDocVersionIDByDocID(sourceDocumentID);

	// look up the name of the document. Either from :-
	// (1) Selected option of <select> element (most cases) or 
	// (2) Text from <span> element (if Doc Templates used)
	var docName = null ;
	if ($(documentTemplateId)[0]!=null)
	{
		if ($(documentTemplateId)[0].options !=null) {	
			var options = $(documentTemplateId)[0].options ;
				for (var i = 0 ; i < options.length ; i++ )
				{
					if (options[i].value ==  sourceDocumentID)
					{
						docName = options[i].text;
						i = options.length ;
					}
				}
				if (docName == langStrings.pleaseSelect)
					docName = '';
		} else {
			docName = $(documentTemplateName).text(); 
		}	
	} 
	// Bugfix: when we have a name, check whether the document is autonamed. If so, disable the field. 
	if (docName!=null) 	
	{
		processDocType(sourceDocumentVersionID, docName, counter, false, true);
		var autoname = $(documentNameId).attr("autoname");
		if (!(autoname !=null && autoname =='true') ) 
			$(documentNameId)[0].value= docName;					
	}
	
}

// Change the document type for a document row. Change from browse, copy or link
function setDocumentType(documentType , documentCounter, label) {
	try {
		var columnElement = "#documentSelectionColId" + documentCounter;
		
		if (!label) {   // This may get obsolete when all callers provide a label
			switch(documentType) {
				case 'Browse': label = langStrings.browse; break;
				case 'Copy': label = langStrings.copy; break;
				case 'Link': label = langStrings.link; break;
				case 'New': label = langStrings.newString; break;
			}
		}
		// set source element hidden info and label	
		var htmlcode = '<span class="darktext_greenlink_11 nobr"><input type="hidden" name="documentType'+documentCounter+'" id="documentTypeId' + documentCounter + '" value="'+ documentType +'"/> ' + label + ':</span>';		
		var sourceElement = "#documentType" + documentCounter;
		$(sourceElement).html(htmlcode);  
		
		// set the correct controls for this documentType
		columnElement = $(columnElement);
		columnElement.empty();
			
		// hide attribute category if it exists
		var documentAttributesDivId = "documentDivId" + documentCounter + "Attributes";
		if($("#" + documentAttributesDivId).length > 0) $("#" + documentAttributesDivId).empty();
		hideDocumentAttributes(documentCounter);
		

		if(documentType == "New") {

			
		} else if(documentType == "Browse") {

			columnElement.append('<input type="file" name="documentFileName' + documentCounter + '" id="documentFileNameId' + documentCounter + '" size="30" onchange="changeFileName(\'' + documentCounter + '\');"/>');
			
			if ($(sourceElement)[0] !=null  )			
				$(sourceElement)[0].colSpan=1 ;
			columnElement.show();
			
		} else if(documentType == "Select") {

			columnElement.append('<select name="documentSelect' + documentCounter + '" id="documentSelectId' + documentCounter + '" class="filter">' + makeProjectDocumentsOptionsString() + '</select>');
			if ($(sourceElement)[0] !=null  )			
				$(sourceElement)[0].colSpan=1 ;
			columnElement.show();
			
		} else if ( documentType == "Copy" || documentType == "Link" || documentType == "Move" ) {  

			
			var selectBoxes = '<table><tr><td><select name="documentProjects'+documentCounter+'" id="documentProjects'+documentCounter+'" class="filter" style="width: 200px"></select></td>';
			selectBoxes += '<td><select id="documentFileNameId'+documentCounter+'" name="documentFileName'+documentCounter+'" disabled="disabled" class="filter" style="width:200px"><option value="" selected="selected">' + langStrings.noProjectSelected + '</option></select></td></tr></table>';
			columnElement.append(selectBoxes);
			
			
			if ($(sourceElement)[0] !=null ) $(sourceElement)[0].colSpan=1 ;
			columnElement.show();
			
			
			
			//enable sdrop for project
			var select = $('#documentProjects' + documentCounter);
			
			require(["component/sdrop/SDrop", 
			         "component/sdrop/dataproviders/StaticSDropDataProvider", 
			         "component/sdrop/dataproviders/SDropDataProvider"], function(SDrop, StaticSDropDataProvider, SDropDataProvider){
				if (!gProjectsWithDocumentsDataProvider){
					gProjectsWithDocumentsDataProvider =  new SDropDataProvider({'dataSource': 'GetNameIDList.jsp?list=MyAllProjects'});
				}
				new SDrop(	select, 
						null, 
						gProjectsWithDocumentsDataProvider, 
						{	'autoWidth': false, 
							'onChangedByUser': processCopyProjectSelection.bind(select[0],
																				select[0], 
																				'projectFilterId' + documentCounter,
																				'documentFileNameId' + documentCounter) });
			
				var documentProvider = new StaticSDropDataProvider();
				gDocumentDataProviders['documentFileNameId' + documentCounter] = documentProvider;
				
				var tmpSDrop = new SDrop(	$('#documentFileNameId'+documentCounter), 
											null, 
											documentProvider, 
											{'autoWidth': false, 'initializeDataProvider': false});
		
	//			if (documentType == "Copy"){   // To DO: why is this only for Copy?  What does this do by the way?
				if ( documentType == "Copy" || documentType == "Move" ) {
					tmpSDrop.addEvent('changedByUser', changeFileName.bind($('#documentFileNameId'+documentCounter)[0], documentCounter));
				}
				
				if( documentType == "Link"){
					tmpSDrop.addEvent('changedByUser', function () {
						var fileInputElementVal = $("#documentFileNameId"+documentCounter + " option:selected").text();
						if (fileInputElementVal) {
							var fileExt = getExtension(fileInputElementVal);
							var docTypeId = getDocTypeIdBasedOnExtension(fileExt);
							if(docTypeId === '00001_0000000019' || docTypeId[0] === '00001_0000000019'){
								var dlsObj = getDocLinkSourceObj(documentCounter);
								$("#documentFileNameId"+documentCounter+" option[value='']").prop('selected', true);
								alert(dlsObj.label.langArr['ERR_TEXT_CONTENT_DOC_LINK_FAIL']);
								return;
							}	
						}
						return;
					});
				}
			});
		
		} else if (documentType == "Search") {
			// handles everything itself from documentSourceHandler
			
			
		} else if (documentType == "CreationCopy"){   
			// set value to "CreationCopy" in hidden field and hide selector
			$(sourceElement).empty();
			// add selector because the existing code depends on this, also add one option, because a check is done for index 0
			$(sourceElement).append('<select id="documentTypeId'+documentCounter+'" name="documentType'+documentCounter+'"><option value="Copy" selected="selected"/></select>'); 
			$(sourceElement).hide();
			
			// put document name and id in the correct column as read-only values
			columnElement.attr('colspan',2);

			columnElement.append('<select style="display:none" id="documentFileNameId' + documentCounter + '" name="documentFileName' + documentCounter + '"><option value=""></option></select>');
			columnElement.append('<div name="documentFileNameTxt' + documentCounter + '" id="documentFileNameTxtId' + documentCounter + '" class="darktext_darklink_11 inlinecontent" style="vertical-align: sub;" />');
		}
		
		var selector = "#documentTypeId" + documentCounter ;
		var optionType = documentType ;
		if (documentType == 'Link')
			optionType = 'Select' ;
		var typeSelector = $(selector)[0];
		if (typeSelector!=null && typeSelector.options!=null )
		{
			for (var i = 0 ; i < typeSelector.options.length ; i++ )
			{
				var option = typeSelector.options[i];
				if ( option.value == optionType	 )
				{
					typeSelector.selectedIndex = i ;		
					i = typeSelector.options.length ;
				}
			}
		} 
		
		
		
		// If linking a document clear and disable the name and description boxes
		$("#documentNameId" + documentCounter).val("");
		if(documentType == "Link" || documentType == "Select") {
			$("#documentDescriptionId" + documentCounter).val("");
			$("#documentNameId" + documentCounter).hide();
			$("#documentNameLabelId" + documentCounter).hide();
			$("#documentDescriptionId" + documentCounter).hide();
			$("#documentDescriptionLabelId" + documentCounter).hide();
			if (documentType == "Select") {
				$("#documentFolderId" + documentCounter).val("default");
				$("#documentFolderId" + documentCounter).hide();
				$("#selectedDocumentFolderName" + documentCounter).val("Default");
			}
			else {
				$("#documentFolderId" + documentCounter).show();
			}
		} 
		else {
			$("#documentNameId" + documentCounter).show();
			$("#documentNameLabelId" + documentCounter).show();
			$("#documentDescriptionId" + documentCounter).show();
			$("#documentDescriptionLabelId" + documentCounter).show();
			$("#documentFolderId" + documentCounter).show();
		}
		// If selecting a project document (for link to task), also disable doc template controls
		if (gHasNewDocumentOption) {
			if (documentType == "Select") {
				$("#documentTemplateId" + documentCounter).val("");
				$("#documentTemplateId" + documentCounter).prop("disabled", true);
				$("#documentTemplateId" + documentCounter).hide();  // don't show the disabled selector as it is only adding to confusion
				$("#documentRowId" + documentCounter + "Attributes").hide();			
			}
			else {
				$("#documentTemplateId" + documentCounter).prop("disabled", false);
				$("#documentTemplateId" + documentCounter).show();   // show it if it was hidden
			}
		}
	} catch (err) {
		alert('Problem in DocumentsTable, setDocumentType at line ' + err.lineNumber + ': ' +  err.message );	
	}
}

/**
 * Class method to get Document Link Source object based on documents/BOM table row index.
 * @param docIndex {String} - Index of row in particular document/BOM table. 
 * It's an integer in case of documents and an integer prefixed by "BOM" in case of BOM.
 */
function getDocLinkSourceObj(docIndex) {
	var dlsObj = null;
	try {
		if (!docIndex) return null;
		var dlsObjElem = document.getElementById("documentRowId" + docIndex);
		if (dlsObjElem) dlsObj = dlsObjElem.dlsObj;
	} catch (err) {
		alert('Problem in getDocLinkSourceObj at line ' + err.lineNumber + ' : ' + err.message);
	}
	return dlsObj;
};

/**
 * Method is to validate Text Content being loaded from browse link in Text Content section.
 * @param {String} fileInputElementId - id of the element to upload a file.
 * @returns
 */
function validateTextContent(fileInputElementId) {
	

    var file = $(fileInputElementId)[0];
   
    /* Create a FormData instance */
    var formData = new FormData();
    /* Add the file */ 
    formData.append("upload", file.files[0]);
    var result = false;
    
	var url = 'validatetextcontent.jsp';
	$.ajax({
		async: false,
		url: url,
		contentType: "MULTIPART/FORM-DATA",
		type: "POST",
		data: formData,
		datatype: "json",
		processData: false,
		success: function (response) {
			var status = (JSON.parse(response)).status;
			
			if(status === 'valid')
				result = true;
			else 
				result = false;
		},
		error: function (jqXHR, textStatus, errorThrown) {
			console.log(textStatus);
		}
	});
	 
    return result;
}


// After change of the browser file name - use the file name a document name if not already supplied
// TODO: NEEDS to be verified on MacOS. Alternatively use JAMI method (value on browse?)
/**
* Called when you browse to a new file on your local file system (document source Browse)
* Does the checking on document extension
* @param {String} documentCounter - suffix for the id's to pick up the value of the right row/table
* @param {Boolean} skipTemplate - skips auto selecting the default document template  (only set when called from getDocumentAttributes)
*/
function changeFileName(documentCounter, skipTemplate) {
	try {
		// get DocumentSourceHandler object and allowed document extensions from it
		var fileAllowedExtStr = "";
		var dlsObj = getDocLinkSourceObj(documentCounter);  // To do: wrong place to get it from (sits in the row!)
		if (dlsObj) fileAllowedExtStr = dlsObj.documentType;
		
		var nameElement = $("#documentNameId" + documentCounter);  
		
		var fileInputElement = $("#documentFileNameId" + documentCounter);
		if (fileInputElement.is("input")) {
			fileInputElementVal = fileInputElement.val();
		} else {
			fileInputElementVal = $("#documentFileNameId" + documentCounter + " option:selected").text();
		}
		
	
		if (fileInputElementVal) {
			// find the file name without folders and drive letters
			if (fileInputElementVal.lastIndexOf("\\") != -1) {
				fileInputElementVal = fileInputElementVal.substring(fileInputElementVal.lastIndexOf("\\") + 1);
			} else if (fileInputElementVal.lastIndexOf(":") != -1) {
				fileInputElementVal = fileInputElementVal.substring(fileInputElementVal.lastIndexOf(":") + 1);
			} else if (fileInputElementVal.lastIndexOf("/") != -1) {
				fileInputElementVal = fileInputElementVal.substring(fileInputElementVal.lastIndexOf("/") + 1);
			}
			// set the default name to the name of the uploaded file
			if ((fileInputElementVal.length > 0) && (nameElement.length > 0)) {
				nameElement.val(fileInputElementVal);
			}

			var fileExt = getExtension(fileInputElementVal);  // this returns null if there is no extension!
			
			// check if the extension of the file is among allowed extensions
			// (if no extensions specified, all extensions are allowed)
			if (fileAllowedExtStr && fileAllowedExtStr.length > 0) {
				var isExtensionAllowed = false;
						  
				if (fileExt) {
					fileExt = fileExt.substring(fileExt.indexOf(".") + 1);   //get rid of "." in extension string like ".doc"			  
				  
					var allowedExtList = fileAllowedExtStr.split(",");   
					if (allowedExtList.length == 1) allowedExtList = fileAllowedExtStr.split(";");  // allow both , and ; as a separator but not mixed
				  
					for (var i = 0; i < allowedExtList.length; i++) {
						var allowedExt = allowedExtList[i];
						if (!allowedExt) continue;  // empty
						allowedExt = allowedExt.replace(/^\s+|\s+$/g, '').toLowerCase();
						if (allowedExt.substr(0,1) == '.') allowedExt = allowedExt.substr(1);
						if (fileExt == allowedExt) {   
							isExtensionAllowed = true;
							break;
						}
					}
				} 				
				if (!isExtensionAllowed && fileInputElement) {
					alert(langStrings.notAllowedDocExtension + fileAllowedExtStr);
					// file input cannot be reset directly -> regenerate it to make it empty again 
					// (other methods don't work reliably in all browsers)
					fileInputElement.parent().html(generateDocInputField(documentCounter));
					// reset document name field and ...
					if (nameElement.length > 0) nameElement.val("");
					// ... exit here
					return;
				}
			}
			
			//We need to validate document only if document type is of type Text Content and documentType is "Upload"
			var documentType = $("#documentTypeId" + documentCounter);
			if(documentType!=null && documentType.val()=="Browse"){
				var docTypeId = getDocTypeIdBasedOnExtension(fileExt);
				if(docTypeId === '00001_0000000019' || docTypeId[0] === '00001_0000000019'){					
					var textValidation = validateTextContent("#documentFileNameId" + documentCounter);
					if (false == textValidation) {
						fileInputElement.parent().html(generateDocInputField(documentCounter));
						if (nameElement.length > 0) nameElement.val("");
						alert(dlsObj.label.langArr['ERR_INVALID_TEXT_CONTENT']);
						return;
					}
				}
			}
		}
		
		var docTemplateSelElement = "#documentTemplateId" + documentCounter;
		var docTemplateSelElementVal = $(docTemplateSelElement).val();

		// If we have a document template selected we don't want to continue and override its attributes.
		if (docTemplateSelElementVal != null && docTemplateSelElementVal.trim() != "") {
			return;
		}
		
		//get Document Version ID for the selected document (not applicable for 'Upload'/Browse way of specifying a Document)
		var specifiedDocVersionID = $("#documentFileNameId" + documentCounter + " option:selected").val();
		
		
		// check whether the document autonaming was set up and whether the att category was set up 
		myACat = null;  // CR HADW: this is a global not named as such --> decide where to go with this
		
		//this call does following actions:
		// - sets myACat value > used to show the appropriate Attribute Category if a Default AC is set for the specified Document type
		// - checks autonaming preference for the specified Document Type (can disable "name" field if autonaming is found to be active for this Doc Type)
		var categoryID = processDocType(specifiedDocVersionID, fileInputElementVal , documentCounter, true, false);  // gets the category of the document type  and hides name field in case of autonaming, but does not load the category yet (3rd parameter)

		if(categoryID == null || categoryID == ''){
			// remove and hide attributes
			var documentAttributesDivId = "documentDivId" + documentCounter + "Attributes";
			clearAttributeCategory(documentAttributesDivId);
			hideDocumentAttributes(documentCounter);
		}
		
		if(!skipTemplate && $('#documentTemplateId'+documentCounter).length > 0) {		
			// do automatic template assignment. 
			autoSelectTemplateDocument(fileInputElementVal, docTemplateSelElement, documentCounter);  // this sets myACat if the default template loads
		}

		// now load the autonaming category but only if no default document template exists (default document template overrules autonaming setting)
		if(myACat == null && categoryID != null && categoryID != '') { // seems to check whether the category is not yet loaded. 
			showCategoryID(categoryID, documentCounter);  // sets myACat...
		}
	} catch (err) {
		alert('Problem in DocumentsTable.changeFileName() at line ' + err.lineNumber + ' : ' + err.message);
	}
}



function getExtension(curDocName)
{
	if (curDocName == null || curDocName.length == null || curDocName.length < 3)
		return null; // not a name long enough to have an extension
	if (curDocName.lastIndexOf('.') < 0 || curDocName.lastIndexOf('.') >= (curDocName.length-1)) // no extension
		return null; // no extension
	var ext = curDocName.substr(curDocName.lastIndexOf('.'));
	// return the extension with no leading and trailing spaces and converted to lowercase
	return ext.replace(/^\s+|\s+$/g, '').toLowerCase();
}

function isSinglePageUpload()
{
	if ($("#uploadType")[0] != null && $("#uploadType")[0].value == 'single')
		return true;
	return false;
}

// This function will determine the document type ID based on the extension
// and on the availability of the doucment type, ie. it will also check whethet the doc type is enabled. 
function getDocTypeIdBasedOnExtension(extension)
{
	var docTypeID = '00001_0000000005'; // other
	
	if (extension != null) 
	{
		if ( IsGraphicalExtension(extension) && gIsGraphicsDocEnabled)  // HADW CR: this calls back into AddDocument.js
		{
			docTypeID = '00001_0000000004'	;	
		}
		else if (IsArtiosCADDocument(extension) && gIsCADDesignDocEnabled)
		{
			if (extension.toLowerCase() == '.a3d')
				docTypeID = '00001_0000000003'	;	// a3d files	
			if (extension.toLowerCase() == '.acd')
				docTypeID = '00001_0000000020'	;	// acd files	
			else if (extension.toLowerCase() == '.mfg')
				docTypeID = '00001_0000000002'	; // mfg files
			else
				docTypeID = '00001_0000000001'	; // ARD files 			
		}
		else if (extension.toLowerCase() == ".clf" && gIsCapeDocEnabled)
		{
			docTypeID = '00001_0000000008'	;
		}
		else if (extension.toLowerCase() == ".zcp" && gIsCapeDocEnabled)
		{
			docTypeID = '00001_0000000008'	;
		}
		else if (extension.toLowerCase() == ".dae" &&  gIsColladaDocEnabled ) // collada file 
		{
			docTypeID = '00001_0000000017';
		}
		else if (extension.toLowerCase() == ".zae" && gIsZippedColladaDocEnabled) // collada zip file 
		{
			docTypeID = '00001_0000000016';
		}
		else if (extension.toLowerCase() == ".chp" && gIsChiliDocEnabled) // Chili chp file
		{
			docTypeID = '00001_0000000018';
		}
		else if (extension.toLowerCase() == ".wcc" || extension.toLowerCase() == ".wtc") // textcontent file
		{
			docTypeID = '00001_0000000019';
		}
		else if (isKnownDocType && isKnownDocType(extension)) // self defined
		{
			if (getKnownDocType)
				docTypeID = getKnownDocType(extension);
		}
	}
	
	return docTypeID ;
}

// 1. retrieves Attribute Category ID of the source Document > used to show the appropriate Attribute Category if a Default AC is set for the specified Document type
// 2. checks autonaming preference for the specified Document Type (can disable "name" field if autonaming is found to be active for this Doc Type)
//
// @param {String} sourceDocVersionID - [OPTIONAL; can be null > when uploading a brand new file > no COPY or NEW upload mode]; 
//				   ID of the soruce Document > used to check for a Document Type related to it for autonaming settings
// @param {String} filename - filename of the processed Template Document; used to set as the default value if no Autonaming is effective for the source Template Document
// @param {int} docCounter - index of the Document row that is being processed; used to refer to the appropriate HTML elements
// @param {Boolean} dontshow - if true, the attribute category will not be loaded, but instead categoryId will be returned (to load later)
// @param {Boolean} usingTemplateDoc - if true, loading of the real Doc Type of the source Document will be done for a Template Document context
// 
function processDocType(sourceDocVersionID, filename, docCounter, dontshow, usingTemplateDoc)
{
	//fetch the Document Type of the source Document (based on: file name or real doc type of a source template document)
	var docTypeID = null;
	if (sourceDocVersionID != null) { // using a source Document > emplate Document [NEW]/Source Document [COPY]
		//get the real Document Type of the source Document
		if (usingTemplateDoc) {
			docTypeID = getSourceDocumentTypeID(sourceDocVersionID, gUploadProjectID);	
		} else {
			docTypeID = getSourceDocumentTypeID(sourceDocVersionID, null);
		}
			
	} else { //now source Document > uploading a new document > Browse/Upload mode
		//fetch the Doc Type based on the file extension
		var extension = getExtension(filename);
		if(extension) extension = extension.toUpperCase();
		docTypeID = getDocTypeIdBasedOnExtension(extension);
	} 
	 
	 
	 //get the upload type 
	var selectBoxID = "#documentTypeId" + docCounter ; 
	var uploadType = "" ;
	if ( $(selectBoxID).length > 0 )
		uploadType = $(selectBoxID)[0].value ;
	
	// read the settings based on the doc type 
	if (gDocTypeConfigs !=null  )
	{
		var docTypeSettings = null;
		if (docTypeID != null) {
			docTypeSettings = gDocTypeConfigs[docTypeID];	
		}
		
		if (docTypeSettings!=null)
		{
			// check whether the doc type has autonaming option on, if so, hide the doc name field
			showHideDocName(docTypeSettings['Autoname On'], docTypeSettings['Autoname Edit Field'],docCounter);
			
			// change filename field 
			if(docTypeSettings['Autoname On']){
				if (docTypeSettings['Autoname Edit Field']){
					// autoname, edit field: message to user
					// field will disappear when element is in focus and will reappear when it loses focus if empty
					// off course, the message will not be submitted
					var msg = "[" + langStrings.namesuffix + "]";
					
					$("#documentNameId" + docCounter).val(msg);
					$("#documentNameId" + docCounter).attr('rel', msg);
					$("#documentNameId" + docCounter).css('color', 'gray');
					
					$("#documentNameId" + docCounter).on("focus", function() {
					    if ($(this).val() == $(this).attr('rel')){
					        $(this).val('');
					        $(this).css('color', 'black');
				        }
					});
					
					$("#documentNameId" + docCounter).on("blur", function() {
					    if ($(this).val() == ''){
					        $(this).val($(this).attr("rel"));
					        $(this).css('color', 'gray');
				        }
					});
					
					$("#documentNameId" + docCounter).on("submit", function() {
					    if ($(this).val() == $(this).attr('rel')){
					        $(this).val('[Name Suffix]');
					    }
					});
					
					
				}else{
					// autoname, no editfield: empty
					$("#documentNameId" + docCounter).val("");
					removeSuffixHandlers(docCounter);
				}
				$("#documentNameId" + docCounter).attr('autoname',"true"); 
			} else {
				// no autoname: filename
				$("#documentNameId" + docCounter).val(filename);
				removeSuffixHandlers(docCounter);
				$("#documentNameId" + docCounter).removeAttr('autoname'); 
			}
			
			// check whether the doc type has a category selected and when we are not in the case of 'new', if so, show the category.
			// In the case of 'New', we inherit the category of the selected document
			if(docTypeSettings && (uploadType != 'New')){
				// first check if there's a category assigned to the tasktype, otherwise use the doctype category
				var taskTypeCat = $("#fixeDocumentAttributeCategory").val();
				var categoryID = '';
				if(taskTypeCat != null && taskTypeCat != ''){
					categoryID = taskTypeCat;
				}else{
					categoryID = docTypeSettings['categoryID'];
				}

				if(categoryID != ''){
					if (dontshow == true) return categoryID;
					else showCategoryID(categoryID, docCounter);	// sets myACat
				}
					
			}
		} else {
			// change filename field 
			($("#documentNameId" + docCounter))[0].value = filename;
		}
	}  		
}

function removeSuffixHandlers(docCounter){
	$("#documentNameId" + docCounter).removeAttr('rel');
	$("#documentNameId" + docCounter).css('color', 'black');
	$("#documentNameId" + docCounter).off("focus");
	$("#documentNameId" + docCounter).off("blur");
	$("#documentNameId" + docCounter).off("submit");
}

// returns whether autonaming is used or not
function showHideDocName(useAutoName, hasFreeEditablePart, docCounter )
{
	var documentNameId = "#documentNameId" + docCounter ;  
	
	if ($(documentNameId) == null || $(documentNameId).length == 0)
		return ; 
	
	if ((!useAutoName) || hasFreeEditablePart) // only when no autoname option is used, or when there is a free-editable part, enable the doc name field
	{
		$("#documentNameId" + docCounter).prop('disabled', false);
		//$("#documentNameId" + docCounter).attr("enabled", "enabled");
	}
	else
	{
		$("#documentNameId" + docCounter).prop("disabled", true);
	}	
	
}

function processTemplateDocSelection(selectorElementId, counter)
{
	var selectorElem = $(selectorElementId).get(0);
	if (isSinglePageUpload()) {
		ProcessSelectedTemplateDoc(selectorElem, false, counter);
	}
	else { // multi
		getDocumentAttributes(selectorElem, counter);
		setFolderName(selectorElem, counter);
	}
}

/** HADW CR: internal function (only called from DocumentsTable.js)
* implements function "automatically assign attribute category of default.extension in the document templates"
* It also sets the document type of the new document to the one of the template (makes sense for PDF and ZIP at least)
*/
function matchTemplateDocument(curDocDefaultName, selectorElementId, counter)
{
	var found = false;
	// go through the list of document templates and see if there is one matching the pattern "Default.<extension>"
	var curTempDocID, curTempDocName;
	for (var i = 0; i < gTemplateDocumentList.length; i++)
	{
		//retrieve the basic data for the current Template Document
		curTempDocName = gTemplateDocumentList[i].name;
		
		if (curTempDocName.toLowerCase() == curDocDefaultName.toLowerCase()) // not case-sensitive
		{
			curTempDocID = gTemplateDocumentList[i].id;
			$(selectorElementId).val(curTempDocID);		      
			processTemplateDocSelection(selectorElementId, counter);
			found = true;
			if (isSinglePageUpload())  // set the default document type
			{
				var mimeType = (getExtension(curDocDefaultName) || "").toUpperCase(); 
				var curTempDocTypeId = gTemplateDocumentList[i].doctypeid;
				var curTempDocType = null;
				if (curTempDocTypeId == '00001_0000000014')
					curTempDocType = 'pagelist';
				else if (curTempDocTypeId == '00001_0000000005')
					curTempDocType = 'other';
				else if (curTempDocTypeId == '00001_0000000004' || // Graphics
						 curTempDocTypeId == '00001_0000000007') // Digital Film (Zip can be of this type
					curTempDocType = 'graphic';
				if (curTempDocType != null)
				{
					//PDF - Graphic Document / MultiPage PDF Document, Pagelist or Other
					if (mimeType == ".PDF" && $("#pdf_type_select").is(':visible')) // the PDF doc type selector is vailable
					{
						$("#pdf_type_select").val(curTempDocType); // set the default doc type value; if it not in the list - no change is made
						TogglePDFDocType($("#pdf_type_select").get(0), $("#pdf_type_select").val(), true);
					}
					else
					//ZIP FILE
					if (mimeType == ".ZIP" && $("#zip_type_select").is(':visible')) // the ZIP doc type selector is vailable
					{
						$("#zip_type_select").val(curTempDocType); // set the default doc type value; if it not in the list - no change is made
						ToggleZipDocType($("#zip_type_select").get(0), $("#zip_type_select").val(), true);
					}
				}
			}
			break;
		}
	}
	return found;
}

/**
* Called from AddDocument.js and from DocumentsTables.js
* implements function "automatically assign attribute category of default.extension in the document templates" largely by calling matchTemplateDocument
* Automatically selects a document template 'default.extension' after browsing a new file named filename.extension
* @param {String} curDocName - name of the browsed file
* @param {String} selectorElementId - typically 'documentTemplateId', so the document template selector
* @param {Integer} counter - index in the documents table
*/
function autoSelectTemplateDocument(curDocName, selectorElementId, counter)
{
	if (!gHasTemplateDocuments || gTemplateDocumentList == null || gTemplateDocumentList.length == null || gTemplateDocumentList.length == 0)
		return; // no template documents
	var curDocExtension = getExtension(curDocName); // get extension or null if not found
	var found = false;
	var defName = 'default'; // not case sensitive
	if (curDocExtension != null)
	{
		// go through the list of document templates and see if there is one matching the pattern "Default.<extension>"
		var curDocDefaultName = defName + curDocExtension;
		found = matchTemplateDocument(curDocDefaultName, selectorElementId, counter);
	}
	// if nothing found, go through the list of document templates and see if there is one matching the pattern "Default"
	if (!found) 
	{
		var curDocDefaultName = defName;
		found = matchTemplateDocument(curDocDefaultName, selectorElementId, counter);
	}
	// if not found, check if the current selection is a default template. If that is the case, reset the
	if (!found)
	{
		var selectedText = $(selectorElementId + " option:selected").text();
		if (selectedText.toLowerCase() == defName || 
			selectedText.toLowerCase().indexOf(defName + '.')==0) // not case-sensitive
		{
			$(selectorElementId)[0].selectedIndex = 0; // select first item
			processTemplateDocSelection(selectorElementId, counter);
		}
	}
}

function changeDocumentFolder(selector, documentCounter) {
	// just copy name of the selected folder to hidden input prepared for that.
	// this is to pass both original folder ID and name to corresponding action helper.
	var selectedFolderName = $("#documentFolderId" + documentCounter + " :selected").text();
	$("#selectedDocumentFolderName" + documentCounter).val(selectedFolderName);
}

// This function populates a list select form field from an array of documents
function makeDocumentsOptionsString(documentList) {
	var optionsString = "";
	
	var maxCharacters = 40 ; // maximum number of characters that we show in the template selector drop down
	
	if(documentList != null && documentList.length > 0) {
		optionsString += '<option value="" selected="selected">' + langStrings.pleaseSelect + '</option>';
		var g = 0;
		for(g = 0; g < documentList.length; g++) {
			
			// when the name is too long, cut it to a max nr of characters
			var docname = documentList[g].name ;
			if (docname.length > maxCharacters + 3)
				docname = docname.substr(0,maxCharacters) + "..."; // Truncate + indicate that it got truncated by adding the '...'
 			optionsString += '<option value="' + documentList[g].id + '">' + WCXML.xmlencode(docname) + '</option>';
		}
	} else {
		optionsString += '<option value="" selected="selected">' + langStrings.noDocuments + '</option>';
	}
	
	return optionsString;
}

// This function populates the Documents Template Column in the Document Table.
// It uses a global variable gTemplateDocumentList
function makeTemplateDocumentsOptionsString() {
	return makeDocumentsOptionsString(gTemplateDocumentList);
}

// This function populates the Project Documents Column in the Document Table.
// It uses a global variable gProjectDocumentList
function makeProjectDocumentsOptionsString() {
	return makeDocumentsOptionsString(gProjectDocumentList);
}

// This function populates a list select form field from an array of folders
function makeProjectFoldersOptionsString(documentIndex) {
	var optionsString = "";
	
	var defaultfolder = null;
	var hasDocTemplate = false;

	// if there is a default folder name, it should be loaded
	if (typeof gDefaultFolderName != "undefined" && gDefaultFolderName != null  && gDefaultFolderName != '' ){
		defaultfolder = gDefaultFolderName;
	}
	
	// check if there are document templates
	if (typeof gHasNewDocumentOption != "undefined" && gHasNewDocumentOption != null  && gHasNewDocumentOption != '' ){
		hasDocTemplate = gHasNewDocumentOption;
	}

	if (gProjectFolders == null) {
		// there are no project folders loaded - use AJAX to load them
		optionsString = '<option value="" selected="selected">' + langStrings.loading + '</option>';
		getProjectFoldersOptions(documentIndex);  // HADW CR: this seems to count on having the AJAX call slow enough to have $("#documentFolderId" + documentIndex) already available by then
	}
	
	if (gProjectFolders != null) {
		if(hasDocTemplate){
			// "Default Folder" option is there when there are document templates
			optionsString = '<option value="default">' + langStrings.defaultFolder + '</option>';
		}
		for (var g = 0; g < gProjectFolders.length; g++) {
			var selectString = '';
			if (defaultfolder != null && defaultfolder.toLowerCase() ==  gProjectFolders[g].name.toLowerCase()) {
				// option should be selected
				selectString = 'selected="selected"';
			}
			
			optionsString += '<option value="' + gProjectFolders[g].folderID + '" '+selectString+'>' + WCXML.xmlencode(gProjectFolders[g].name) + '</option>';
		}
	}

	return optionsString;
}

// This function initializes the global list of project folders 'gProjectFolders'.
// HADW CR: I don't understand why you can fill gProjectFolders globally and still accept a documentIndex --> debug this with firebug to see what happens
function getProjectFoldersOptions(documentIndex) {
	// if the given page doesn't support "Folder" column, or we don't have a project ID
	// (create from a blank project) simply skip this method
	if ((typeof gProjectFolders == "undefined") || (gProjectID == null)) return;

	// if project folders haven't been initialized yet, do so now
	try {
		ajax({
			url: "GetDocUploadInfo.jsp?action=GetSingleProjectFolders&projectid="+gProjectID,
			type: "GET",
			data: "xml",
			debug: false,
			synchronous: false,
			// timeout: 80000,
			onError: function(status) { 
				if (status == "998"){
					status = "SESSION EXPIRED (998)";
				}
				window.alert("Unable to get folders of current project. Server status: "+status);},
			onSuccess: function(xml) 
			{	
				//alert("GetDocUploadInfo.jsp AJAX worker returned successfuly.");
				
				// handle return XML
				gProjectFolders = new Array();
				
				var projectXml = xml.getElementsByTagName("project")[0];

				if (projectXml != null) {
					// add root folder to the list of avalible folders if in the XML
					var isRootFolderUploadEnabled = WCXML.GetElementText(projectXml, "root_upload_enabled", false);
					
					if (isRootFolderUploadEnabled != null && isRootFolderUploadEnabled == '1') {
						gProjectFolders.push({folderID: "", name: langStrings.rootFolder});
					}
					
					// check whether the current Upload Project has any sub-Folders available for uploading as well
					var folderListParent = projectXml.getElementsByTagName("folder_list");
					if (folderListParent != null && folderListParent.length > 0) {
						var foldersList = projectXml.getElementsByTagName("folder_list")[0].getElementsByTagName("folder");
						if (foldersList != null && foldersList.length > 0) {
							var curFolderID, curFolderName;
							for (var g = 0; g < foldersList.length; g++) {
								// get the current Folder info
								curFolderID = WCXML.GetElementAttribute(foldersList[g], "id");
								curFolderName = WCXML.GetElementText(foldersList[g], "name", false);
								
								// add the current folder into the Project's Folder list
								gProjectFolders.push({folderID: curFolderID, name: curFolderName});
							}
						}
					}
				}
				
				var foldersPlaceholder = $("#documentFolderId" + documentIndex);
				if (foldersPlaceholder.length > 0) {
					// finally generate HTML and put it to prepared folder selector
					foldersPlaceholder.html(makeProjectFoldersOptionsString(documentIndex));
					// update the folder name hidden field
					foldersPlaceholder.trigger("change");
					// ...and handle the folder selector visibility correctly
					hideShowFolderColumns();
				}
				
				// check whether to set folder defaults
				setDelayedFolderDefaults(gTargetFolderActions);
				// Avoids JS error on Task Execution Page
				if (typeof gBOMTargetFolderActions != "undefined") {
					setDelayedFolderDefaults(gBOMTargetFolderActions);
				}			
				
			} //end: AJAX success callback					
		}); // End Ajax code
	} 
	catch (err) 
	{
		alert("Problem in keep session alive: " + err);
	}
}

/**
* a global variable gBOMTargetFolderActions and gTargetFolderActions contain folder actions to be done when the folder dropdown(s) are loaded
* Mostly this will be 0 or 1 but in case of search it is not excluded that there are multiple
* @author HADW
* @param {Array.Obj} folderActions - for each row where the folder still needs to be set an object with the id of the dropdown and the name of the folder
*/
function setDelayedFolderDefaults(folderActions) {
	"use strict";
	try {
		if (folderActions && folderActions.length >0) {
			for (var action= 0; action < folderActions.length; action++) {
				var dropdownId = folderActions[action].id;
				var hiddenId = folderActions[action].hiddenId;
				var targetFolderName =  folderActions[action].folder;
				$("#" + dropdownId + " option").each ( function (index) {
					if (  $(this) && $(this).text().toLowerCase() == targetFolderName.toLowerCase()  ) {
						$(this).prop('selected', true);	
						$("#" + hiddenId).val( $(this).text() );  // set the hidden name field
					}
				});
			}
		}
		
	} catch (err) {
		alert("Problem in setDelayedFolderDefaults: " + err);
	}
}

// This function sets the hidden input field with id folderNameId# where # is the document index
// It uses a global variable gTemplateDocumentList
function setFolderName(selectBox, documentIndex) {
	var documentFolderNameId = "folderNameId" + documentIndex;
	var templateFolderNameId = "templateFolderNameId" + documentIndex;
	var documentId = selectBox.value;
	
	var folderName = "";
	var templateFolderName = "";
	var dlsObj = getDocLinkSourceObj(documentIndex);
	if (dlsObj) {
		// get predefined target folder from corresponding document source (if any)
		folderName = dlsObj.targetFolder;
	}
	// look for default target folder based on document template folder only if target folder is not set in 
	// document source definition and there are some document template(s)
	if (gTemplateDocumentList != null) {
		for(var g = 0; g < gTemplateDocumentList.length; g++) {
			if (gTemplateDocumentList[g].id == documentId) {
				if(folderName.length == 0){
					folderName = WCXML.xmlencode(gTemplateDocumentList[g].foldername);
				}
				templateFolderName = WCXML.xmlencode(gTemplateDocumentList[g].foldername);
				break;
			}
		}
	}
	$("#"+documentFolderNameId).val(folderName);
	$("#"+templateFolderNameId).val(templateFolderName);
}

/**
* Does the acutal loading of the attribute category
* @param {String} categoryId - id of the attribute category to load
* @param {String} documentIndex - suffix for id's and names, typically containing the index of the document in the table. In case of copy also helps finding the source document to copy the attribute values
*/
function showCategoryID(categoryId, documentIndex)
{ 
	var documentAttributesDivId = "documentDivId" + documentIndex + "Attributes";
	
	if (categoryId.length ==0) // clear the fields 
	{
		$("#" + documentAttributesDivId).empty();
		hideDocumentAttributes(documentIndex);
		return; // nothin more to do	
	}
	else
	{
		var readURL = "GetAttributeCategoryXML.jsp?categoryid=" + categoryId;
		var valuesURL = "GetAttributes.jsp?" +"categoryid=" + categoryId;  
		// Remark that in case of not copy, valuesURL will only have a categoryId. It will not get any values, but don't take this out!!!
		// It needs this call anyway to pick up the types of the attributes
		
		if($("#documentTypeId"+documentIndex).val() == "Copy"){  // so in case of Copy, you copy the values. To Do: Check SEARCH!!!
			var copydoc = $("#documentFileNameId"+documentIndex).val();
			if(copydoc) {
				
				valuesURL += "&docverid="+copydoc;
			}
		}


		var aCatOptions = new Object();
		aCatOptions.ACatObj = documentAttributesDivId;
		aCatOptions.ACatPanel = documentAttributesDivId;
		aCatOptions.readURL = readURL + "&view=Creation";
		aCatOptions.actionURL = "";
		aCatOptions.valuesURL = valuesURL;
		aCatOptions.view = "Creation";
		aCatOptions.prefix = "doc" + documentIndex + "_"; // to match what is expected on the server
		aCatOptions.defaultHourAsHalfHours = gDefaultHourAsHalfHours;
		aCatOptions.callbackOnLoad=function() {showDocumentAttributes(documentIndex);};
		aCatOptions.type = "document";
		aCatOptions.projectID = gProjectID;  
		// document/version IDs not known as this is creation of a new document with a default attribute cat.
		// generate a temporary new document ID in-line with DocTableX concept
		aCatOptions.newDocTmpID = 'newID_' + documentIndex;
		// indicate we are in project creation context if so
		aCatOptions.projectCreationContext = (window.gProjectCreationType == "TemplateProject") 
				|| (window.gProjectCreationType == "CopyProject")
				|| (window.gProjectCreationType == "BlankProject");

		// Load the attribute category asynchronously.
		require(["attributecategory/AttributeCategory", "utils/ObjectArrayCloneUtil"], function (AttributeCategory, ObjectHandler) {
			
			var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
			currentUser.canEditAttributes = true; // TODO (if reused outside project creation)			
			aCatOptions.currentUser = currentUser;
			
			myACat = new AttributeCategory(aCatOptions);
		});		
	}
}

/** 
* Gets the attributes of a document template that has been selected
* It uses a global variable gTemplateDocumentList, gTemplateProjectID
* @param {DOMElem} selectBox - selection/dropdown of the document template choice
* @param {String} documentIndex - suffix for id's and names to allow picking the right elements (row/table)
*/
function getDocumentAttributes(selectBox, documentIndex) {
	// only if there is a valid template name typed in the config page attempt to get its attributes
	if (!selectBox) return;

	// get Id of source document (not the template), only in case of copy
	var sourceDocVersionId = null;
	var documentType = $("#documentTypeId" + documentIndex);
	if(documentType!=null && documentType.val()=="Copy"){
		var documentId = $("#documentFileNameId" + documentIndex);
		if(documentId!=null && documentId.val()!=null && documentId.val()!=''){
			sourceDocVersionId = documentId[0].value;
		}
	}

	var documentId = selectBox.value;

	var documentAttributesDivId = "documentDivId" + documentIndex + "Attributes";

	// if the template has no category (which should be very uncommon), check if there's a tasktype category (can only exist in task execution page)
	// this one should also be loaded when there is no template selected
	var categoryId = $("#fixeDocumentAttributeCategory").val();
	
	
	if ((documentId == null || documentId.length == 0) && (categoryId == null || categoryId.length == 0)) {
		// no template selected and no fixed category (tasktype category)
		// try to load the doctype's default attribute category, otherwise, clear and return
		if(documentType!=null && (documentType.val()=="Browse" || documentType.val()=="Copy")){
			changeFileName(documentIndex, true);  // default.ext is loaded where ext is the extension of the selected document
			return;
		}
		if(categoryId == null || categoryId == ""){
			$("#" + documentAttributesDivId).empty();
			hideDocumentAttributes(documentIndex);
			clearAttributeCategory(documentAttributesDivId);
			return; // nothin more to do
		}
	}
	
	var docVersionId = null;
	if(documentId != null && documentId.length != 0){
		for(var g = 0; g < gTemplateDocumentList.length; g++) {
			if (gTemplateDocumentList[g].id == documentId) {
				if(gTemplateDocumentList[g].categoryid != null && gTemplateDocumentList[g].categoryid.length > 0) categoryId = gTemplateDocumentList[g].categoryid;
				docVersionId = gTemplateDocumentList[g].docverid;
				break;
			}
		}
	}

	if (categoryId != null && categoryId.length > 0) {
		// valuesURL will be with values of the source document. valuesURLMerge will be the values of the document template
		// if there's no source document, only valuesURL will be used
		var readURL = "GetAttributeCategoryXML.jsp?categoryid=" + categoryId;
		var valuesURLMerge = "GetAttributes.jsp?doctemplate=1&projectid=" + gProjectID + "&documentid=" + documentId + "&docverid=" + docVersionId  + "&categoryid=" + categoryId;
		var valuesURL;
		
		if(sourceDocVersionId != null && sourceDocVersionId != ''){
			valuesURL = "GetAttributes.jsp?docverid=" + sourceDocVersionId  + "&categoryid=" + categoryId;
		}else{
			valuesURL = valuesURLMerge;
			valuesURLMerge = null;
		}
		
		if(docVersionId == null || docVersionId == ''){ // note: this code makes it impossible to re-use this method for loading attributes in case of a simple copy
			valuesURL = "GetAttributes.jsp?categoryid=" + categoryId;
			valuesURLMerge = null;
		}

		var currentUser = gCurrentUser;
		currentUser.canEditAttributes = true;
		var aCatOptions = new Object();
		aCatOptions.ACatObj = documentAttributesDivId;
		aCatOptions.ACatPanel = documentAttributesDivId;
		aCatOptions.readURL = readURL + "&view=Creation";
		aCatOptions.actionURL = "";
		aCatOptions.currentUser = currentUser;
		aCatOptions.valuesURL = valuesURL;
		if(valuesURLMerge != null && valuesURLMerge != '') aCatOptions.valuesURLMerge = valuesURLMerge;
		aCatOptions.view = "Creation";
		aCatOptions.prefix = "doc" + documentIndex + "_"; // to match what is expected on the server
		aCatOptions.defaultHourAsHalfHours = gDefaultHourAsHalfHours;
		aCatOptions.callbackOnLoad=function() {showDocumentAttributes(documentIndex);};
		aCatOptions.type = "document";
		aCatOptions.projectID = gProjectID;
		// document/version IDs not known as this is creation of a new document (from a doc template)
		// generate a temporary new document ID in-line with DocTableX concept
		aCatOptions.newDocTmpID = 'newID_' + documentIndex;
		// indicate we are in project creation context if so
		aCatOptions.projectCreationContext = (window.gProjectCreationType == "TemplateProject") 
				|| (window.gProjectCreationType == "CopyProject")
				|| (window.gProjectCreationType == "BlankProject");
		
		// Load the attribute category asynchronously.
		require(["attributecategory/AttributeCategory"], function (AttributeCategory) {
			myACat = new AttributeCategory(aCatOptions); // myACat is a global here!!!
		});
			
	} else {
		clearAttributeCategory(documentAttributesDivId);
		hideDocumentAttributes(documentIndex);
	}
}

function clearAttributeCategory(documentAttributesDivId){
    // there is a jQuery issue where jQuery's .empty() does not work properly
    // all JS elements must be removed manually
    var docACatObj = $("#" + documentAttributesDivId)[0];
    if(docACatObj && docACatObj.ACatObj){
    	docACatObj.ACatObj.destroy();
    	docACatObj.ACatObj = null;
    }
    $("#" + documentAttributesDivId).empty();
}


// Load project documents
function loadProjectDocuments(projectSelectBox, documentSelectBoxId) {
	if(projectSelectBox.value == "")
	{
		//the first (dummy) option in the 'Source Copy Project' dropdown list was selected --> reset the 'Source Copy Document' dropdown box
		resetCopyDocumentSelector(documentSelectBoxId);
		return;
	}
		
	
	var projectId = projectSelectBox.value;
	var documentSelectBox = "#" + documentSelectBoxId;
	documentSelectBox = $(documentSelectBox)[0];
	
	try {
		ajax({
			url: "GetProjectCreationInfo.jsp?action=ProjectDocuments&projectID=" + projectId,
			type: "GET",
			data: "xml",
			debug: false,
			synchronous: false,
			onError: function(status) {
				if (status == "998"){
					status = "SESSION EXPIRED (998)";
				}
				window.alert("Unable to get project creation info. Server status: " + status);},
			onSuccess: function(xml) {
				// parse the returning XML string
				var elements=xml.getElementsByTagName("doc_version");
				
				// Empty the select box of previous entries
				while(documentSelectBox.length > 0)
					documentSelectBox.remove(0);
				
				
				var dataProvider = gDocumentDataProviders[documentSelectBoxId];
				dataProvider.reset();
				
				if(elements.length == 0) {
					// no documents were found, disable the dropdown
					documentSelectBox.SDrop.setDisabled(true, langStrings.noDocuments);
					$(documentSelectBox).val('');
				} else {
					// documents were found, enable the sdrop and fill in the correct documents
					documentSelectBox.SDrop.options.i18n.startTyping = langStrings.pleaseSelect;
					documentSelectBox.SDrop.clear();
					documentSelectBox.SDrop.setDisabled(false);
					for ( var i = 0  ; i < elements.length ; i++ ) {
						var newDocument = elements[i];
						var documentID = newDocument.getAttribute("id");
						
						//var documentName = WCXML.GetElementText(newDocument, "original_disk_filename", false);
						//JAMI> Upload Copy/Create New Documents, list of documents to copy does not show given file name but original document name 
						var documentElem = newDocument.getElementsByTagName("document")[0];
						var documentName = WCXML.GetElementText(documentElem, "name", false);
						
						dataProvider.addToStore([{'id': documentID, 'name': documentName}]);					
					}
					
				}
			}
		}); // End Ajax code
	} catch (err) {
		alert("Problem in keep session alive: " + err);
	}
}

function toggleDocumentAllSelection(checkBox) {
	if(checkBox.checked) {
		for(var i = 0; i < gDocumentRowIds.length; i++)
			$("#" + gDocumentRowIds[i] + " input[type='checkbox']").prop("checked", true);
	} else {
		for(var i = 0; i < gDocumentRowIds.length; i++)
			$("#" + gDocumentRowIds[i] + " input[type='checkbox']").prop("checked", false);
	}
}

function updateDocumentAllSelection() {
	if($("#documentsTableId input:not(#AllDocsId):checked").length == gDocumentRowIds.length)
		$("#AllDocsId").prop("checked", true);
	else
		$("#AllDocsId").prop("checked", false);
}

function deleteSelectedEntries() {
	$.each($("#documentsTableId input:not(#AllDocsId):checked").parent().parent(), function(index, element) {
		deleteEntry(element.id);
	});
	$("#AllDocsId").prop("checked", false);
}

function deleteEntry(rowId) {
	$("#" + rowId).remove();
	$("#" + rowId + "Attributes").remove();
	var arrIndex = $.inArray(rowId, gDocumentRowIds); // finds the index of rowId in gDcoumentRowIds, -1 if not found, which is the case when deleting from the BOM section in ProjectCreation
	
	if (arrIndex != -1) {  
		gDocumentRowIds.splice($.inArray(rowId, gDocumentRowIds), 1);
		if (gDocumentRowIds.length == 0) {
			$("#documentsTableId > tbody").filter(".documentsList").hide();
		}
	}
	
	// Check expand after doing something with attributes
	checkExpand();
}

/**
* Called when the documents table must be cleaned, for example when you change template in project creation or when changing doc upload type
*/
function resetDocumentsTable(fullDestroy) {
	if (window.docTableObj){
		if (fullDestroy) {
			window.docTableObj.destroy(true);
			window.docTableObj = null;
		} else {
			window.docTableObj.whenAllAsyncWorkDone()
				.then(window.docTableObj.reset.bind(window.docTableObj, true))
				.catch(window.docTableObj.reset.bind(window.docTableObj, true));
		}
	}
	
	try
	{
		$("#documentsTableId > tbody").filter(".documentsList").empty();
		$("#documentsTableId > tbody").filter(".documentsList").hide();
	}
	catch (e) {}   // ignore any exception in this case, because the method can be called from various places...
	gDocumentCounter = 0;
	gDocumentRowIds = new Array(); // Array contianing a list of all the checkboxes
	gProjectOptionsHTML = null;
	// if the given page doesn't support "Folder" column. simply ignore it
	if (typeof gProjectFolders != "undefined") gProjectFolders = null;
	
	// hide the links that are not applicable 
	showHideAddDocumentOptions();   // HADW To Do: change this for the case of documentSourceHandler
}

function setHasLinkSelectDocumentOption(hasLink) {
	gHasLinkSelectDocumentOption = hasLink;
}


function setHasNewDocumentOption(hasNew) {

	// make sure Document Upload Links are initialized with the document templates just loaded.
	// if 'dshObjElem' is not there yet, the upload links initialization has not been done yet
	// and no special steps are needed...
	var dshObjElem = document.getElementById("documentSourcesHiddenDiv");
	if (dshObjElem && dshObjElem.dshObj) {
		
		// ... But if the upload links were already initialized, the 'New' link(s) might be missing! 
		// The initialization must be completed and the upload links redrawn now.
		var dshObj = dshObjElem.dshObj;
		var options = {};
		options.hasDocumentTemplates = hasNew;			
		// redraw the upload links
		dshObj.displayLinks(options);
	}


	gHasNewDocumentOption = hasNew;

	// Show or hide template document selection and attribute show/hide controls
	$(".hideShowAttribute").toggle(gHasNewDocumentOption);
	$("#LinkDocument").toggle(gHasLinkSelectDocumentOption);		
	

}

// HADW CR: looks like always called with false
function setHasListDeleteOption(hasOption) {
	gHasListDeleteOption = hasOption;
	// Show or hide template document selection and attribute show/hide controls
	if (gHasListDeleteOption)
		$(".hideShowListDelete").show();
	else
		$(".hideShowListDelete").hide();
}

function hideShowFolderColumns() {
	// if the given page doesn't support "Folder" column. simply skip this method
	if (typeof gProjectFolders == "undefined") return;
	
	var attrcolspan = 4;
	if (gHasListDeleteOption) attrcolspan++;
	if (gHasNewDocumentOption) attrcolspan++;
	if (typeof gProjectFolders != "undefined") attrcolspan++;

	// hide "Folder" selection column in Documents Table if current project has no folders,
	// otherwise show the "Folder" column
	if (gProjectFolders != null && gProjectFolders.length > 1)
	{
		// (the first element is always the root folder)
		$(".hideShowFolderColumn").show();
		for (var i = 1; i <= gDocumentCounter; i++) {
			$("#documentAttrsCellSpanId" + i).attr("colSpan", attrcolspan);
		}
	}
	else
	{
		$(".hideShowFolderColumn").hide();
		for (var i = 1; i <= gDocumentCounter; i++) {
			$("#documentAttrsCellSpanId" + i).attr("colSpan", attrcolspan-1);
		}
	}
	
	if (typeof checkShowHideFolderColumnBOM != 'undefined') {
		checkShowHideFolderColumnBOM();
	}
}

function setHasLinkBrowseDocumentOption(hasLink) {
	gHasLinkBrowseDocumentOption = hasLink;
}


function setHasCopyDocumentOption(hasCopy) {
	gHasCopyDocumentOption = hasCopy;
}

// show a particular document attribute row and adjust icons accordingly
// This function can be called :-
// (1) When uploading from a Document section :- documentIndex will be a numeric value
// (2) When uploading from a BOM section :- documentIndex will be "BOM" with a numeric value concatenated to the end
function showDocumentAttributes(documentIndex) {
	var documentAttributesRowId = "documentRowId" + documentIndex + "Attributes";
	var documentAttributesDivId = "documentDivId" + documentIndex + "Attributes";
	var documentAttributesHideIconId = "documentAttributesHideIconId" + documentIndex;
	var documentAttributesShowIconId = "documentAttributesShowIconId" + documentIndex;
	if ($("#" + documentAttributesDivId).children().length > 0) {
		$("#" + documentAttributesHideIconId).show();
		$("#" + documentAttributesRowId).show();
	}
	else {
		$("#" + documentAttributesHideIconId).hide();
		$("#" + documentAttributesRowId).hide();
	}
	$("#" + documentAttributesShowIconId).hide();
	
	if(typeof checkShowHideBOMAttributes != 'undefined') {
		checkShowHideBOMAttributes();
	}
	
	// Check expand after doing something with attributes
	checkExpand();
}

// hide a particular document attribute row and adjust icons accordingly
function hideDocumentAttributes(documentIndex) {
	var documentAttributesRowId = "documentRowId" + documentIndex + "Attributes";
	var documentAttributesDivId = "documentDivId" + documentIndex + "Attributes";
	var documentAttributesHideIconId = "documentAttributesHideIconId" + documentIndex;
	var documentAttributesShowIconId = "documentAttributesShowIconId" + documentIndex;
	if ($("#" + documentAttributesDivId).children().length > 0) {
		$("#" + documentAttributesShowIconId).show();	
	}
	else {
		$("#" + documentAttributesShowIconId).hide();
	}
	$("#" + documentAttributesRowId).hide();
	$("#" + documentAttributesHideIconId).hide();
	
	// Check expand after doing something with attributes
	checkExpand();
}

// show all document attributes
function showAllDocumentAttributes() {
	if (gDocumentRowIds != null) {
		for(var g = 0; g < gDocumentRowIds.length; g++) {
			var documentIndex = gDocumentRowIds[g].substring("documentRowId".length);
			showDocumentAttributes(documentIndex);
		}
	}
}

// hide all document attributes
function hideAllDocumentAttributes() {
	if (gDocumentRowIds != null) {
		for(var g = 0; g < gDocumentRowIds.length; g++) {
			var documentIndex = gDocumentRowIds[g].substring("documentRowId".length);
			hideDocumentAttributes(documentIndex);
		}
	}
}

// show expand/collapse
function checkExpand() {
	// if there no attribute information: hide expand
	var count = $("#documentsTableId img[id^='documentAttributesShowIconId']").filter(":visible").length + $("#documentsTableId img[id^='documentAttributesHideIconId']").filter(":visible").length;
	// +/- visible
	if (count > 0) {
		$("#DocAttrShowHideAll").show();
	}
	else {
		$("#DocAttrShowHideAll").hide();
	}
}
window.checkExpand = checkExpand;

/**
* validate a single document row in a documents table, either in upload, project creation or BOM
* @author unkown, commented, restyled and changed by HADW
* @param {String} type - The operation which will be done Browse, Copy, Move, Link, New
* @param {String} index - suffix which will be added to all ID's of control fields to find the right one in the table. For BOM these indexes are like BOM1, BOM2.
* @return {Boolean} true when all ok, false when there is a problem.
* @desc HADW CR remark: if something is wrong, only a generic message is shown. It doesn't say what exactly is wrong --> could be more user friendly
* @desc HADW CR remark: what about the operations Link and Move?
*/
function validateDocumentRow(type, index)
{
	"use strict";
	try {
		
		if ( type == 'Browse' ) {
			var docfile = document.getElementById("documentFileNameId"+ index );
			if ( docfile != null ) {
				if (isWhitespace(docfile.value)) {
					return false;
				}
			} 
		
		} else if ( type == 'Copy' ) {
			// Copy exists in 2 flavors: 
			// 1. using Project/Folder document source --> check project and document
			// 2. using Search document source --> only check the docVersionId
			// You see the difference by seeing the type of the documentFileNameId field (which contains the docVersionId, not the file name). 
			// you need to select a source project and a source document
			var project = document.getElementById("documentProjectsId"+ index );
			var copyFromDoc = document.getElementById("documentFileNameId"+ index );

			if (project != null && project.selectedIndex == 0) return false;  // in case of Search, project will be null --> never returns false in that case
		
			if (copyFromDoc.tagName.toLowerCase() == 'input') {
				if (!copyFromDoc.value) return false;   // case of search: check whether something got into this line (should always be the case if the code works fine)
			} else {
				if (copyFromDoc.selectedIndex <= 0) return false ;  // checks for somebody not selecting anything	
			}
		
		} else if ( type == 'New' ) {
			// you need to select a template
			var doctemplate = document.getElementById("documentTemplateId"+ index );
			if ( doctemplate !=null ) {
				if (doctemplate .selectedIndex == 0 ) return false; 
			} 
		} else if ( type == 'Select' ) {  // Add to Bill of Materials
			var selectDoc  = document.getElementById("documentSelectId"+ index );
			if (selectDoc  && selectDoc.selectedIndex == 0) return false;				
		}
	} catch (err) {
		alert('Problem in DocumentsTable.validateDocumentRow at line ' + err.lineNumber + '  : ' + err.message);
	}
	return true;
}

function getFileNameFromDocRow(type, index)
{
	if ( type == 'Browse' ) // browse
	{
		var docfile = document.getElementById("documentFileNameId"+ index );
		if ( docfile !=null )
		{
			return docfile.value;
		} 
	}
	
	return "";
}

//----------------------
// Even callback called upon a change on the 'Select Source Copy Project' dropdown box for an individual new document row
//author: JAMI
//
//params:
//- curSelectElem: DOM reference to the parent dropdown list element whose change event triggered call of this function
//- filterInputID: String; ID of the 'Filter Source Copy Projects' input field for the current new document row
//- documentSelectBoxId: String; ID of the 'Source Copy Documents' dropdown box for the current new document row
//
//NOTE: referes to 'gProjectID' > global variable defined in AddDocument.js
function processCopyProjectSelection(curSelectElem, filterInputID, documentSelectBoxId)
{
	//check whether the User hasnt selected the same Copy Project as Destination Project (which is not allowed)
	//this check is only valid when on the general Upload Document Page
	if (typeof gProjectID != "undefined" && gExistingProjectContext)
	{
		var curSelectedCopyProjectID = curSelectElem.value;
		if (curSelectedCopyProjectID == gProjectID)
		{
			//cannot Copy within the same project > let the user know
			//display feedback to the user
			alert(langStrings.invalidCopyProjectSelected);
			curSelectElem.selectedIndex = 0;
			
			//reset 'Source Copy Documents' dropdown box
			resetCopyDocumentSelector(documentSelectBoxId);
			return;
		}
	}
	
	
	//load 'Source Copy Documents' and handle the appropriate dropdown box
	loadProjectDocuments(curSelectElem, documentSelectBoxId);
}

//---------------
//Resets 'Source Copy Documents' dropdown box to its initial (disabled) state
//author: jami
//
//params:
//- documentSelectBoxId: String; ID of the 'Source Copy Documents' dropdown box for the current new document row
function resetCopyDocumentSelector(documentSelectBoxId)
{
	//1. remove any potential OPTION items
	$('#'+documentSelectBoxId+" > option").remove();
	//2.add 'No Project Selected' option
	var copyDocSelectElem = $('#'+documentSelectBoxId);
	copyDocSelectElem.append('<option value="" selected="selected">' + langStrings.noProjectSelected + '</option>');
	//3.disable the dropdown box
	copyDocSelectElem.prop('disabled', true);
}

/**
 * Function that handles document template selection dialog
 * @param documentCounter {int} - Defines row in document upload table. First row has counter 1. 
 * 		For single upload the value is -1. There are more special values - check preSelectSourceDocument()
 * 		function for more details.
 * @param dlsObj {Object} - document source object defining the New action
 */
function OpenDocTemplateSelection(documentCounter, dlsObj) {
	try {
		require(["jquery", "jqueryUI"], function($){
			// GEMU 
			// The code has been re-worked due to the Fixed Template processing now working correctly and flagging a problem
			// If this hadn't been done :-
			// (1) The first time into the Fixed Template processing would be fine.
			// (2) The second (and subsequent) time(s) on the same page, would have seen the template selection dialog remaining visible
			//
			// This was due to the timing of the template dialog being opened and closed. In the old code :-
			// (1) With an ajax call - drops thru' to open the dialog, then return from ajax closes it = OK
			// (2) No ajax call - closes the unopened dialog first, then opens it = NG 

			// set the document counter and dlsObj in the dialog
			if ($("#documentCounter")[0] != null) {
				$("#documentCounter")[0].value = documentCounter; 
				
				// here next to documentCounter value the whole DLS (Document Link Source) object is stored in 
				// "dlsObj" property of hidden "documentCounter" input field. This is to support cases when
				// OpenDocTemplateSelection() method is called with one parameter only. 
				// Check:
				// - DocumentsTable.refreshDocTemplateContent()
				// - AddDocuments.ToggleDocUploadSourceType()
				// At least the first one is called under some circumstances - see DT122891...
				if (!$("#documentCounter")[0].dlsObj)
					$("#documentCounter")[0].dlsObj = dlsObj;
				else if (!dlsObj) {
					// use what's stored in "documentCounter" only if there is no dlsObj provided via parameter!
					dlsObj = $("#documentCounter")[0].dlsObj;
				}
			}
			
			var onClose = function(){
				if (gVisibleSelects) { gVisibleSelects.show(); gVisibleSelects = null; }
			};
			
			// create the dialog used for selecting the templates
				var buttonObj = new Object();
				buttonObj[this.langStrings['cancel']]= function(){ 
						$("#documentTemplateDialog").dialog("close");
	//					if (gVisibleSelects) { gVisibleSelects.show(); gVisibleSelects = null; }
					};
				buttonObj[this.langStrings['ok']] = function(){ 
						$("#documentTemplateDialog").dialog("close");
						var localDocCounter = -1;
						if ($("#documentCounter")[0] != null)
							localDocCounter = $("#documentCounter")[0].value;

						preSelectSourceDocument($("#documentTemplateDialogContent")[0].value, localDocCounter, dlsObj);
						//if (gVisibleSelects) { gVisibleSelects.show(); gVisibleSelects = null; }
					};
					
				// get size of the browser's window and adapt the dialog size according to it.
					// Minimal size is 700x450px, which should be OK even for screens with 800x600 resolution.
					var viewportHeight = $(window).height();
					var dialogHeight = viewportHeight - viewportHeight / 10;
					if (dialogHeight < 450) dialogHeight = 450;
					
				$("#documentTemplateDialog").dialog({
						autoOpen: false, 
						modal: false,
						overflow: scroll,
						width: 600,
						modal: true, 
						position: { my: "center top", at: "center top+80 ", of: window },
						buttons: buttonObj,
						close: function(){
							onClose();
						},
						closeText: "",
						maxHeight: dialogHeight
						
					});
				
				//JAMI > IE error with overlaying dropdown boxes --> just hide them for when the dialog is opened
				gVisibleSelects = $('select').filter(':visible'); // remember which ones were visible
				gVisibleSelects.hide();
			
			//define event handler when the User closes the dialog window
			//$(".ui-dialog-titlebar-close").hide();
			
			//change the colors(css style class) of the buttons
			//$('.ui-dialog-buttonpane button:contains(yes)').attr("class", "xxx");
			//$('.ui-dialog-buttonpane button:contains(no)').attr("id", "xxx");
			
			// exception: open selects that are on the dialog 
			$("#selectChar").show();
		
			if ($("#selectChar2")[0] != null) {
				if ($("#selectChar2")[0].length > 0) $("#selectChar2").show();
				else $("#selectChar2").hide();
			}
				
			// call the SDK page to get more info
			if (gDocumentTemplateSelectionInitialized == false) 
			{
				var selectedCharId = '';
				if ( $("#documentCharacteristic") != null) {
					if($("#documentCharacteristic")[0] != null) {
						selectedCharId = $("#documentCharacteristic")[0].value;   
					} else {
						selectedCharId = $("#documentCharacteristic").value;
					}
				}
		
				ajax({
					url: "GetProjectCreationInfo.jsp?loadThumbnails=1&action=LoadTemplateDocuments&projectID=" + gProjectID +"&doccharid="+selectedCharId,
					type: "GET",
					data: "xml",
					debug: false,
					synchronous: false,
					onError: function(status) {
						if (status == "998"){
							status = "SESSION EXPIRED (998)";
						}
						window.alert("Unable to get project creation info. Server status: "+status);
					},
					onSuccess: function(xml) 
					{
						$("#documentTemplateDialog").dialog("open"); 	
						gTemplateDocsLoaded = true;
						FillUpDocumentTemplatesDropDownSelectAndDialog(false, xml);		
						filterDocumentTemplateDialog(dlsObj);
						gDocumentTemplateSelectionInitialized = true;
					}
				});  // End Ajax code
			} else {
				$("#documentTemplateDialog").dialog("open"); 	
				filterDocumentTemplateDialog(dlsObj);
			}
		});
	} catch (err) {
		alert("Problem in OpenDocTemplateSelection() in DocumentsTable.js: " + err);
	}
}

/**
* Called from the OK button of the New dialog
* @param {Object} dlsObj - object defining the document source. Can be null in case of calling from single upload page
*/
function preSelectSourceDocument(sourceDocumentID, documentCounter, dlsObj)
{
	// Caters for a template selection list with no entries and 'Ok' clicked
	if (sourceDocumentID == null || sourceDocumentID.trim() == "") {
		return
	}

	// get a correct document row index ('counter') based on documentCounter value
	// note special cases when documentCounter < 0... only then a new document row is added and that is
	// the reason why counter needs to be pre-incremented in these cases. the global counter gets 
	// auto-incremented within the addRow() / addBOMRow() function!
	var counter = documentCounter;
	if (documentCounter == -1) counter = gDocumentCounter + 1;  // from a doc. upload page
	else if (documentCounter == -2) counter = "BOM" + (gBOMDocumentCounter + 1);  // from a BOM page

	// add new row in document/BOM table only if documentCounter has the value (-1 or -2)
	// the document type is always "new"
	if (documentCounter == -1) addRow(2, null, dlsObj);   // "new" doc. source on document upload;
	else if (documentCounter == -2) addBOMRow(2, null, dlsObj);   // "new" doc. source on BOM
		
	//--------------------------------
	//handle SINGLE DOC UPLOAD context
	//--------------------------------
	if (isSinglePageUpload())
	{
		var sourceElem = $("#Select_SourceNewDoc")[0];
		// set the value to the selected template 
		if (sourceElem != null)
		{
			var options = sourceElem.options;
			if (options != null)
			{
				for (var i = 0; i < options.length; i++)
				{
					if ( options[i].value == sourceDocumentID);
					{
						sourceElem.selectedIndex = i-1;
						sourceElem.value = sourceDocumentID;
					}
				}
			}	
		}
		ProcessSelectedTemplateDoc(sourceElem, true, counter);
		return ;
	}
 	
	//--------------------------------
	//handle MULTI-DOC UPLOAD context
	//--------------------------------	
	var docSelectionCol = "#documentSelectionColId" + counter;
	var documentTemplateId = "#documentTemplateId" + counter;  
	var documentTemplateName = "#documentTemplateName" + counter;  
	
	var documentType = "#documentType" + counter;
	
	var label = "";
	if (dlsObj) {
		label = dlsObj.label.getLabel();
	}
	setDocumentType("New", counter, label);
	
	// Set the text label to the selected document template name	
	for(var i = 0; i < gTemplateDocumentList.length; i++) {
		if (sourceDocumentID == gTemplateDocumentList[i].id) {
			$(documentTemplateName).text(gTemplateDocumentList[i].name);
			break;
		}
	}
	// Set hidden field to selected document template id
	if ($(documentTemplateId)) $(documentTemplateId).val(sourceDocumentID); 
	getDocumentAttributes($(documentTemplateId)[0], counter);
					
	// look up the name of the document
	updateNameToTemplateSelection(counter);
	
	// handle target folder
	setFolderName($(documentTemplateId)[0], counter);
	
									
	// hide the selection
	//var html = "<img id=\"showThumbnailId\" height=\"50\" border=\"1\" width=\"50\" title=\"thumbnail\" name=\"showThumbnail\" src=\"" + thumbnail  + "\">";
	//html +=  "<input type=\"hidden\" name=\"" + "documentType" +counter + "\" id=\"" + "documentType" +counter + "\" value=\"New\"/" ;
	//	$(documentTypeId)[0].innerHTML = html+$(documentTypeId)[0].innerHTML ;
					
	if ($(documentType)[0].colSpan != null) $(documentType)[0].colSpan = 2;
	$(docSelectionCol).hide();
			
	if (gVisibleSelects) { gVisibleSelects.show(); gVisibleSelects = null; }
	
	//JAMI: DT108458 > ...as the 'Temp Doc. Selector' dialog is not prepared by us,... 
	//...we cannot use event handling framework of TEP - need to handle 'TEP is modified' feedback explicetly (by using taskExPage global variable instance)
	
	//check for existence of an initialized TEP JS object instance first 
	if (taskExPage) {
		//set the modified flag of the Docs section to TRUE
		try {
				var docsTEPSection = taskExPage.pageSections.documents;
				if (docsTEPSection && docsTEPSection != null){
					//set the docs section as modified
					docsTEPSection.setModified();
				}
		}
		catch (err) {
			alert("Problem in TEP:addNewDocumentRow > PageSection.prototype.setModified error: " + err);
		}
	}
}

function preSelectCopyDocument(sourceDocumentID, sourceDocumentName, sourceDocumentDesc, sourceDocumentThumb)
{
	// insert a new row
	// check which type it needs to be (for now, it is a new document type)
					
	javascript:addRow(4);
	counter = gDocumentCounter;
		
	var docElemID = 'documentFileNameId' + counter;
	var docSrcTxt = 'documentFileNameTxtId' + counter;
	var docDesc = 'documentDescriptionId' + counter;
	// add value as an option in a hidden selected, because existing functionality depends on this
	$("#"+docElemID).append('<option value="'+sourceDocumentID+'" selected="selected">'+sourceDocumentName+'</option>'); 
	if(sourceDocumentThumb){
		$("#"+docSrcTxt).before('<img width="50" height="50" border="0" align="middle" src="'+sourceDocumentThumb+'" />&nbsp;&nbsp;');
	}
	$("#"+docSrcTxt).append(sourceDocumentName); 
	$("#"+docDesc).val(sourceDocumentDesc); 
	
	changeFileName(counter);
	
	processDocType(sourceDocumentID, sourceDocumentName, counter, false, true);
}

/*
* Fills up the dropdown select box that is used to pick a Document Template for uploading a new Document (id: Select_SourceNewDoc)
*/
function FillUpDocumentTemplatesDropDownSelectAndDialog( onlyDesignFiles, xml ) {
	try {
		
		//modify the DD listboxes only if
		if (gTemplateDocumentList != null && gTemplateDocumentList.length > 0 && gTemplateDocsLoaded)
		{				
			//clear the template docs. lists
			$("#Select_SourceNewDoc").empty();
			$("#Select_Template_Document").empty();
			
			//insert the first 'dummy OPTION' item into the appropriate list
			//alert("FillUpDocumentTemplatesDropDownSelect adding 'Please Select' item");
			var pleaseSelectOptionHTML =  '<option value="" selected="selected">'+langStrings.pleaseSelect+'</option>';
			
			// for single document upload only
			$("#Select_SourceNewDoc").append(pleaseSelectOptionHTML);
			$("#Select_Template_Document").append(pleaseSelectOptionHTML);
			
			var nodethumbnailList = xml.getElementsByTagName("template_doc_thumbnail");
			
			
			gTemplateDocumentThumbnailList = new Array();
			if(nodethumbnailList != null && nodethumbnailList.length > 0) 
			{
				for(var i = 0; i < nodethumbnailList.length; i++) 
				{
					var id 			= WCXML.GetElementText(nodethumbnailList[i], "id", false);
					var thumbnail  	= WCXML.GetElementText(nodethumbnailList[i], "thumbnail", false);

					gTemplateDocumentThumbnailList.push({id: id , thumbnail: thumbnail});						 				
				}
			}
			
			
			
			//...and now go through the list and add a new OPTION item into the appropriate list
			var curTempDocID, curTempDocHTML, curTempDocHTMLLong;
			
			var dialogContentHTML = "";
			
			dialogContentHTML += '<table class="ordtable">';
			
			for (var i = 0; i < gTemplateDocumentList.length; i++)
			{
				//retrieve the basic data for the current Template Document
				curTempDocID = gTemplateDocumentList[i].id;
				curPreprocessedTempDocName = gTemplateDocumentList[i].name;
				
				var mimeType = curPreprocessedTempDocName.substr(curPreprocessedTempDocName.lastIndexOf('.')).toUpperCase(); 
				
				// The document source can provide a list of allowed templates (smaller than the full list). 
							
				
				if (!onlyDesignFiles ||  mimeType=='.ARD'  ) // when the filter is not turned on, or whether it is a design file, add the file to the selection
				{
					curTempDocHTML = '<option value="'+curTempDocID+'" >'+curPreprocessedTempDocName+'</option>';
					curTempDocHTMLLong = '<option value="'+curTempDocID+'" >'+curPreprocessedTempDocName+'</option>';
					
					
					
					// look the thumbnail up
					for (var j = 0 ; j < gTemplateDocumentThumbnailList.length ; j++ )
					{
						if ( gTemplateDocumentThumbnailList[j].id == curTempDocID)
						{	
							thumbnail = gTemplateDocumentThumbnailList[j].thumbnail ;
							
							dialogContentHTML += '<tr name="selp" id="selp'+curPreprocessedTempDocName+'"><td>';
							
							//alert ("Option to be inserted - " + curTempDocHTML);
							dialogContentHTML += "<p onclick=\"ToggleTemplate(document.getElementById('selectDocumentTemplate"+i+"'))\">";
							dialogContentHTML += "<input type=\"radio\" value=\"" +curTempDocID + "\" name=\"selectDocumentTemplate\" id=\"selectDocumentTemplate"+i+"\" onClick=\"ToggleTemplate(this)\">&nbsp;";
							dialogContentHTML +="<img align=\"middle\" border=\"0\" height=\"50\" width=\"50\" src=\""+thumbnail+"\" />";
							dialogContentHTML += "&nbsp;&nbsp;" + curPreprocessedTempDocName;
							dialogContentHTML += "</input>";
							dialogContentHTML +="</p>";
							
							dialogContentHTML += '</td></tr>';
							j = gTemplateDocumentThumbnailList.length;
						}
					}
					
					
					//...and add it into the appropriate dropdown box
					$("#Select_SourceNewDoc").append(curTempDocHTML);
					$("#Select_Template_Document").append(curTempDocHTMLLong);
					
					$("#documentTemplateDialogInfoMessage").hide();
					
				}
			}
			
			dialogContentHTML += '</table>';
			
			try{
				var obj=document.getElementById("documentTemplateDialogContent");
				obj.innerHTML = dialogContentHTML;
			}
			catch(err)
			{
				alert("Failed to update HTML block: " + err);
			}
			
			$("#characteristicfilterrow").show();	
				 
			if ($("#selectChar")!=null)
				$("#selectChar").show();
		}
	} catch(err) {
		alert('Problem in DocumentsTable.FillUpDocumentTemplatesDropDownSelectAndDialog method at line ' + err.lineNumber + ' : ' + err.message);
	}
}

function filterDocumentTemplateDialog(dlsObj) {
	try {
		var nTemplatesAllowed = gTemplateDocumentList.length;
		var firstAllowedTemplateID = null;
		
		//check if we have specific DocumentLink configuration for Template Documents
		if (dlsObj && dlsObj.docTemplateName) {
		
			nTemplatesAllowed = 0;  // counts how  many templates are shown and if only 1, autoselects it
			var templArr = dlsObj.docTemplateName.split(',');
			if (templArr.length == 1) templArr = dlsObj.docTemplateName.split(';');  // allow splitting with , or ;
			var allowedArr = [];  // remembers which entries are allowed
			
			for (var i = 0; i < gTemplateDocumentList.length; i++) {
				var curPreprocessedTempDocNameLower;
				curTempDocID = gTemplateDocumentList[i].id;
				if 	(gTemplateDocumentList[i].name) curPreprocessedTempDocNameLower = gTemplateDocumentList[i].name.toLowerCase();
					
				for (var idx = 0; idx < templArr.length; idx++) {
					var allowedTemplateName = templArr[idx];
					if (!allowedTemplateName) continue;
					allowedTemplateName = allowedTemplateName.replace(/^\s+|\s+$/g, '').toLowerCase();
					if ( allowedTemplateName == curPreprocessedTempDocNameLower) break; 
				}
				
				allowedArr[i] = (idx < templArr.length);
					
				if (allowedArr[i]) {
					nTemplatesAllowed++;
					if (nTemplatesAllowed == 1) firstAllowedTemplateID = curTempDocID;
				}
			}
		} else { // no specific DocLink-DocTemplate configuration? > check default Document Template Library selection available
			//initialize the ID of the first Document Template (will be used to preselect it automatically if its the only one avaialble)
			firstAllowedTemplateID = gTemplateDocumentList[0].id;
		}
			
		//if only a single Document Template is allowed...
		if (nTemplatesAllowed == 1 && firstAllowedTemplateID != null && firstAllowedTemplateID.length > 0) {
			require(["jquery", "jqueryUI"], function($){								
				$("#documentTemplateDialog").dialog("close");  // no dialog needed, only 1 valid possibility
				var docCounter = -1 ;
				if ($("#documentCounter")[0] != null) {
					docCounter = $("#documentCounter")[0].value;
				}
				preSelectSourceDocument(firstAllowedTemplateID, docCounter, dlsObj);
				if (gVisibleSelects) { gVisibleSelects.show(); gVisibleSelects = null; }
			});
		} else if (nTemplatesAllowed == gTemplateDocumentList.length) {	
			$("#nrDocuments")[0].innerHTML = nTemplatesAllowed; // fill out the number of documents at the top of the dialog, possibly even 0
			if ($("#selectDocumentTemplate0")) {
				$("#selectDocumentTemplate0").prop('checked', true);
				$("#documentTemplateDialogContent")[0].value = $("#selectDocumentTemplate0").val();				
			}		
			$("#documentTemplateDialogFilter").prop('disabled', false);  // nothing taken out --> enable filter
			for (var i = 0; i < gTemplateDocumentList.length; i++) {  // show all: can have been hidden by a previous click on a different New button
				var pElem = document.getElementById("selp"+gTemplateDocumentList[i].name);
				if (pElem) pElem.style.display = ''; 	
			}
		} else {		
			$("#nrDocuments")[0].innerHTML = nTemplatesAllowed; // fill out the number of documents at the top of the dialog, possibly even 0
			var initialized = false;
			for (var i = 0; i < gTemplateDocumentList.length; i++) {
				var pElem = document.getElementById("selp"+gTemplateDocumentList[i].name);
				if (!allowedArr[i]) {
					//$("#selp"+gTemplateDocumentList[i].name).hide();	 // does not seem to work
					if (pElem) pElem.style.display = 'none'; // while this works					
				} else {
					if (pElem) {
						pElem.style.display = ''; 	
						if (!initialized) {
							if ($("#selectDocumentTemplate"+i)) $("#selectDocumentTemplate"+i).prop('checked', true);			
							$("#documentTemplateDialogContent")[0].value = $("#selectDocumentTemplate"+i).val();				
							initialized = true;
				}
			}
				}
			}

			$("#documentTemplateDialogFilter").prop('disabled',true);
			$("#documentTemplateDialogFilter").val('');
		}
	} catch(err) {
		alert('Problem in DocumentsTable.filterDocumentTemplateDialog method at line ' + err.lineNumber + ' : ' + err.message);
	}

}

function refreshDocTemplateContent()
{
	
	var docCounter = -1;
	if ($("#documentCounter")!=null)
		docCounter = $("#documentCounter")[0].value;
	
	// reset the existing documents
	gDocumentTemplateSelectionInitialized= false;
	
	//gTemplateDocumentList = null ; 
	$("#documentTemplateDialogContent").innerHTML = "";
	
	OpenDocTemplateSelection(docCounter);
	 	
}

function docCharSelected(elem)
{
	// set the document characteristic
	if ( $("#documentCharacteristic")!=null)
		$("#documentCharacteristic")[0].value = elem.value;

	if ( $("#documentCharacteristiclevel")!=null)
		$("#documentCharacteristiclevel")[0].value = elem.attributes["level"].value ;
			

	// when this is a first level selection, populate the list of the second level and show the second level 
	if (elem.attributes["level"].value == '1')
	{
		// when the selected element is the first one ('ALL'), hide the second box		
		if ( elem.value == '') 
		{
			$("#selectChar2").val("");
			$("#selectChar2").hide();
		}
	
		// look up the available options 
		else if ( gCharacteristicsTree!=null && gCharacteristicsTree[elem.value] != null  )
		{
			var subtree = gCharacteristicsTree[elem.value] ; 
		
			// when no suboption, make this cleam
			if (subtree.length ==0   )
			{
				var selectBox = $("#selectChar2")[0];
		
				while(selectBox.length > 0)
					selectBox.remove(0);
					
				$("#selectChar2").hide();
			}
			else 
			{
				// first empty the select box!
				var selectBox = $("#selectChar2")[0];
		
				while(selectBox.length > 0)
					selectBox.remove(0);
		
				// the label of the first element is the same as the label of the parent. 
				suboption = document.createElement('option');
				suboption.text = $("#selectChar")[0].options[0].text;
				suboption.value =  "";
				
				try{
					selectBox.add(suboption, null );	
				} catch(ex) { 
					selectBox.add(suboption); // IE 
				}
				
					
				for (var i = 0 ; i <subtree.length ; i++ )
				{
					var char2 = subtree[i] ;
					suboption = document.createElement('option');
					suboption.text =  char2[1];
					suboption.value =  char2[0];
					try{
						selectBox.add(suboption, null );	
					} catch(ex) { 
						selectBox.add(suboption); // IE 
					}			
				}
				// populate the second selector and show it 
			$("#selectChar2").show();
			} 		
		} 		
	} 
}

function ToggleTemplate(elem)
{
	$("#documentTemplateDialogContent")[0].value = elem.value ;
	elem.checked = true; 
} 

function ChangeDocumentTemplateDialogFilter(elem)
{
//	alert('Filter: '+elem.value);
	try {
		if (elem.value!='')
		{
			$("tr[name=selp]").hide();  // first hide everything
			var filter = elem.value.toLowerCase(); // make it case insensitive
			$("tr[name=selp]").each(function(i,n) {
			    var name = $(n).attr("id").toLowerCase();   // encoding problems!
			    if (name.indexOf(filter)!=-1) {
					$(n).show();
				}
			});	
		}
		else
			$("tr[name=selp]").show();
	}
	catch (err) 
	{
		alert("Selector problem: " + err);
	}
}

/**
 * Validate documents to be added to the Project before submitting them
 * 
 * @param languageStrings
 * @param prefix for example "BOM" because the BOM documents have something like "documentTypeIdBOM1" instead of "documentTypeId"
 * @param uniqueNameCheckObj - if this is passed, add names of documents here, instead of doing it independently
 * @param processedACatObjs - array of attribute categories that are about to be submitted
 * 
 * @returns {Boolean}
 */
function validateDocuments(languageStrings, prefix, uniqueNameCheckObj, processedACatObjs)
{
	var allSpecifiedDocRowsAreValid = true ;
	var atLeastOneDocSpecified = false;
	var docNamesAreUnique = true ;
	var unknownDocTypeUploadAttempted = false;
	var allDocDescriptionsValid = true ;
	var msgDescription = '';
	
	var unsupportedDocTypeFilesString = "";
	
	var independentNameChecking = false;
	if(!uniqueNameCheckObj){
		uniqueNameCheckObj = window.eventBasedValidator.createUniqueNamesObj();
		independentNameChecking = true;
	}
	 
			
	// check whether there is at least one document specified 
	for (var docAttIdx = 1; docAttIdx <= gDocumentCounter ; docAttIdx++) {
		var prefixedDocAttIdx = "" + prefix + docAttIdx;
		var docUploadTypeID = document.getElementById("documentTypeId"+ prefixedDocAttIdx);
		if (docUploadTypeID != null) // there is a document row
		{
			var currentRowName= document.getElementById("documentNameId" + prefixedDocAttIdx ).value ;
			atLeastOneDocSpecified = true ;
			if (!validateDocumentRow(docUploadTypeID.value, prefixedDocAttIdx) )
			{
				allSpecifiedDocRowsAreValid = false ;
			}
			
			var docDescription = document.getElementById("documentDescriptionId"+ prefixedDocAttIdx);
			if (docDescription != null && !validateDocDescription(docDescription.value)) {
				msgDescription += '\n Document ' + docAttIdx + ' : ' + docDescription.value;
				allDocDescriptionsValid = false ;
			}		
			
			//DT#89886 : check whether the current document is of a supported Doc. Type
			if (!validateDocTypeSupport(docUploadTypeID.value, prefixedDocAttIdx))
			{
				unknownDocTypeUploadAttempted = true;
				
				//append the current document name to the err. string for later use
				var curFileName = getFileNameFromDocRow(docUploadTypeID.value, prefixedDocAttIdx);
				if (curFileName != null && curFileName != "")
				{
					if (unsupportedDocTypeFilesString != "")
					{
						unsupportedDocTypeFilesString += "; ";
					}
					
					unsupportedDocTypeFilesString += curFileName;
				}
			}
			 
			// check whether the specified name of the document is unique
			var docTypeId = '';

			// DT104102: document type must be deducted from file name, not name (can be edited)
			//           but only in case of 'Browse' upload type.
			//           In case of 'New'/'Copy' -> take over the doctype of the source document
			if (docUploadTypeID.value == 'Browse') 
			{
				var fileName  = document.getElementById("documentFileNameId"+ prefixedDocAttIdx ).value;
				if (fileName != null && fileName.length > 0) {
					var extension = getExtension(fileName); 
					docTypeId = getDocTypeIdBasedOnExtension(extension);
				}
			} else if (docUploadTypeID.value == 'Copy') {
				//as we are copying an existing WCR Document > need to load its real Doc Type
				//cannot rely on file extension
				
				//get Document Version ID of the selected source document
				var sourceDocumentVersionID = $("#documentFileNameId" + prefixedDocAttIdx + " option:selected").val();
				// In case of a fixed template, we need to find another way to select the sourceDocumentversionID 
				// GRBO: Gemu, I need your help to find a better solution. This is a bit implicit. 
				if (sourceDocumentVersionID == null)
					sourceDocumentVersionID = $("#documentFileNameId" + prefixedDocAttIdx ).val();
				
				if (sourceDocumentVersionID) {
					docTypeId = getSourceDocumentTypeID(sourceDocumentVersionID, null);		
				}
			} else if (docUploadTypeID.value == 'New') {
				//as we are using an existing WCR 'Template Document' > need to load its real Doc Type
				//cannot rely on file extension
				
				//get Document Version ID of the selected source template document
				var sourceDocumentID = document.getElementById("documentTemplateId"+ prefixedDocAttIdx ).value;
				var sourceDocumentVersionID = getTemplateDocVersionIDByDocID(sourceDocumentID);
				if (sourceDocumentVersionID) {
					docTypeId = getSourceDocumentTypeID(sourceDocumentVersionID, gUploadProjectID);	
				}
					
			}
		
			var autoName = true ;
			if (docTypeId != '')  // check whether autoname is used 
			{
				 var docTypeSettings = gDocTypeConfigs[docTypeId];
				 if (docTypeSettings!=null)
				 	autoName  = docTypeSettings['Autoname On'];				
			}

			if (!autoName){
				// add to check for unique names
				var projId = '';
				if(document.actionform.targetProjectID){
					projId = document.actionform.targetProjectID.value
				}
				if(document.actionform.projectID){
					projId = document.actionform.projectID.value;
				}
				uniqueNameCheckObj.addDoc($("#documentNameId" + prefixedDocAttIdx), projId);
			} 
		}
	}

	// If gProjectCreationForm exists, check for required field before checking number of documents
	if (prefix === "BOM" && (typeof(gProjectCreationForm) === 'undefined' || gProjectCreationForm.bom === 'REQUIRED') && (!atLeastOneDocSpecified)) 
	{
		alert(languageStrings.selectAtLeastOneBOMDoc);
		return false;
	}
	
	if (!allSpecifiedDocRowsAreValid)
	{
		alert(languageStrings.invalidDocument );
		return false;
	}
	// specify unique names for the documents to upload 
	if (!docNamesAreUnique) {
		alert(languageStrings.docNamesNotUnique);
		return false;
	}

	// all document descriptions are valid
	if (!allDocDescriptionsValid) {
		alert(languageStrings.invalidDocDescription + msgDescription);
		return false;
	}
	
	//at least one document has a non-supported document type
	if (unknownDocTypeUploadAttempted) 
	{
		alert(languageStrings.unsupportedDocumentTypeMultiDoc + " " + unsupportedDocTypeFilesString);
		return false;
	}
	
	if (!processedACatObjs) {
		processedACatObjs = [];
	}
	// document attribute validation
	for (var docAttIdx = 1; docAttIdx <= gDocumentCounter; docAttIdx++) {
		var docACatObj = document.getElementById("documentDivId" + prefix + docAttIdx + "Attributes");
		if (docACatObj && docACatObj.ACatObj) 
		{
			if (!docACatObj.ACatObj.syncPrepareForSubmit())
			{
				//attributes were not validated succesfully (alert window was already displayed - just bail out)
				return false;
			}
			if (!docACatObj.ACatObj.isDestroyed) {
				processedACatObjs.push(docACatObj.ACatObj);
			}
		}
	}
	
	// check for unique names
	if(independentNameChecking){
		window.eventBasedValidator.validateNamesGlobally(uniqueNameCheckObj);
		if(!uniqueNameCheckObj.isOk()){
			return false;
		}
	}
	
	var asyncWorkAfterValidation = [];
	for (var awIdx = 0; awIdx < processedACatObjs.length; awIdx++) {
		asyncWorkAfterValidation.push(processedACatObjs[awIdx].whenAllAsyncWorkDone());
	}
	Promise.all(asyncWorkAfterValidation).then(function() {
		for (var awIdx = 0; awIdx < processedACatObjs.length; awIdx++) {
			processedACatObjs[awIdx].convertDocReferencesToXML();
		}

		// JQuery's submit action is only valid on the form. 
		// Since a custom submit is assed to input fields, we will trigger this one manually.
		$('input[id^="documentNameId'+ prefix +'"]').trigger("submit");
	})
	.catch(function(reason) {
		if (console && console.error) {
			console.error("Exception in asynchronous task: " + reason);
		} else {
			alert("Exception in asynchronous task: " + reason);
		}
	})

	return true;
}

/**
 * Returns Document Type ID of a specific WCR document
 * 
 * @param documentVersionID
 * @param projectID [OPTIONAL; indicates a use Template Document > projectID needed for access authorization]
 * @return (String) Id of the Document Type / empty if the request cannot be completed
 */
function getSourceDocumentTypeID(documentVersionID, projectID) {
	var sourceDocTypeID = '';
	
	//prepare the URL for AJAX call ()
	var ajaxURL = "GetDocUploadInfo.jsp?action=LoadSourceDocumentTypeID&documentVersionID="+documentVersionID;
	if (projectID != null && projectID.length > 0) {
		ajaxURL = ajaxURL+"&projectID="+projectID;
	}
	
	ajax({
		url: ajaxURL,
		type: "GET",
		data: "xml",
		debug: false,
		synchronous: true,
		onError: function(status) {
			if (status == "998"){
				status = "SESSION EXPIRED (998)";
			}
			window.alert("Unable to load Document Type ID for the specified Document Version. Server status: "+status);
		},
		onSuccess: function(xml) 
		{
			var err = WCXML.GetElementText(xml, "error", false);
			if (err) { // oops - some error occured when loading Document Type ID
				alert(err);
			} else {
				//get the Document Type ID from the returned XML
				var responseVal = WCXML.GetElementText(xml, "doc_type_id", false);
				if (responseVal != null && responseVal.length > 0) {
					sourceDocTypeID = responseVal;
				}
				
			}
		}
	});  // End Ajax code
	
	return sourceDocTypeID;
}

/**
 * Attempts to find a Document Version ID corresponding to a passed Document ID from the list of Template Documents 
 * 
 * @param documentID
 * @returns docVersionID (NULL if not found)
 */
function getTemplateDocVersionIDByDocID(documentID) {
	if (documentID != null && gTemplateDocumentList != null && gTemplateDocumentList.length > 0) {
		for (var tempDocIdx = 0; tempDocIdx < gTemplateDocumentList.length; tempDocIdx++) {
			var curTempDocID = gTemplateDocumentList[tempDocIdx].id;
			if (curTempDocID === documentID) {//matching document ID in the list of Document Templates
				return gTemplateDocumentList[tempDocIdx].docverid;	
			}
		}
	}
	
	return null;
}
