<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY copy "&#169;">
  <!ENTITY nbsp "&#160;">
  <!ENTITY lk "/webcenter_page/user_lang_key">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:XSLUtils="com.esko.webcenter.jsp.XSLUtils" xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr" exclude-result-prefixes="XSLUtils Lang">
  <xsl:import href="template.xsl"/>
  <xsl:import href="templatedate.xsl"/>
  <xsl:import href="attributetemplates.xsl"/>

  
  <xsl:variable name="useTableBodyContainer" select="false()" />
  
  
  
  <xsl:variable name="isCurProjTemplate">
  	<xsl:choose>
  		<xsl:when test="/webcenter_page/cur_project_is_template"><xsl:value-of select="true()" /></xsl:when>
  			<xsl:otherwise><xsl:value-of select="false()" /></xsl:otherwise>
  	</xsl:choose>
  </xsl:variable>
  
  <xsl:variable name="isCopyDocument">
	  <xsl:choose>
		<xsl:when test="count(/webcenter_page/is_copy_document) &gt; 0"><xsl:value-of select="true()"/></xsl:when>
	  	<xsl:otherwise><xsl:value-of select="false()"/></xsl:otherwise>
	  </xsl:choose>	
  </xsl:variable>
  
  <xsl:variable name="isProjectTaskUpload">
	  <xsl:choose>
		<xsl:when test="count(/webcenter_page/cur_project_task) &gt; 0"><xsl:value-of select="true()"/></xsl:when>
	  	<xsl:otherwise><xsl:value-of select="false()"/></xsl:otherwise>
	  </xsl:choose>	
  </xsl:variable>
  
  <xsl:variable name="isUploadMulti">
	  <xsl:choose>
		<xsl:when test="/webcenter_page/upload_type = 'multi'"><xsl:value-of select="true()"/></xsl:when>
	  	<xsl:otherwise><xsl:value-of select="false()"/></xsl:otherwise>
	  </xsl:choose>	
  </xsl:variable>
  
<!-- check whether this is a 'move document' variant - uses 'copy document' page/functionality, except has to send the info to client to change the labels and submit method   -->
<!-- test for document Move must be every time before the test on the document copy - because when moving document, isCopyDocument variable is also true. This way it avoids some changes on frontend and some hackish coding is just in this place -->
  <xsl:variable name="isMoveDocument">
	  <xsl:choose>
		<xsl:when test="count(/webcenter_page/is_move_document) &gt; 0"><xsl:value-of select="true()"/></xsl:when>
	  	<xsl:otherwise><xsl:value-of select="false()"/></xsl:otherwise>
	  </xsl:choose>	
  </xsl:variable>
  
  
  <xsl:variable name="runStandard">
	  <xsl:choose>
		<xsl:when test="count(/webcenter_page/run_standard) &gt; 0"><xsl:value-of select="true()"/></xsl:when>
	  	<xsl:otherwise><xsl:value-of select="false()"/></xsl:otherwise>
	  </xsl:choose>	
  </xsl:variable>

  <xsl:variable name="documentID"><xsl:value-of select="/webcenter_page/document_id"></xsl:value-of></xsl:variable>
  <xsl:variable name="docVersionID"><xsl:value-of select="/webcenter_page/document_version_id"></xsl:value-of></xsl:variable>
  <xsl:variable name="docName"><xsl:value-of select="/webcenter_page/document_name"></xsl:value-of></xsl:variable>
  <xsl:variable name="docVersionCatId"><xsl:value-of select="/webcenter_page/document_category_id"></xsl:value-of></xsl:variable>
  
  
  
	<!-- 
  
		Template that controls the generation of the body header
            
	-->
	<xsl:template name="bodyheader">
		<xsl:call-template name="DisplayHeaderWithAction">
			<xsl:with-param name="NoPrimaryAction" select="true()"/>
			<xsl:with-param name="Name">			
				<xsl:choose>
					<xsl:when test="$runStandard = 'true'">
					  	<xsl:value-of select="Lang:getStr(&lk;,'UPLOADDOC_RUNSTANDARD')"/>&nbsp;&nbsp;<xsl:value-of select="/webcenter_page/document_name"/>
				  	</xsl:when>
				  	<xsl:when test="$isMoveDocument = 'true'">
					  	<xsl:value-of select="Lang:getStr(&lk;,'UPLOADDOC_MOVEDOCUMENT')"/>&nbsp;&nbsp;<xsl:value-of select="/webcenter_page/document_name"/>
				  	</xsl:when>				  	
				  	<xsl:when test="$isCopyDocument = 'true'">
					  	<xsl:value-of select="Lang:getStr(&lk;,'UPLOADDOC_COPYDOCUMENT')"/>&nbsp;&nbsp;<xsl:value-of select="/webcenter_page/document_name"/>
				  	</xsl:when>
				  	<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$isProjectTaskUpload = 'true'">
								<xsl:value-of select="Lang:getStr(&lk;,'UPLOADDOCINTOTASK_TAG')"/>&nbsp;<xsl:value-of select="/webcenter_page/cur_project_task/project_wctask/name"/>
						  	</xsl:when>
						  	<xsl:otherwise>
						  	  	<xsl:value-of select="Lang:getStr(&lk;,'ADDDOCUMENT_TAG')"/>
						  	</xsl:otherwise>
						</xsl:choose>
				  	</xsl:otherwise>
				</xsl:choose>
			</xsl:with-param>
			
				<xsl:with-param name="Action">
					<xsl:if test="not($isCopyDocument = 'true') ">
						<xsl:value-of select="Lang:getStr(&lk;,'MULTIUPLOAD_DOCS')"/>
					</xsl:if>		
				</xsl:with-param>
				<xsl:with-param name="Url">
					<xsl:if test="not($isCopyDocument = 'true') ">
						<xsl:value-of select="'javascript:FollowUploadAppletLink();'"/>
					</xsl:if>		
				</xsl:with-param>
				<xsl:with-param name="Action2">
					<xsl:if test="not($isCopyDocument = 'true') and not($isUploadMulti = 'true')">
						<xsl:value-of select="Lang:getStr(&lk;,'MULTIADD_DOCS')"/>
					</xsl:if>		
				</xsl:with-param>
				<xsl:with-param name="Url2">
					<xsl:if test="not($isCopyDocument = 'true') ">
						<xsl:value-of select="'javascript:SwitchDocUploadType();'"/>
					</xsl:if>		
				</xsl:with-param> 
			
		</xsl:call-template>	
	</xsl:template>
  
  <!-- 
  
            template that controls extensions to the body tag 
            
  -->
  <xsl:template name="bodyextensions">
    <xsl:attribute name="onload">initializePage();</xsl:attribute>
  </xsl:template>

  <!-- 
  
            template that controls the generation of the body content
            
  -->
  <xsl:template name="bodycontent">
  
  	<xsl:variable name="hasProjectContext">
  		<xsl:choose>
  			<xsl:when test="/webcenter_page/cur_project_data">1</xsl:when>
  			<xsl:otherwise>0</xsl:otherwise>
  		</xsl:choose>
  	</xsl:variable>
  	
  	<xsl:variable name="hasFolderContext">
  		<xsl:choose>
  			<xsl:when test="/webcenter_page/cur_project_data/has_folder_context">1</xsl:when>
  			<xsl:otherwise>0</xsl:otherwise>
  		</xsl:choose>
  	</xsl:variable>
  	
	<input type="hidden" id="DocRenderConfigXML" name="DocRenderConfigXML" value="{/webcenter_page/docrenderingsetup}"/>
				
 	<form name="actionform" id="actionform" method="post" action="doprojectactions.jsp" enctype="MULTIPART/FORM-DATA" class="wcr-form"> 
		<input type="hidden" name="actionVal" value="UploadNewDocument"/>
		<input type="hidden" name="menu_file" value="{menu_file}"/>
		<input type="hidden" name="uploadType" id="uploadType" value="{upload_type}"/>
						
		<!-- doc type params -->
		<input type="hidden" name="singlePDFDocType" id="singlePDFDocType" value=""/>
		<input type="hidden" name="singleZIPDocType" id="singleZIPDocType" value=""/>
		<input type="hidden" name="selectedDocType" id="selectedDocType" value=""/>
		
		<!--  approval cycle params -->
		<input type="hidden" name="ApprovalRequiredCheck" id="ApprovalRequiredCheck" value=""/>
		<input type="hidden" name="StartApprovalCycle" id="StartApprovalCycle" value=""/>
		
		<input type="hidden" name="targetProjectID">
			<xsl:attribute name="value">
				<xsl:value-of select="/webcenter_page/cur_project_data/project/@id"/>
			</xsl:attribute>
		</input>
		
		<input type="hidden" name="targetFolderID">
			<xsl:if test="($hasProjectContext = '1') and ($hasFolderContext = '1')">
				<xsl:attribute name="value">
					<xsl:choose>
						<xsl:when test="/webcenter_page/cur_project_data/cur_folder_id">
							<xsl:value-of select="/webcenter_page/cur_project_data/cur_folder_id"/>
						</xsl:when>
						<xsl:otherwise>ROOT</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
			</xsl:if>
		</input>
		
		<input type="hidden" name="targetTaskID" value="{/webcenter_page/cur_project_task/project_wctask/@id}"/>
		
		<input type="hidden" name="curProjectSelectedIndex" value=""/>

		<input type="hidden" id="maxNrProjects" value="{/webcenter_page/max_projects}"/>
		
		<!-- run as standard -->
		<input type="hidden" name="runAsStandard" id="runAsStandard" value="{$runStandard}"/> 
	
			<div class="form-section">
				<p class="text-center help-block" id="noprojects" name="noprojects" style="display:none;">
					<xsl:value-of select="Lang:getStr(&lk;,'NO_TARGET_PROJECTS_FOR_UPLOAD')" />
				</p>	  								
				<!-- Write 'destination' row ('pick a Project/Folder' dropdown boxes) -->
				<xsl:call-template name="DestinationSetupRow"/>
				
						<!-- Write button/links row -->
<!-- 										
						<xsl:call-template name="ActionButtonsRow"/>
-->			
						
						<p class="help-block" id="messageRowId" style="display:none;">
				</p>
				
				<!-- write the 'Upload Single Doc.' fields -->
				<xsl:call-template name="SingleDocUploadDetails"/>
				
				<!-- write the 'Upload Multiple Docs.' fields -->
				<xsl:call-template name="MultipleDocsUploadDetails"/>
				
				<!-- Write 'Extra Template Doc' row -->
				<xsl:call-template name="TemplateDocSelectorRow"/>
						
				<!-- Write 'Extra Add to BOM' row -->
				<xsl:call-template name ="DocAddToBOMRow" />
				
				<!-- write the 'Document Attributes' controls -->
				<xsl:call-template name="DocAttributesRow"/>
				
				<!-- write the 'Approval Setup' controls -->
				<xsl:call-template name="ApprovalSetupRow"/>
				
				<!-- Write button/links row -->
				<xsl:call-template name="ActionButtonsRow">
					<xsl:with-param name="showLinks"><xsl:value-of select="true()"/></xsl:with-param>
				</xsl:call-template>
	  			
		</div>
   </form>
		
	
	<!-- create dummy location for modal popups relevant to this page -->
	<xsl:call-template name="ProjectChangeResetPopup"/>
		
	
			<xsl:call-template name="SelectDocumentTemplateDialog"/>
		
			
  </xsl:template>
  
  
  <!-- 
  
  This template writes the row with 'Upload/Upload Mutliple Document/Use Upload Applet' buttons
  
  -->
  <xsl:template name="ActionButtonsRow">
  	<xsl:param name="showLinks" select="true()"/>
  	
  	<div class="form-group ActionButtonsRow" style="display:none;">
  		<label class="offset-label"></label>
  		<div class="form-entry">
  			<!-- 'UPLOAD' and 'CANCEL' buttons-->
  			<xsl:choose>
				<xsl:when test="$runStandard = 'true'">
		  			<input type="button" value="{Lang:getStr(&lk;,'PROJDETAILSRUNSTANDARDDOC_TAG')}" name="UploadButton" id="UploadButton" class="btn btn-primary" onClick="SubmitDocUploadForm()"/>
	  			</xsl:when>
	  			<xsl:when test="$isMoveDocument = 'true'">
		  			<input type="button" value="{Lang:getStr(&lk;,'MOVE')}" name="UploadButton" id="UploadButton" class="btn btn-primary" onClick="javascript:MoveDocument('{$docVersionID}', '{$documentID}'); return false;"/>
	  			</xsl:when>	  									
	  			<xsl:when test="$isCopyDocument = 'true'">
		  			<input type="button" value="{Lang:getStr(&lk;,'DOCDETAILSCOPY_TAG')}" name="UploadButton" id="UploadButton" class="btn btn-primary" onClick="SubmitDocUploadForm()"/>
	  			</xsl:when>
	  			<xsl:otherwise>
		  			<input type="button" value="{Lang:getStr(&lk;,'UPLOAD_TAG')}" name="UploadButton" id="UploadButton" class="btn btn-primary" onClick="SubmitDocUploadForm()"/>
				</xsl:otherwise>											
			</xsl:choose>
			<input type="button" value="{Lang:getStr(&lk;,'CANCEL')}" name="CancelButton" id="CancelButton" class="btn btn-default" onClick="CancelButtonClicked()"/>
			<p id="UploadFeedback" class="help-block" style="display: none;">
				<xsl:value-of select="Lang:getStr(&lk;,'UPLOAD_STARTED_PLEASE_WAIT')"/>
			</p>
  		</div>
  	</div>
  </xsl:template>
  
  <!-- 
  	This template writes the form fields for uploading a Single Document
  -->
  <xsl:template name="SingleDocUploadDetails">
  	
	<!-- Write 'Doc Source' row -->
	<xsl:call-template name="SourceSetupRow"/>
	<div class="form-section add-padding-top">	
			
	<!-- Write 'Doc Type' row -->
	<xsl:call-template name="DocTypeInfoRow"/>
			
	<!-- Write 'Cape Doc Details' rows (will be hidden until a CAPE file is selected for upload) -->
	<xsl:call-template name="CapeDocDetailsRow"/>
			
	<!-- Write 'Cape Doc Details' rows (will be hidden until a PDF file is selected for upload) -->
	<xsl:call-template name="PDFDocDetailsRow"/>
	
	<!-- Write 'Zip File Details' rows (will be hidden until a ZIP file is selected for upload) -->
	<xsl:call-template name="ZipFileDetailsRow"/>

	<div class="form-group SingleDocUploadFieldsRow" id="DocNameSpacerRow" style="display:none;">  	
  	</div>
				
	<!-- Write 'Doc. Name' row -->
	<xsl:call-template name="DocNameRow"/>
	
	<!-- Write the copy options row -->
	<xsl:call-template name="CopyOptionsRow"/>
			
	<div class="form-group SingleDocUploadFieldsRow" id="DocDescriptionSpacerRow" style="display:none;">  	
  	</div>			
	
			
	<!-- Write 'Doc. Description' row -->
	<xsl:call-template name="DocDescriptionRow"/>
	</div>																	
  </xsl:template>
  
  <!-- 
  	This template writes the form fields for uploading Multiple Documents
  -->
  <xsl:template name="MultipleDocsUploadDetails">
	<!-- Write 'Doc Source' row -->
	<div class="form-group MultiDocUploadFieldsRow" id="MultiDocUploadFieldsRow" style="display:none;">
		<label class="offset-label"></label>
		<div class="form-entry full-width">		
			<xsl:call-template name="MultiDocumentUploadDetails"/>
		</div>
	</div>
  </xsl:template>
  
  <!-- 
  
  Write 'destination' row ('pick a Project/Folder' dropdown boxes)
  
  -->
  <xsl:template name="DestinationSetupRow">
  	<xsl:variable name="hasProjectContext">
  		<xsl:choose>
  			<xsl:when test="/webcenter_page/cur_project_data"><xsl:value-of select="true()" /></xsl:when>
  			<xsl:otherwise><xsl:value-of select="false()" /></xsl:otherwise>
  		</xsl:choose>
  	</xsl:variable>
  	<!-- Write the "Destination Dropdown Boxes" -->
  	<div class="form-section" id="DestinationSelectTable">  	
		 
		<!-- A row containing 'Destination Project/Folder' dropdown select controls --> 
		<div class="form-group" id="DestinationSelectRow">
			<!-- Write the 'TARGET PROJECT' label -->
			<label for="Select_Project">
				<xsl:choose>
					<xsl:when test="$isMoveDocument = 'true'">
						<xsl:value-of select="Lang:getStr(&lk;,'MOVE_TO_PROJECT')"/>
					</xsl:when>
					<xsl:when test="count(/webcenter_page/is_copy_document) &gt; 0">
					  	<xsl:value-of select="Lang:getStr(&lk;,'COPY_TO_PROJECT')"/>													  	
				  	</xsl:when>
				  	<xsl:otherwise>
						<xsl:value-of select="Lang:getStr(&lk;,'ADD_DOC_DESTINATION_PROJECT')" />
	  			  	</xsl:otherwise>
				</xsl:choose>
			</label>
			<div class="form-entry">
				<!-- 'PROJECT' selector dropdown box -->
				<div id="dynamic_target_project_container" style="display:none;">
	  				<select id="Select_Project" name="Select_Project" class="form-control"/>
	  			</div>
	  			<div class="row">
	  				<div class="col-md-6 col-xs-12">
			  			<p id="static_target_project_container" style="display:none;">
				  			yyy
				  		</p>
				  	</div>
				  	<div class="col-md-6 col-xs-12" id="ChangeDestinationLinkTD">
				  		<!-- 'Change Destination Project/Folder' action link-->
						<xsl:if test="(not($isCurProjTemplate = 'true') and not($isMoveDocument = 'true') and not(count(/webcenter_page/is_copy_document) &gt; 0))">
							<a href="javascript:EnableTargetProjectSelect();" class="btn btn-default" onclick="$('#ChangeDestinationLinkTD').addClass('hidden');">
								<xsl:value-of select="Lang:getStr(&lk;,'CHANGE_TARGET_PROJECT_LINK_TAG')" />
							</a>
						</xsl:if>
						<!-- 'Loading' helper row -->
						<span id="DestinationSelectLoadingRow">
						</span>
				  	</div>
				 </div>
	  			<!-- If In copy document mode, show a help message -->
	  			<p class="help-block">
		  			<xsl:if test="count(/webcenter_page/is_copy_document) &gt; 0">
			  			<xsl:choose>
							<xsl:when test="$isMoveDocument = 'true'">
								<xsl:value-of select="Lang:getStr(&lk;,'SELECT_PROJECT_FOLDER_TO_MOVE_DOCUMENT')"/>
							</xsl:when>
							<xsl:otherwise>
				  				<xsl:value-of select="Lang:getStr(&lk;,'SELECT_PROJECT_FOLDER_TO_COPY_DOCUMENT')"/>
				  			</xsl:otherwise>
			  			</xsl:choose>
			  		</xsl:if>
		  		</p>
			</div>
		</div> 
		
		
		<div class="form-group">
		
			<!-- 'FOLDER' label -->
			<label for="Select_Folder"><xsl:value-of select="Lang:getStr(&lk;,'FOLDER')" /></label>
			<div class="form-entry">
				<!-- 'FOLDER' selector dropdown box -->
				<div id="dynamic_target_folder_container" style="display:none;">
	  				<select id="Select_Folder" name="Select_Folder" class="form-control" onchange="HandleTargetProjectFolderChange();"/>
	  			</div>
	  			<p id="static_target_folder_container" style="display:none;">
	  				xxx
	  			</p>
			</div>
		</div>
		
		
	</div> 
  
  </xsl:template>
  
  <!-- 
  
  Write 'Document Source' selector row
  
  -->
  <xsl:template name="SourceSetupRow">

  	<div class="form-group SingleDocUploadFieldsRow" id="DocSourceRow" style="display:none;">
  		<label for="Select_Source_Type"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_SOURCE')"/></label>
  		<div class="form-entry">
  			<!-- 'SOURCE TYPE' selector dropdown box -->
  			<xsl:choose>
	  			<xsl:when test="$isCopyDocument = 'true'">
	  				<input type="hidden" id="Select_Source_Type" name="Select_Source_Type"  value="doc_source_copy"/>
	  			</xsl:when>
	  			<xsl:otherwise>
		  			<select id="Select_Source_Type" name="Select_Source_Type" class="form-control" onchange="ToggleDocUploadSourceType(true);ToggleGeneralDocTypeDetails(false);HandleComponentInputSelect();">
						<option value="doc_source_browse" selected="selected"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBER_BROWSE')"/></option>
						<option value="doc_source_copy"><xsl:value-of select="Lang:getStr(&lk;,'DOCDETAILSCOPY_TAG')"/></option>
						<!-- option value="doc_source_url"><xsl:value-of select="Lang:getStr(&lk;,'URL')"/></option-->
		  			</select>						
	  			</xsl:otherwise>
	  		</xsl:choose>
	  		<!-- 'BROWSE' doc upload type controls -->
	  		<div class="add-spacing-top" id="docFileInputTD">
	  			<!--  we use styledfile input to make the button primary -->
				<div class="file-input-selector" data-init="component/styledfileinput/StyledFileInput">
					<input type="file" name="docFileInput" id="docFileInput">
					<xsl:attribute name="onchange">ProcessDocMimeType(this, false);</xsl:attribute>
					</input>
					
					<a class="btn btn-primary"><xsl:value-of select="Lang:getStrBundle(&lk;, 'StyledFileInput', 'OPEN_FILE_BROWSER')"/></a>					
				</div>	
	  		</div>
	  		<!-- 'COPY' doc upload type controls -->
  			<xsl:if test="$isCopyDocument != 'true'">
	  			<div id="docCopySelectTD" class="add-spacing-top" style="display:none">
	  				<div id="SourceCopyProjectTD">
	  					<select id="Select_SourceCopyProject" name="Select_SourceCopyProject" class="form-control" />
	  				</div>
	  				<script type="text/javascript">
	  					require(["jquery", "component/sdrop/SDrop", "component/sdrop/dataproviders/SDropDataProvider"], function($, SDrop, SDropDataProvider){
	  						$(function(){
	  							if (!gProjectsWithDocumentsDataProvider){
	  								gProjectsWithDocumentsDataProvider = new SDropDataProvider({'dataSource': 'GetNameIDList.jsp?list=MyAllProjects'});
	  							}
	  							gCopyFromSDrop = new SDrop($("#Select_SourceCopyProject"), null, gProjectsWithDocumentsDataProvider, {'autoload': false, 'onChangedByUser': LoadProjectCopyDocuments.bind(this,$("#Select_SourceCopyProject")[0]), 'manageStyleAndWidth': false});
	  						});
	  					});
	  				</script>
	  				<div id="SourceCopyDocTD" class="add-spacing-top">
	  					<select id="Select_SourceCopyDoc" name="Select_SourceCopyDoc" class="form-control" disabled="disabled" onchange="ProcessDocMimeType(this, true);">
	  						<option value=""><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_NO_PROJ_SEL')"/></option>
	  					</select>
	  				</div>	  				
	  			</div>
  			</xsl:if>
  			
  			<xsl:choose>
  				<xsl:when test="$isCopyDocument = 'true'">
  					<input  type="hidden" id="Select_SourceCopyDoc" name="Select_SourceCopyDoc"  value="{/webcenter_page/document_version_id}"/>
  					<!-- <input  type="hidden" id="Select_SourceCopyDoc" name="Select_SourceCopyDoc"  value="{/webcenter_page/document_id}"/>
  					<input  type="hidden" id="Select_SourceCopyDocVersion" name="Select_SourceCopyDocVersion"  value="{/webcenter_page/document_version_id}"/> -->
  				</xsl:when>
  				<xsl:otherwise>
		  			<!-- 'NEW' doc upload type controls (document template select)-->
		  			<div id="docNewSelectTD" style="display:none" class="add-spacing-top">
		  				<select id="Select_SourceNewDoc" name="Select_SourceNewDoc" class="form-control" onchange="ProcessSelectedTemplateDoc(this, true);"/>
		  			</div>	
  				</xsl:otherwise>
			</xsl:choose>
			
			<!-- A dummy row that should be displayed only when loading and filling up the 'Template Documents' dropdown list -->
  			<div id="docNewLoadingTD" style="display:none"/>
  			
  			<!-- 'URL' doc upload type controls -->
  			<div id="docURLSelectTD" class="add-spacing-top" style="display:none">
				<xsl:variable name="UrlPlaceholder"><xsl:value-of select="Lang:getStr(&lk;,'URL')"/></xsl:variable>
  				<input id="Input_SourceURLDoc" class="form-control" name="Input_SourceURLDoc" placeholder="{$UrlPlaceholder}" onkeyup="ProcessDocMimeType(this, false);" onchange="ProcessDocMimeType(this, false);" size="80"/>
  			</div>  					
  				
  			<!-- abchor for the document thumbnail -->
  			<div id="SourceDocumentThumbnail" style="display:none"/>
  		</div>  		
  	</div>  
  </xsl:template>
  
  <!-- 
  
  Write 'doc type' info row (a simple r/o string)
  
  -->
  <xsl:template name="DocTypeInfoRow">
  	<div class="SingleDocUploadFieldsRow" id="DocTypeInfo_Spacer_Row" style="display:none;"/>
  	
  	<div class="section-title" id="DocDetails" style="display:none;">
		<label class="offset-label"/>
		<h3><xsl:value-of select="Lang:getStr(&lk;,'DOCDETAILS')"/></h3>
	</div>
  	
  	<div class="form-group SingleDocUploadFieldsRow" id="DocTypeInfo_Row" style="display:none;">
  		<!-- Write the row's label -->
  		<label><xsl:value-of select="Lang:getStr(&lk;,'DOCTYPE_TAG')"/></label>
  		<!-- Write the "Destination Dropdown Boxes" -->
  		<div class="form-entry">
  			<!-- Standart DOC TYPE label row (a simple text label)  -->
  			<div id="doc_type_label_row">
  				<!-- the actual doc type label -->
  				<p id="doc_type_label">  				
  				</p>
  			</div>
  			<!-- DOC TYPE row for a PDF file (either a simple label - if there is only a single doc. type for PDF; ...or a dropdown box with the supported doc. types)  -->
  			<div id="pdf_doc_type_label_row">
  				<!-- the actual doc type label -->
  				<div id="pdf_type_select_TD">
  					<select id="pdf_type_select" class="form-control" name="pdf_type_select" onChange="TogglePDFDocType(this, this.value);">
  						<!-- option value="graphics" selected="selected"><xsl:value-of select="Lang:getStr(&lk;,'GRAPHICS')"/></option>	
  						<option value="pagelist"><xsl:value-of select="Lang:getStr(&lk;,'PAGE_LIST')"/></option>	
  						<option value="other"><xsl:value-of select="Lang:getStr(&lk;,'OTHER')"/></option-->	
  					</select>
  				</div>
  			</div>
  			<!-- DOC TYPE row for a ZIP file (either a simple label - if there is only a single doc. type for ZIP; ...or a dropdown box with the supported doc. types)  -->
  			<div id="zip_doc_type_label_row">
  				<div id="zip_type_select_TD">
  					<!-- input type="hidden" name="singleZIPDocType" id="singleZIPDocType" value=""/-->
  					<select id="zip_type_select" class="form-control" name="zip_type_select" onChange="ToggleZipDocType(this, this.value);">
  						<!-- option value="other" selected="selected"><xsl:value-of select="Lang:getStr(&lk;,'OTHER')"/></option-->	
  					</select>
  				</div>
  			</div>
  		</div>
  	</div>
  
  </xsl:template>
  
  <!-- 
  
  Write 'Template Document' select row (a dropdown list; only shown if there are actually any template documents available)
  
  -->
  <xsl:template name="TemplateDocSelectorRow">
	<!-- Spacer Row -->
	<div class="SingleDocUploadFieldsRow" id="temp_doc_spacer_row" style="display:none;">
	</div>
	
	<div class="form-group SingleDocUploadFieldsRow" id="temp_doc_select_row" style="display:none;">
		<label for="Select_Template_Document"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_DOCUMENT_TEMPLATE')"/></label>
		<div class="form-entry">
			<select class="form-control" id="Select_Template_Document" name="Select_Template_Document"  onChange="ProcessSelectedTemplateDoc(this, false);"/>
		</div>
	</div>
  </xsl:template>
  
  	<!-- Write Add to BOM row. Only show when the user has ChangeBOM rights -->
	<xsl:template name="DocAddToBOMRow">
		<xsl:if test="/webcenter_page/bom_enabled = '1' ">
			<!-- Spacer Row -->
			<div class="SingleDocUploadFieldsRow" id="temp_doc_spacer_row" style="display:none;">
			</div>
			
			<div class="form-group SingleDocUploadFieldsRow" id="DocAddToBOMRow" style="display:none;">
				<label for="AddToBOM"><xsl:value-of select="Lang:getStr(&lk;,'ADD_DOCUMENTS_TO_BOM')" /></label>
				<div class="form-entry">
					<div class="checkbox">
						<label>
							<input type="checkbox" id="AddToBOM" name="AddToBOM" onclick="$('#AddToBOMCount').toggle();"/>
							<span id="AddToBOMCount" style="display:none;">
								<strong><xsl:value-of select="Lang:getStr(&lk;,'COUNT')" /></strong>&nbsp;&nbsp;
								<input type="input" id="countBOM" name="countBOM" size="7"/>	
								<input type="hidden" id="dec_countBOM" name="dec_countBOM" />
							</span>
						</label>
					</div>
				</div>
			</div>
			
		</xsl:if>
	</xsl:template>
  
  <!-- 
  
  Write 'Document Attributes' values row (only shown when a Template Document with some attributes connected to it)
  
  -->
  <xsl:template name="DocAttributesRow">
	
	
	<!-- Spacer Row -->
	<div id="doc_attributes_spacer_row_top1" style="display:none;">
	</div>
	
	<!-- Divider Row -->
	<div id="doc_attributes_divider_row_top" style="display:none;">
	</div>
  
	<!-- Spacer Row -->
	<div id="doc_attributes_spacer_row_top2" style="display:none;">
	</div>
	
	<div class="form-group" id="doc_attributes_row" style="display:none;">
		<label><xsl:value-of select="Lang:getStr(&lk;,'DOCDETAILSATTRS_TAG')"/></label>
		<!-- Write the "Document Template Dropdown" select -->
		<div class="form-entry full-width" id="DocAttributesContainer">
		</div>
	</div>
	
  	<!-- Spacer Row -->
  	<div class="SingleDocUploadFieldsRow" id="doc_attributes_spacer_row_bottom" style="display:none;">
  	</div>
	
	<!-- Divider Row -->
	<div class="SingleDocUploadFieldsRow" id="doc_attributes_divider_row_bottom" style="display:none;">
	</div>
  
  </xsl:template>
  
  <!-- 
  
  Write 'doc name' row
  
  -->
  <xsl:template name="DocNameRow">
  	<div class="form-group SingleDocUploadFieldsRow" id="DocNameRow" style="display:none;">
  		<!-- Write the row's label -->
  		<label for="Doc_Name" id="DocNameRowName" class="form-required"><xsl:value-of select="Lang:getStr(&lk;,'NAME')"/></label>
  		<label for="Doc_Name" style="display:none" id="DocNameRowNameSuffix">
  			<xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_EDIT_FIELD')"/>
  		</label>
  		<div class="form-entry">
  			<input id="Doc_Name" name="Doc_Name" class="form-control" size="80">
			<!--   	JIDO: this is here to disable doc name inputfor the move functionality - It is not possible to remove it, because it has to be here for some handling purposes(when choosing project/folder) and this is the easiest and cleanest solution as I believe -->		  						
	  			<xsl:if test="$isMoveDocument = 'true'">
					<xsl:attribute name="disabled"><xsl:value-of select="'disabled'"/></xsl:attribute>
				</xsl:if>
			</input>	
			<xsl:if test="$isCopyDocument = 'true' and $isMoveDocument = 'false'">
				<p class="help-block">
					<xsl:value-of select="Lang:getStr(&lk;,'COPYDOCUMENTAUTONAMINGTIP')"/>
				</p>				
			</xsl:if>					
  		</div>
  	</div>
  
  </xsl:template>
  
  <!-- 
  
  Copy options row.
  Write 'copy also annotations' and  'retain text status'.
  
  -->
  <xsl:template name="CopyOptionsRow">
  	<!-- when we are on this page because we want to copy a document... -->
  	<xsl:if test="$isCopyDocument = 'true' and $isMoveDocument = 'false'">
  		<!-- the SingleDocUploadFieldsRow class makes sure the row only appears when a target project is selected... -->
  		<div class="form-group SingleDocUploadFieldsRow" id="CopyAlsoAnnotationsRow" style="display:none;">
  			<label class="offset-label"></label>
  			<div class="form-entry">
  				<div class="checkbox">
  					<input type="checkbox" name="alsoCopyAnnotations"/>
  					<xsl:value-of select="Lang:getStr(&lk;,'COPYDOCUMENT_ALSOCOPYANNOTATIONS')"/>
  				</div>
  			</div>
  		</div>
  		<xsl:if test="/webcenter_page/isPCMEnabled = '1'">
	  		<div class="form-group SingleDocUploadFieldsRow" id="retainTextContentElementId" style="display:none;">
	  			<label class="offset-label"></label>
	  			<div class="form-entry">
	  				<div class="checkbox">
	  					<input type="checkbox" name="retainTextContentElementStatus"/>
	  					<xsl:value-of select="Lang:getStr(&lk;,'COPY_TEXTCONTENT_ELEMENT_STATUS')"/>
	  				</div>
	  			</div>
	  		</div>
	  	</xsl:if>	  	
	</xsl:if>
  </xsl:template>
  
  <!-- 
  
  Write 'doc descriptiom' row
  
  -->
  <xsl:template name="DocDescriptionRow">
  	
  	<div class="form-group SingleDocUploadFieldsRow" id="DocDescriptionRow" style="display:none;">
  		<!-- Write the row's label -->
  		<label for="doc_description"><xsl:value-of select="Lang:getStr(&lk;,'DESCRIPTION')"/></label>
  		<div class="form-entry">
  			<!-- Write the "Document Description" text area -->
  			<textarea name="doc_description" id="doc_description" cols="80" rows="3" class="form-control"/>
  		</div>
  	</div>
  
  </xsl:template>
  
  <!-- 
  
  Write 'approval preferences' row (if possible)
  
  -->
  <xsl:template name="ApprovalSetupRow">
		<!-- Spacer Row -->
		<div class="ApprovalSetupRow" id="apply_approval_settings_spacer_row" style="display:none;">
		</div>
	
		<!-- "Apply Default Approval Settings" row -->
		<div class="form-group ApprovalSetupRow" id="apply_approval_settings_row" style="display:none;">
			<label for="doApplyDefApprovalSettings"><xsl:value-of select="Lang:getStr(&lk;,'APPROVAL_START_CYCLE')"/></label>
			<div class="form-entry">
				<div class="checkbox">
					<label>
						<input type="checkbox" name="doApplyDefApprovalSettings" id="doApplyDefApprovalSettings" onclick="ToggleApplyApprovalSettings(this);"/>
						<xsl:value-of select="Lang:getStr(&lk;,'APPROVAL_REQUIRED_OPTION')"/>
					</label>
				</div>
			</div>
		</div>
		
	  	<!-- Spacer Row -->
	  	<div class="ApprovalSetupRow" id="start_approval_cycle_spacer_row" style="display:none;">
	  	</div>
	  	
		<!-- "Start Approval Cycle" row -->
		<div class="form-group ApprovalSetupRow" id="start_approval_cycle_row" style="display:none;">
			<label class="offset-label"></label>
			<div class="form-entry">
				<div class="checkbox">
					<label>
			  			<input type="checkbox" name="doStartApprovalCycle" id="doStartApprovalCycle" onclick="ToggleStartApprovalCycle(this);">
							<xsl:if  test="/webcenter_page/approval_restart_enable_checkbox='0'">
				  				<xsl:attribute name="DISABLED">
				  					<xsl:value-of select="DISABLED" />
				  				</xsl:attribute>
			  				</xsl:if>
			  				<!--  when the system settings specify to always start, start the approval cycle -->
			  				<xsl:if  test="/webcenter_page/approval_restart_option ='1'">
				  				<xsl:attribute name="value">
				  					<xsl:value-of select="1" />
				  				</xsl:attribute>
			  				</xsl:if>	  				
						</input>				
						<xsl:value-of select="Lang:getStr(&lk;,'APPROVAL_STATUS_STARTCYCLE')"/>
					</label>
				</div>
			</div>
		</div>
		
		<div class="form-group" id="AppAlwaysStart" style="display:none;">
			<label class="offset-label"></label>
			<div class="form-entry">
				<p>
					<xsl:value-of select="Lang:getStr(&lk;,'APPROVAL_WILL_AUTO_START')"/>
				</p>
			</div>
		</div>
		
		<div class="form-group" id="AppNeverStart" style="display:none;">
			<label class="offset-label"></label>
			<div class="form-entry">
				<p>
					<xsl:value-of select="Lang:getStr(&lk;,'APPROVAL_WILL_NOT_AUTO_START')"/>
				</p>
			</div>
		</div>
	  	
	
	  	<!-- Spacer Row -->
	  	<div class="ApprovalSetupRow" id="approval_due_date_spacer_row" style="display:none;">
	  	</div>

		<!-- "Approval Due Date" row -->
		<div class="form-group ApprovalSetupRow" id="approval_due_date_row" style="display:none;">
			<label for="longFormat_due_date"><xsl:value-of select="Lang:getStr(&lk;,'TODO_DUEDATE')"/></label>
			<div class="form-entry" id="apprDueDateTD">
				<xsl:call-template name="DisplayDateWithCalendar">
					<xsl:with-param name="date" select="/webcenter_page/due_date"/>
					<xsl:with-param name="ShowCalendarFormName" select="'actionform'"/>	
					<xsl:with-param name="ShowCalendarFieldName" select="'due_date'"/>	
					<xsl:with-param name="PeriodOfDayFieldName" select="'due_periodOfDay'" />
					<xsl:with-param name="longIntDate" select="/webcenter_page/default_due_date_time"/>						
<!-- 					<xsl:with-param name="labelTag" select="Lang:getStr(&lk;,'DUEDATE')"/> -->
<!-- 					<xsl:with-param name="onChange" select="'DueDateChanged'"/>	-->
				</xsl:call-template>
			</div>
		</div>	  	

	  	<!-- Spacer Row -->
	  	<div class="ApprovalSetupRow" id="approval_bottom_spacer_row" style="display:none;">
	  	</div>

	  	<!-- Divider Row -->
	  	<div class="ApprovalSetupRow" id="approval_divider_row" style="display:none;">
	  	</div>
	
  </xsl:template>
  
  <!-- 
  
  Write 'Cape Doc Details' row
  
  -->
  <xsl:template name="CapeDocDetailsRow">
	
	<!-- Spacer Row -->
	<div id="cape_spacer_xml_row" style="display:none;"/>
	
  	<div class="form-group" id="cape_doc_xml_row" style="display:none;">
  		<label for="capeDocXMLFile"><xsl:value-of select="Lang:getStr(&lk;,'CAPE_UPLOAD_XML')"/></label>
  		<!-- Write the "Cape Doc XML File" text area -->
  		<div class="form-entry">
  			<input type="file" name="capeDocXMLFile" id="capeDocXMLFile" size="60">
				<xsl:attribute name="onchange">CheckTextInput(this.value, '', 'capeDocXMLFile');</xsl:attribute>
				<xsl:attribute name="onkeyup">CheckTextInput(this.value, '', 'capeDocXMLFile');</xsl:attribute>
				<xsl:attribute name="onpropertychange">CheckTextInput(this.value, '', 'capeDocXMLFile');</xsl:attribute>	
			</input>
  		</div>
  	</div>
  	
  	<div id="cape_spacer_report_row" style="display:none;"/>
  	
  	<div class="form-group" id="cape_doc_report_row" style="display:none;">
  		<label><xsl:value-of select="Lang:getStr(&lk;,'CAPE_UPLOAD_REPORT')"/></label>
  		<!-- Write the "Report/Diagram File" text area -->
  		<div class="form-entry">
  			<input type="file" name="capeDocReportFile" id="capeDocReportFile" size="60">
				<xsl:attribute name="onchange">CheckTextInput(this.value, '', 'capeDocReportFile');</xsl:attribute>
				<xsl:attribute name="onkeyup">CheckTextInput(this.value, '', 'capeDocReportFile');</xsl:attribute>
				<xsl:attribute name="onpropertychange">CheckTextInput(this.value, '', 'capeDocReportFile');</xsl:attribute>	
			</input>
  		</div>
  	</div>
  	
  
  </xsl:template>
  
  <!-- 
  
  Write 'PDF/Pagelist Doc Details' row
  
  -->
  <xsl:template name="PDFDocDetailsRow">
  	<xsl:variable name="hasPagelistType"><xsl:value-of select="/webcenter_page/upload_doc_types/doc_type_list/doc_type[@id='00001_0000000014']/enabled"/></xsl:variable>
  	<xsl:variable name="hasOtherType"><xsl:value-of select="/webcenter_page/upload_doc_types/doc_type_list/doc_type[@id='00001_0000000005']/enabled"/></xsl:variable>
  	<xsl:variable name="hasGraphicsType"><xsl:value-of select="/webcenter_page/upload_doc_types/doc_type_list/doc_type[@id='00001_0000000004']/enabled"/></xsl:variable>
  	
	<xsl:if test="($hasGraphicsType = '1') and (($hasPagelistType = '1') or ($hasOtherType = '1'))">
		<!-- Doc Type Tip Row -->
		<div class="form-group docTypeTipTR" id="pdf_tip_index_row" style="display:none;">
			<label class="offset-label"></label>
			<div class="form-entry">
				<p class="help-block">
					<strong><xsl:value-of select="Lang:getStr(&lk;,'UPLOAD_TIP_START')"/></strong>
					<xsl:if test="$hasPagelistType = '1'">
						<xsl:text>&nbsp;</xsl:text>
						<xsl:value-of select="Lang:getStr(&lk;,'UPLOAD_TIP_PDF_PAGELIST')"/>
					</xsl:if>
					<xsl:if test="$hasOtherType = '1'">
						<xsl:text>&nbsp;</xsl:text>
						<xsl:value-of select="Lang:getStr(&lk;,'UPLOAD_TIP_PDF_OTHER')"/>
					</xsl:if>
				</p>
			</div>
		</div>
	</xsl:if>
		
	<!-- Spacer Row -->
	<div id="pdf_spacer_pagelist_index_row" style="display:none;"/>
		
  	<div class="form-group" id="pdf_pagelist_index_row" style="display:none;">
  		<label for="Pagelist_Index"><xsl:value-of select="Lang:getStr(&lk;,'PAGELIST_UPLOAD_INDEX_FIRST_PAGE')"/></label>
  		<div class="form-entry">
  			<input id="Pagelist_Index" class="form-control" name="Pagelist_Index" size="6" value="1"/>
  		</div>
  	</div>
  	
  </xsl:template>
  
  <!-- 
  
  Write 'ZIP File Details' row
  
  -->
  <xsl:template name="ZipFileDetailsRow">
	
  	<xsl:variable name="hasOtherType"><xsl:value-of select="/webcenter_page/upload_doc_types/doc_type_list/doc_type[@id='00001_0000000005']/enabled"/></xsl:variable>
  	<xsl:variable name="hasGraphicsType"><xsl:value-of select="/webcenter_page/upload_doc_types/doc_type_list/doc_type[@id='00001_0000000004']/enabled"/></xsl:variable>
  	<xsl:variable name="hasCHILIType"><xsl:value-of select="/webcenter_page/upload_doc_types/doc_type_list/doc_type[@id='00001_0000000018']/enabled"/></xsl:variable>
  	
  	<xsl:variable name="isZipAsGraphicType">
  		<xsl:choose>
  			<xsl:when test="/webcenter_page/graphic_files_extensions/extension = '.zip'">1</xsl:when>
  			<xsl:otherwise>0</xsl:otherwise>
  		</xsl:choose>
  	</xsl:variable>
  	
	<xsl:if test="($hasGraphicsType = '1') and ($isZipAsGraphicType = '1') and (($hasOtherType = '1') or ($hasCHILIType = '1'))">
		<!-- Doc Type Tip Row -->
		<div class="form-group docTypeTipTR" id="zip_tip_row" style="display:none;">
			<label class="offset-label"></label>
			<div class="form-entry">
				<p class="help-block">
					<strong><xsl:value-of select="Lang:getStr(&lk;,'UPLOAD_TIP_START')"/></strong>
					<xsl:text>&nbsp;</xsl:text>
					<xsl:value-of select="Lang:getStr(&lk;,'UPLOAD_TIP_ZIP_GRAPHICS')"/>
				</p>
			</div>
		</div>
	</xsl:if>

	<!-- Spacer Row -->
	<div id="zip_spacer_pagelist_toggle_row" style="display:none;"/>
	
	<div class="form-group" id="unzip_file_toggle_row" style="display:none;">
		<label class="offset-label"></label>
		<!-- Write the "Unzip file and store contained files individually" checkbox toggle -->
		<div class="form-entry">
			<div class="checkbox">
				<input type="checkbox" name="doUnzipArchive" id="doUnzipArchive" onclick="toggleUnzipArchive(this);"/>
				<xsl:value-of select="Lang:getStr(&lk;,'UNZIP_WHEN_UPLOADING')"/>
			</div>
		</div>
	</div>
  	
  </xsl:template>
  
	<!--
		Template to show 'multiple documents' fields
	-->
	<xsl:template name="MultiDocumentUploadDetails">
		<div id="projectDocumentsBlockId" >
			<xsl:call-template name="NewDocumentsSelector"/>
		</div>
	</xsl:template>
	
	<!--
		Template to show table/formular to add new documents and specify their parameters
	-->
	<xsl:template name="NewDocumentsSelector">
		<table width="100%">
			<tr>
				<td colspan="4">
					<div id="documentsTableContainerDiv"/>
					<div id="documentsTableHiddenDiv" class="displayNone"/>
				</td>
			</tr>
			<tr style="display:none;" class="alwaysHidden">
				<td>
					<textarea id="documentSourcesTextArea" cols="200" rows="4">
						<!-- currently there is no 'doccreation_setup_xml' in the generated XML, it's loaded dynamically via AJAX!
						<xsl:value-of select="/webcenter_page/doccreation_setup_xml"/>
						-->
						<xsl:value-of select="/webcenter_page/doccreation_setup_xml"/>	
					</textarea>
					<div id="documentSourcesHiddenDiv"/>
				</td>
			</tr>
		</table>		
	</xsl:template>
	
	<!-- 
		This template contains an HTML definition of a modal popup window that is displayed to warn
		the user that he will lose his current new document upload setup by changing the target project
	-->
	<xsl:template name="ProjectChangeResetPopup">
		<div style="display: none;" class="form-group add-spacing" id="projectChangeResetDialog">
			<xsl:attribute name="title">
				<xsl:value-of select="Lang:getStr(&lk;,'UPLOAD_DOC')"/>
			</xsl:attribute>
			
			<p id="changeProjectWarningMessage" class="">
				<xsl:value-of select="Lang:getStr(&lk;,'CHANGE_TARGET_PROJECT_RESET_WARNING')"/>	
			</p>
			
			<p id="errorMessage" class=""/>
			
			<p id="changeProjectWarningQuery" class=""> 
				<xsl:value-of select="Lang:getStr(&lk;,'CHANGE_TARGET_PROJECT_RESET_QUERY')"/>
			</p>
		</div>
  </xsl:template>

  	  
  <!-- 
  
            template that controls the inclusion of javascript functionality 
            
  -->
  <xsl:template name="scriptincs">
  
		<script src="javascript/validate.js" type="text/javascript"/>
		<script src="javascript/TableSelection.js" type="text/javascript"/>
		<script src="javascript/search.js" type="text/javascript"/>
		<script src="javascript/popup.js" type="text/javascript"/>
		<script src="javascript/extpopup.js" type="text/javascript"/>
		<script src="javascript/detailswin.js" type="text/javascript"/>

		<script src="javascript/DocumentsTable.js" type="text/javascript"/>
		<script src="javascript/AddDocument.js" type="text/javascript"/>
		<script src="javascript/webcenter_ajax.js" type="text/javascript"/>
		<script src="javascript/webcenter_xml.js" type="text/javascript"/>
		<script src="javascript/webcenter_html.js" type="text/javascript"/>
		<script src="javascript/hover.js" type="text/javascript"/>
		<script src="javascript/projdetailsbom.js" type="text/javascript"/>
    
		<xsl:call-template name="i18n">
			<xsl:with-param name="keys">
				INVALID_COUNT|
				INVALID_COUNT_EMPTY
			</xsl:with-param>
		</xsl:call-template>
    
    <script type="text/javascript">	
    
	// Intialise Language Strings Object
	langStrings = { noTemplate: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOTMPLTAVAIL')"/></xsl:call-template>",
						noProjects: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOPROJSSAVAIL')"/></xsl:call-template>",
						noDocuments: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NODOCSAVAIL')"/></xsl:call-template>",
						noProjectSelected: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_NO_PROJ_SEL')"/></xsl:call-template>",
						loading: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_LOADING')"/></xsl:call-template>",
						pleaseSelect: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_SELECT')"/></xsl:call-template>",
						noGroup: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NO_GROUP')"/></xsl:call-template>", 
						noUsers: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'GROUPHASNOUSERS')"/></xsl:call-template>",
						projectCreationWarning: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_WARNING')"/></xsl:call-template>",
						projectMemberWarning: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBER_WARNING')"/></xsl:call-template>",
						browse: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBER_BROWSE')"/></xsl:call-template>",
						copy: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'COPY')"/></xsl:call-template>",
						newString: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NEW_TAG')"/></xsl:call-template>",
						link: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBER_LINK')"/></xsl:call-template>",
						del: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'DELETE_TAG')"/></xsl:call-template>",
						expand: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_EXPAND')"/></xsl:call-template>",
						collapse: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_COLLAPSE')"/></xsl:call-template>",
						singleDocUpload: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SINGLEUPLOAD_DOC')"/></xsl:call-template>",
						multiDocUpload: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MULTIUPLOAD_DOCS')"/></xsl:call-template>",
						yes: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'YESUSEKEYWORD')"/></xsl:call-template>",
						no: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOUSEKEYWORD')"/></xsl:call-template>",	
						ok: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'OK')"/></xsl:call-template>",
						cancel: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CANCEL')"/></xsl:call-template>",
						unsupportedDocumentType: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'BADUPLOADEXTHINT')"/></xsl:call-template>",
						unsupportedDocumentTypeMultiDoc: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'BADUPLOADEXTMULTIDOCVALIDATE')"/></xsl:call-template>",
						urlSourceType: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'URL')"/></xsl:call-template>",
						componentSourceType: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'COMPONENT')"/></xsl:call-template>",
						blankDocName: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'INVALIDDOCNAMEMSG')"/></xsl:call-template>",
						emptyTargetProjectField: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'EMPTYTARGETPROJECT')"/></xsl:call-template>",
						emptyTargetProjectFolderField: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SELECTDESTFOLDER')"/></xsl:call-template>",
						emptyFileUploadField: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'BADUPLOADDOC')"/></xsl:call-template>",
						emptyCapeXMLFileField: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CAPE_UPLOAD_NOXML')"/></xsl:call-template>",
						emptyCopyDocField: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'EMPTYCOPYDOCSOURCE')"/></xsl:call-template>",
						emptyTemplateDocField: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'EMPTYTEMPLATEDOC')"/></xsl:call-template>",
						emptyTDocURLField: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'BADDOCURL')"/></xsl:call-template>",
						badCapeCLFZCPFileExt: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CAPE_UPLOAD_BADCLF_OR_ZCP')"/></xsl:call-template>",
						badCapeXMLFileExt: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CAPE_UPLOAD_BADXML')"/></xsl:call-template>",
						badCapeReportFileExt: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CAPE_UPLOAD_BADREPORT')"/></xsl:call-template>",
						invalidPagelistStartIndexVal: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PAGELIST_ERR_VALUE_INDEX')"/></xsl:call-template>",
						rootProject: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ROOT_FOLDER_TAG')"/></xsl:call-template>",
						invalidDocument: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_DOCUMENT')"/></xsl:call-template>",
						invalidDocDescription	: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_DOC_DESCR')"/></xsl:call-template>",																			
						selectAtLeastOneDoc: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_SELECT_DOCUMENT')"/></xsl:call-template>",										
						docNamesNotUnique: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_SPECIFY_UNIQUE_DOCNAMES')"/></xsl:call-template>",
						invalidCopyProjectSelected: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SAME_COPY_PROJECT')"/></xsl:call-template>",
						resetProjectWarning: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CHANGE_TARGET_PROJECT_RESET_WARNING')"/></xsl:call-template>",					
						namesuffix: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_EDIT_FIELD')"/></xsl:call-template>",
						errdescription: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ERR_UPLOAD_DESCRIPTION')"/></xsl:call-template>",
						notAllowedDocExtension: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOT_ALLOWED_DOC_EXTENSION')"/></xsl:call-template>",
						FolderChangeDialogTitle: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'UPLOAD_DOC')"/></xsl:call-template>",
						ChangeFolderDialogMessage: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CHANGE_TARGET_FOLDER_MESSAGE')"/></xsl:call-template>",
						ChangeFolderDialogQuestion: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CHANGE_TARGET_FOLDER_QUESTION')"/></xsl:call-template>",
						ChangeFolderDialogNoDocumentsQuestion: 	 "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CHANGE_TARGET_PROJECT_RESET_QUERY')"/></xsl:call-template>",
						documentDefault: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'DEFAULT_DOCUMENT_FOLDER_OPTION')"/></xsl:call-template>"
		};	
			
			<!-- generate language tags array 'i18nDocUConfLangArr' for Doc. Upload Config. feature -->
			<xsl:call-template name="docUploadConfigJSLangTags">
				<xsl:with-param name="langArrName" select="'i18nDocUConfLangArr'"/>
			</xsl:call-template>
			
       
      //Upload Page - global vars 
      gExistingProjectContext = true;
            
      <xsl:if test="/webcenter_page/cur_project_data">
      gHasProjectContext = true;
      </xsl:if>
	  
	  <xsl:if test="/webcenter_page/bom_enabled = '0'">
      gBOMEnabled = 0;  // is default on, so we must only switch it off if needed
      </xsl:if>

      <xsl:if test="/webcenter_page/cur_project_data/has_folder_context">
      gHasProjectFolderContext = true;
      </xsl:if>
      
      <xsl:if test="$isCurProjTemplate = 'true'">
      gIsDestProjIsTemplate = true;
      </xsl:if>
      
      gIsCopyDocument = false;
      <xsl:if test="$isCopyDocument = 'true'">
      	gIsCopyDocument = true ;
      </xsl:if>
      
      var docname = '<xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/document_name)"/>';
      if (gIsCopyDocument)
      {
				gDocumentID  = '<xsl:value-of select="XSLUtils:encodeForJScript($documentID)"/>'; 
				gDocVersionID  = '<xsl:value-of select="XSLUtils:encodeForJScript($docVersionID)"/>';
				gDocumentName  = '<xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/document_name)"/>'; 
				gDocVersionCatID  = '<xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/document_category_id)"/>';
				gDocumentDescription = '<xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/document_description)"/>';
				gSourceCopyDocumentProjectID =  '<xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/project_id)"/>';
      }
      
      gInitialProjectName = '';
      gProjectID = '';
      gDestFolderID = ''; 
      
      if (gHasProjectContext)
      {
      	gProjectID = '<xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/cur_project_data/project/@id)"/>';
      	//also initialize the target Project for DocumentsTable.js
      	gUploadProjectID = gProjectID;
      	gInitialProjectName = '<xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/cur_project_data/project/name)"/>';
      }
      
      if (gHasProjectFolderContext)
      {
      	//if no fodler ID is present
      	gDestFolderID = '<xsl:choose><xsl:when test="/webcenter_page/cur_project_data/cur_folder_id"><xsl:value-of select="XSLUtils:encodeForJScript(/webcenter_page/cur_project_data/cur_folder_id)"/></xsl:when><xsl:otherwise>ROOT</xsl:otherwise></xsl:choose>';
      }
       
      if (gHasProjectContext)
      {
      	gDestProjectFolders = new Array(<xsl:for-each select="/webcenter_page/cur_project_data/folder_list/folder">{folder_id:'<xsl:value-of select="XSLUtils:encodeForJScript(@id)"/>', folder_name:'<xsl:value-of select="XSLUtils:encodeForJScript(name)"/>'}<xsl:if test="position()!=last()">,</xsl:if></xsl:for-each>);
      } 
      
      $(function(){
      	if(window.location.search.indexOf("enableMulti") > -1){
      		SwitchDocUploadType();
      	}	
      });
         
	  
	    <!-- build the doc type settings array -->
	  <xsl:call-template name="scriptincsdoctypesettings"/>
	
    function initializePage()
    {
    
    	require(["component/smartnames/savedsearchcontext/SavedSearchContextInfo"], function(SavedSearchContextInfo) {
    	
    		// hide the rows, that are not shown as a default
	    	HideAllExtraDetails();
	    	
	    	// hide the template doc. attributes row initially
	    	ToggleDocumentAttributesRow(false);
	    	
	    	// hide extra 'Template Documents' row initially
	    	ToggleExtraTemplateDocRow(false);
	    	
	    	// hide the 'Multi Doc. Upload' row
	    	toggleDocUploadDetailsRow(false, 'MultiDocUploadFieldsRow');
	
	<!--   changed to do late show of doc upload details. We only do it when the project and folder is fixed
	     	//show the 'Single Doc Upload' form fields
	     	ShowCurrentDocUploadType();
	-->
	     	// handle graphical file type options
	     	ProcessEnabledDocTypes();
	     	
	     	// handle initialization of 'Destination Project/Fodler' selector controls
	     	DisplayDestinationProjectFolder();
	     	
	     	// show only minimal upload controls
	     	ToggleGeneralDocTypeDetails(false);
	     
	     	// check whether Approval Rule is defined for the current Project/Folder
	     	LoadProjectFolderApprovalRule();
	     			
	     	// fetch the 'Context Project' Template Documents list (in this case it should be the first option in the dropdown select)
	     	// this method also shows the links to change upload mode from "single upload" to "multi upload"!
	     	LoadDocTemplatesForProject();
	      			
			// load the project permissions
			LoadProjectPermissions();
		      	
			// Check if expand/collapse should be hidden
			checkExpand();
				
			var prefix = 'AddNewDocuments';
			//Initialize the SavedSearchContextInfo required for intermediate value injection for Saved Search with Smart Names
			var savedSearchContextInfo = new SavedSearchContextInfo();
			savedSearchContextInfo.setProjectId(gProjectID);
			var textAreaId = 'documentSourcesTextArea';
			var hiddenDivId = 'documentSourcesHiddenDiv';
			var linksId = 'AddDocumentGreenLinkTd';
			var section = 'Upload';
			var hasDocumentTemplates = false;
			var hasBillOfMaterials = false;
			var projectId = gProjectID;
			var docTableDiv = 'documentsTableContainerDiv';
			var docTableHiddenDiv = 'documentsTableHiddenDiv';
			var projectCreationContext = false;
				

			initDocTableX(
					textAreaId, 
					docTableDiv, 
					hiddenDivId, 
					docTableHiddenDiv, 
					linksId, 
					section, 
					prefix, 
					i18nDocUConfLangArr, 
					hasDocumentTemplates, 
					hasBillOfMaterials, 
					savedSearchContextInfo, 
					projectId, 
					projectCreationContext);
				
    	});
    }
	
		function SubmitDocUploadForm()
		{
			// disable submit buttons to prevent double form submit on Chrome (DT93833)
			// (it needs to be here as well because of the postponed validation below)
   			EnableMainButtons(false);
   		
	   		// make sure the validation is not performed before all asynchronous loading/initialization is done!
   			var asyncWorkPromises = [];

			// add documents table in case it exists (multi-document upload via DocTableX)
   			if (window.docTableObj)	{
   				asyncWorkPromises.push(window.docTableObj.whenAllAsyncWorkDone());
   			}
   			// in single upload case check attributes, whether they are all OK before handling the doc. upload
	        var docACatObj = document.getElementById("DocAttributesContainer");
			if (docACatObj &amp;&amp; docACatObj.ACatObj) {
   				asyncWorkPromises.push(docACatObj.ACatObj.whenAllAsyncWorkDone());
			}
			
			requirejs(["utils/EventBasedValidator"], function(EventBasedValidator) {
				Promise.all(asyncWorkPromises).then(function() {
					if (ValidateUploadFormParams()) {
			        	var evInst = EventBasedValidator.getInstance();
		        		var uniqueNamesObj = evInst.createUniqueNamesObj();
		       			evInst.validateNamesGlobally(uniqueNamesObj);
		       			var validationOK = uniqueNamesObj.isOk();
		       			
		       			if(validationOK) {
							//JAMI: disable form buttons just before submitting the form to prevent double form submit on Chrome (DT93833)
			       			EnableMainButtons(false);
			       			
							// show feedback
							$("#UploadFeedback").show();
							
							var asyncWork = [];
							if (window.docTableObj)	{
   								asyncWork.push(window.docTableObj.whenAllAsyncWorkDone());
							}
							if (docACatObj &amp;&amp; docACatObj.ACatObj) {
				   				asyncWork.push(docACatObj.ACatObj.whenAllAsyncWorkDone());
							}
							return Promise.all(asyncWork).then(function() {
								// generate XML representing all involved documents tables only here as only now we are sure all async work is done!
								if (window.docTableObj)	{
						    		window.docTableObj.onSubmit();
								}
								if (docACatObj.ACatObj) {
									docACatObj.ACatObj.convertDocReferencesToXML();
								}
								
								document.actionform.submit();
							});
						} else {
							// the form not submitted (probably due to validation issue detected) - enable all submit buttons again
							EnableMainButtons(true);
						}
					} else {
						// the form not submitted (probably due to validation issue detected) - enable all submit buttons again
						EnableMainButtons(true);
					}
				})
				.catch(function(reason) {
					// the form not submitted (probably due to validation issue detected) - enable all submit buttons again
					EnableMainButtons(true);
					if (console &amp;&amp; console.error) {
						console.error("Exception in asynchronous task: " + reason);
					} else {
						alert("Exception in asynchronous task: " + reason);
					}
				});
			});
		}
	
		function MoveDocument(docVersionID, documentID)
		{
			var newLocation = 'doprojectdocsactions.jsp?actionVal=DoMoveDoc&amp;actionDocVerID=' + docVersionID + '&amp;documentID=' + documentID +		 
					'&amp;selectedProjectId=' + document.actionform.targetProjectID.value +
<!-- 				this will dump the id of target folder, or empty string in the case of root (implicit) folder -->
					((document.actionform.targetFolderID.value.toLowerCase().indexOf("root") &gt; -1) ? "" : ('&amp;selectedFolderID=' + document.actionform.targetFolderID.value)) +
					'&amp;selectedDocs=' + docVersionID + ','  + documentID +
					'&amp;projectID=' + &quot;<xsl:value-of select="/webcenter_page/project_id" />&quot;+ '&amp;menu_file=addnewdocumentexit';
			window.location = newLocation;				
		}
        
		function SetInitialFocus()
		{
		}
   
   	<!-- PJPR:  DT108582 When form is submitted, the upload and cancel button are disabled. When pressing using the back mechanism in FireFox the buttons will be disabled and not word
   	The function enables the buttons again on page load -->
		$(function(){
	  	// Add change event for BOM count
	   	addChangeEvent($("#countBOM"));
	   	
	   	if ($('#UploadButton')){
	   		$('#UploadButton').prop('disabled', false);
	   	}
	   	
	   	if ($('#CancelButton')){
	   		$('#CancelButton').prop('disabled', false);
	   	}
	   	});
    
    </script>
  </xsl:template>    
</xsl:stylesheet>
