<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY copy "&#169;">
  <!ENTITY nbsp "&#160;">
  <!ENTITY lk "/webcenter_page/user_lang_key">
]>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:java="http://xml.apache.org/xslt/java" xmlns:XSLUtils="com.esko.webcenter.jsp.XSLUtils" xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr" exclude-result-prefixes="XSLUtils java Lang">
	<xsl:import href="template.xsl"/>
	<xsl:import href="templatedate.xsl"/>
	<xsl:import href="managerolestemplates.xsl"/>
	 <xsl:import href="attributetemplates.xsl"/>
	 <xsl:import href="projectstatusestemplates.xsl"/>

	<xsl:variable name="useTableBodyContainer" select="false()" />
	
	<xsl:template name="bodyextensions">  
	</xsl:template>
  
	<!-- 
  
		Template that controls the generation of the body header
            
	-->
	<xsl:template name="bodyheader">
		<xsl:variable name="ProjectTypeName">
			<xsl:choose>
				<xsl:when test="/webcenter_page/project_creation/project_type_name">
					<xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_CREATE_WITCHARPATH')"
						/>&nbsp;<xsl:value-of select="/webcenter_page/project_creation/project_type_name"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_CREATE')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:call-template name="DisplayHeaderNoAction">
			<xsl:with-param name="Name">
					<xsl:value-of select="$ProjectTypeName"/>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:template>
  
	<!-- 
            
		Template that controls the generation of the body content
            
	-->
	<xsl:template name="bodycontent">
		<form name="actionform" id="actionformId" method="post" enctype="MULTIPART/FORM-DATA" action="doprojectactions.jsp" class="wcr-form">
			<input type="hidden" name="actionVal" id="actionValId" value="CreateNewProject"/>
			<input type="hidden" name="menu_file" value="{menu_file}"/>
			<input type="hidden" name="projectID" id="projectIDId" value=""/>
			<input type="hidden" name="creationType" id="creationTypeId" value=""/>
			<input type="hidden" name="createChild" id="createChildId" value="{/webcenter_page/createchild}"/>
			<input type="hidden" name="sourceProjectID" id="sourceProjectIDId" value="{/webcenter_page/source_project_id}"/>
			<input type="hidden" name="userIsPM" id="userIsPMId" value="{count(/webcenter_page/is_manager)}"/>
			
			<!-- get the user's details --> 
			<input type="hidden" id="userID" value="{loginuserid}"/>
			<input type="hidden" id="userLastName" value="{loginuserlastname}"/>
			<input type="hidden" id="userFirstName" value="{loginuserfirstname}"/>
			<input type="hidden" id="userName" value="{loginuser}"/>
				
			<!-- Browser madness: when pressing enter, the browser triggers a click on the first button in the form -->
			<button onclick="return false;" class="displayNone" />
			
			<div id="mainTableId">
				<div class="form-section" id="projectSelectionRowId">
					<xsl:if test="count(project_creation/template) = 1">
				 		<xsl:attribute name="class">displayNone</xsl:attribute>
				 	</xsl:if>
					<xsl:call-template name="ProjectSelection"/>
				</div>
				<div class="form-group" id="messageRowId">
					<xsl:if test="count(project_creation/template) != 1">
				 		<xsl:attribute name="class">displayNone</xsl:attribute>
				 	</xsl:if>
					<label class="offset-label" />
					<div class="form-entry">
						<p><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_FORM_LOADING')"/></p>
					</div>
				</div>
				<div class="form-section" id="mainProjectDetailsRowId" style="display:none;">
					<xsl:call-template name="MainProjectDetails"/>
				</div>
				<div class="form-section" id="mainBomDetailsRowId" style="display:none;">
					<xsl:call-template name="MainBOMDetails"/>
				</div>
				<div class="form-section" id="mainDocumentDetailsRowId" style="display:none;">
					<xsl:call-template name="MainDocumentDetails"/>
				</div>
				<div class="form-section" id="mainMembersRowId" style="display:none;">
					<xsl:call-template name="MainMembers"/>
				</div>
				<div class="form-section" id="mainAttributesRowId" style="display:none;">
					<xsl:call-template name="MainAttributes"/>
				</div>
				<div class="form-section" id="buttonRow" style="display:none;">
					<xsl:call-template name="MainButtons"/>
				</div>
			</div>
			<xsl:call-template name="CopyProjectModalBox">
				<xsl:with-param name="wcTaskLicense" select="/webcenter_page/has_task_management_license"/>	
			</xsl:call-template>														
			<xsl:call-template name="ThumbnailOptionsModalBox"/>								
			<xsl:call-template name="sessionExpiredForm"/>								
		</form>
		
		<xsl:call-template name="SelectDocumentTemplateDialog"/>
		
	</xsl:template>
	
	<!-- 
		Project selection template
	-->
	<xsl:template name="ProjectSelection">
		<div class="form-group" id="projectTypeSelectRowId">
			<xsl:if test="count(project_creation/template) > 0">
				<xsl:attribute name="style">display: none;</xsl:attribute>
			</xsl:if>
			<label for="projectTypeSelectId"><xsl:value-of select="Lang:getStr(&lk;,'CREATE')"/></label>
			<div class="form-entry">
				<select id="projectTypeSelectId" onchange="loadProjectCreationInfo(this);" class="form-control">
					<option value=""><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_SELECT')"/></option>
					<option value="TemplateProject"><xsl:value-of select="Lang:getStr(&lk;,'STEP_USE_TEMPLATE')"/>
						<xsl:if test="count(project_creation/template) > 0 and (project_creation/template/istemplate = '1')">
							<xsl:attribute name="selected">selected</xsl:attribute>
						</xsl:if>
					</option>
					<option value="BlankProject"><xsl:value-of select="Lang:getStr(&lk;,'STEP_START_BLANK_PROJECT')"/></option>
					
					<!-- When the user is NOT a project creator, you can show the copy from existing project -->
					<xsl:if test="count(/webcenter_page/is_project_creator) = 0"> 
						<option value="CopyProject"><xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECT')"/>
							<xsl:if test="count(project_creation/template) > 0 and (project_creation/template/istemplate = '0')">
								<xsl:attribute name="selected">selected</xsl:attribute>
							</xsl:if>
						</option>
					</xsl:if>
				</select>
			</div>
		</div>
		
		<div class="form-group" id="selectTemplateRowId">
			<xsl:if test="count(project_creation/template) = 0">
				<xsl:attribute name="style">display: none</xsl:attribute>
			</xsl:if>
			<label for="selectTemplateId">
				<xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_TEMPLATE')"/>
			</label>
			<div class="form-entry">
				<xsl:if test="count(project_creation/template) = 1">
					<input id="selectTemplateId" type="hidden" value="{project_creation/template/id}"/>
					<div class="input-group">
						<input type="text" disabled="disabled" class="form-control">
							<xsl:attribute name="value"><xsl:value-of select="project_creation/template/name"/></xsl:attribute>
						</input>
						<span class="input-group-btn">
							<button class="btn">
								<xsl:attribute name="type">button</xsl:attribute>
								<xsl:attribute name="onclick">ShowSelectedTemplateDetails(0, event);</xsl:attribute>
								<xsl:value-of select="Lang:getStr(&lk;,'SHOW_DETAILS')"/>
							</button>
						</span>
					</div>
				</xsl:if>
				<xsl:if test="count(project_creation/template) != 1">
					<div class="input-group">
						<select id="selectTemplateId" class="form-control">										
							<xsl:if test="count(project_creation/template) > 1">
								<option value="" selected="selected"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_SELECT')"/></option>
							</xsl:if>
							<xsl:for-each select="project_creation/template">
								<option value="{id}"><xsl:value-of select="name"/></option>
							</xsl:for-each>
						</select>
						<xsl:if test="count(project_creation/template) > 1">
							<script type="text/javascript">
								$(function(){
									$('#selectTemplateId').on("change", selectCopyOptions.bind($('#selectTemplateId')[0], $('#selectTemplateId')[0], false));
								});
							</script>
						</xsl:if>	
						<span class="input-group-btn">
							<button class="btn">
								<xsl:attribute name="type">button</xsl:attribute>
								<xsl:attribute name="onclick">ShowSelectedTemplateDetails(0, event);</xsl:attribute>
								<xsl:value-of select="Lang:getStr(&lk;,'SHOW_DETAILS')"/>
							</button>
						</span>
					</div>
				</xsl:if>
			</div>
			<div class="form-entry">
				<img id="sbox_loader_templ" src="images/ajax_loader.gif" alt="Loading" style="display: none" />
			</div>
		</div>

		<div class="form-group" id="selectProjectRowId" style="display:none;">
			<label for="selectProjectId"><xsl:value-of select="Lang:getStr(&lk;,'PROJECT')"/></label>
			<div class="form-entry">
				<div class="input-group">
					<select id="selectProjectId" class="form-control">
						<xsl:if test="count(project_creation/template) = 1 and /webcenter_page/project_creation/template/istemplate = '1'">
							<option value="{id}"><xsl:value-of select="name"/></option>
						</xsl:if>
					</select>
					<span class="input-group-btn">
						<button class="btn">
							<xsl:attribute name="type">button</xsl:attribute>
							<xsl:attribute name="onclick">ShowSelectedTemplateDetails(1, event);</xsl:attribute>
							<xsl:value-of select="Lang:getStr(&lk;,'SHOW_DETAILS')"/>
						</button>
					</span>
				</div>
			</div>
			<div class="form-entry">
				<img id="sbox_loader_proj" src="images/ajax_loader.gif" alt="Loading" style="display: none" />
			</div>
		</div>
	</xsl:template>
	
	<!--
		This Displays the main project Details for a project
	-->
	<xsl:template name="MainProjectDetails">
	
		<div class="panel panel-default">
			<div class="panel-heading">
				<h4 class="panel-title">
					<button class="btn btn-xs btn-icon-only"  type="button" onclick="slide('projectDetailsBlockId', document.getElementById('projectDetailsMinusId'), this, false);">
						<i class="icon icon-normal icon-WCR_Down" id="projectDetailsMinusId" title="Hide Section"></i>
					</button>
					<span id="PROJ_CREATION_PROJ_DETAILS"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_PROJ_DETAILS')"/></span>
				</h4>
			</div>
			<div class="panel-body" id="projectDetailsBlockId">
				<div class="form-group" id="projectNameRowId">
					<label for="projectNameId" class="form-required" id="PROJ_CREATION_NAME"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_NAME')"/></label>
					<div class="form-entry">
						<input name="projectName" class="form-control" id="projectNameId" size="50" maxlength="{(/webcenter_page/field_sizes/field_size[@key='project.name']/@value)}">
				</input>
					</div>
				</div>
				<div class="form-group" id="projectNameEditFieldRowId">
					<label for="projectNameEditFieldId" id="PROJ_EDITFIELD_NAME"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_EDIT_FIELD')"/></label>
					<div class="form-entry">
						<input name="projectNameEditField" class="form-control" id="projectNameEditFieldId" size="100" maxlength="{(/webcenter_page/field_sizes/field_size[@key='project.name']/@value)}">
				</input>
					</div>
				</div>
				<div class="form-group" id="projectAutoNameMsg">
					<div class="alert alert-info" role="alert" id="PROJ_AUTONAME_MSG">
						<xsl:value-of select="Lang:getStr(&lk;,'PROJ_AUTONAME_MSG')"/>
					</div>
				</div>
				<div class="form-group" id="requestorRowId">
					<label for="selectRequestorId" id="PROJ_CREATION_REQUESTOR"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_REQUESTOR')"/></label>
					<div class="form-entry">
						<select name="selectRequestor" class="form-control" id="selectRequestorId">
					<option value="me"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_TASK_ASSIGNTOMYSELF')"/></option>											
				</select>
					</div>
				</div>
				
				<!-- Project Manager row  -->
				<input name="projectManagerRowVisible" type="hidden" value="1"/>
					
				<div class="form-section" id="projectManagerRowId">
					<div class="form-group " id="projectManagerRowId2">
						<label id="PROJ_CREATION_SELECT_MANAGER" for="projectManagerSelectId"  class="form-required"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_PROJMANAGER')"/></label>
						<div class="form-entry">
							<div id="projectManagerSelectId" class="list-unstyled  main-content"></div>
						</div>
					</div>
				</div>
				
				<!--  Project status  -->
				<div class="form-section" id="projectStatusRowId">	
					<div class="form-group">
						<label id="PROJ_CREATION_STATUS" for="selectProjectStatusId"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_STATUS')"/></label>
						<div class="form-entry" id="selectProjectStatusTdId">
							<select name="selectProjectStatus" class="form-control" id="selectProjectStatusId">
								<xsl:call-template name="CreateSelectWithSystemProjectStatuses">
								</xsl:call-template>											
							</select>
						</div>
					</div>
				</div>
				
				<!-- Customer row -->
				<div class="form-section" id="projectCustomerRowId">
					<div class="form-group">
						<label id="PROJ_CREATION_CUSTOMER" for="selectProjectCustomerId"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_CUSTOMER')"/></label>
						<div class="form-entry">
							<select name="selectProjectCustomer" class="form-control" id="selectProjectCustomerId" onchange="selectCustomer()">
							</select>
						</div>
					</div>
					<div class="form-group">
						<label id="PROJ_CREATION_LOCATION" for="selectProjectLocationId"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_LOCATION')"/></label>
						<div class="form-entry">
							<select name="selectProjectLocation" class="form-control" id="selectProjectLocationId" disabled="disabled">
								<option value="" selected="selected"><xsl:value-of select="Lang:getStr(&lk;, 'EMPTY_LOCATION')"/></option>
							</select>
						</div>
					</div>
				</div>
				<div class="form-group" id="projectDecriptionRowId">
					<label id="PROJ_CREATION_DESCRIPTION" for="projectDescriptionId"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_DESCRIPTION')"/></label>
					<div class="form-entry">
						<textarea name="projectDescription" class="form-control" id="projectDescriptionId" rows="3" cols="25" maxlength="{(/webcenter_page/field_sizes/field_size[@key='project.description']/@value)}" />
					</div>
				</div>
				<div class="form-group" id="projectDueDateRowId">
					<label id="PROJ_CREATION_PROJECT_DUE_DATE" for="longFormat_projectDueDate"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_PROJECT_DUE_DATE')"/></label>
					<div class="form-entry">
						<xsl:call-template name="DisplayDateWithCalendar">
					<xsl:with-param name="date" select="/webcenter_page/due_date"/>
					<xsl:with-param name="ShowCalendarFieldName" select="'projectDueDate'"/>	
					<xsl:with-param name="ShowCalendarFormName" select="'actionform'"/>	
					<xsl:with-param name="PeriodOfDayFieldName" select="'projectDueDatePeriodOfDay'" />
					<xsl:with-param name="longIntDate" select="/webcenter_page/default_due_date_time"/>						
					<xsl:with-param name="onChange" select="'DueDateChanged'"/>	
				</xsl:call-template>
					</div>
				</div>
				<div class="form-section"  id="projectPlanningRowId">
					<div class="form-group">
						<label for="projectPlanningId"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_PLANNING')"/></label>
						<div class="form-entry">
							<select name="projectPlanning" class="form-control" id="projectPlanningId" onchange="projectPlanningChanged();"> 
						<option value="forward" ><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_FORWARDS')"/></option>
						<option value="backward" selected="selected"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_BACKWARDS')"/></option>
					</select>
						</div>
					</div>
					<div class="form-group">
						<label id="planningLastTask" for="longFormat_projectTaskDate" class="form-required"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_LAST_TASK_DATE')"/></label>
						<div class="form-entry">
							<xsl:call-template name="DisplayDateWithCalendar">
						<xsl:with-param name="date" select="/webcenter_page/due_date"/>
						<xsl:with-param name="ShowCalendarFieldName" select="'projectTaskDate'"/>	
						<xsl:with-param name="ShowCalendarFormName" select="'actionform'"/>	
						<xsl:with-param name="PeriodOfDayFieldName" select="'projectTaskDatePeriodOfDay'" />
						<xsl:with-param name="longIntDate" select="/webcenter_page/project/task_date"/>						
					</xsl:call-template>
						</div>
					</div>	  						
				</div>
				<div class="form-group" id="projectThumbnailRowId">
					<label><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_THUMBNAIL')"/></label>
					<div class="form-entry">
						<div class="row">
							<div class="naturalWidth">
								<img name="showThumbnail" id = "showThumbnailId" border="1" width="100" height="100" title="thumbnail"/>
							</div>
							<div class="naturalWidth">
								<input class="btn btn-default" type="button" value="{Lang:getStr(&lk;,'CHANGE')}" onclick="openThumbnailDialog()"/>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>	
	</xsl:template>
	
	<!--
		Template to show documents
	-->
	<xsl:template name="MainDocumentDetails">
			
		<!-- in case there are source doucments selected, put the IDs at hidden vlaues -->
		<xsl:for-each select="/webcenter_page/source_documents/doc_version">
			<!--   set the document version to the selected document  -->
			<input type="hidden" class="source_doc_id">
				<xsl:attribute name="name">source_document<xsl:value-of select="position()"/></xsl:attribute>
				<xsl:attribute name="id">source_document<xsl:value-of select="position()"/></xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="@id"/></xsl:attribute>				
			</input>
			
			<xsl:variable name="documentName" select="document/name"/>	
			<xsl:variable name="documentDesc" select="document/description"/>	
			<xsl:variable name="documentThumbnail" select="thumbnail_url"/>	
			
			
			<input type="hidden" id="source_document_{@id}" value="{$documentName}" />
			<input type="hidden" id="source_document_{@id}Desc" value="{$documentDesc}" />
			<input type="hidden" id="source_document_{@id}Thumb" value="{$documentThumbnail}" />
		</xsl:for-each>	
		
		<!-- Hidden input field to interchange the XML configuration with server -->
		<input type="hidden" id="DocRenderConfigXML" name="DocRenderConfigXML" value="{/webcenter_page/docrenderingsetup}"/>
		<div class="panel panel-default">
					<div class="panel-heading">
						<h4 class="panel-title">
							<button class="btn btn-xs btn-icon-only" type="button" onclick="slide('projectDocumentsBlockId', document.getElementById('projectDocumentsMinusId'), this, false);">
						<i class="icon icon-normal icon-WCR_Down" id="projectDocumentsMinusId" title="Hide Section"></i>
					</button>
					<span id="PROJ_CREATION_DOCS"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_DOCS')"/></span>
						</h4>
					</div>
					<div class="panel-body no-padding-with-overflow" id="projectDocumentsBlockId" >				  		
		  		<table class="wcr-table no-margin no-border table-full-width">
		  			<tbody>
						<tr>
							<td style="padding: 0;">
								<div>
									<xsl:call-template name="NewDocumentsSelector"/>
								</div>
							</td>
						</tr>
					</tbody>								
				</table>														
			</div>
		</div>
			
	
		
	</xsl:template>
	
	<!--
		Template to show BOM
	-->
	<xsl:template name="MainBOMDetails">

		<div class="panel panel-default">
					<div class="panel-heading">
						<h4 class="panel-title">
							<button class="btn btn-xs btn-icon-only" type="button" onclick="slide('projectBOMBodyBlock', document.getElementById('projectBOMMinusId'), this, false);">
								<i class="icon icon-normal icon-WCR_Down" id="projectBOMMinusId" title="Hide Section"></i>
							</button>
							<span id="PROJDETAILSBOM_TAG"><xsl:value-of select="Lang:getStr(&lk;,'PROJDETAILSBOM_TAG')"/></span>
						</h4>
					</div>
					<div class="panel-body no-padding-with-overflow" id="projectBOMBodyBlock">
						<div id="hourglass" style = "display:none;">
							<p class="text-center">
						<img src="images/ajax_loader.gif"></img>
					</p>
				</div>
				<div class="wcr-table no-margin no-border" data-init="component/table/Table">							
					<div id="projectBOMBlockId" class="wcr-table-section">
						
						<!-- filled in by JS -->
					</div>
				</div>
			</div>
		</div>
		
	</xsl:template>
	
	
	
	<!--
	
		//JANH TODO!!! delete this template if not used in addnewdocument.xsl!
	
		Template to show table/formular to add new documents and specify their parameters
	-->
	<xsl:template name="NewDocumentsSelector">
		<table width="100%">
			<tr>
				<td colspan="4">
					<div id="documentsTableContainerDiv" class="no-border"/>
					<div id="documentsTableHiddenDiv" class="displayNone"/>
				</td>
			</tr>
			<tr style="display:none;" class="alwaysHidden">
				<td>
					<textarea id="documentSourcesTextArea" cols="200" rows="4">
						<!-- currently there is no 'doccreation_setup_xml' in the generated XML, it's loaded dynamically via AJAX!
						<xsl:value-of select="/webcenter_page/doccreation_setup_xml"/>
						-->
					</textarea>
					<div id="documentSourcesHiddenDiv"/>
				</td>
			</tr>
		</table>
	</xsl:template>
	
	
	<!--
		Template to show groups
	-->
	<xsl:template name="MainMembers">

	<div class="panel panel-default">
		<div class="panel-heading">
			<h4 class="panel-title">
				<button class="btn btn-xs btn-icon-only"  type="button" onclick="slide('projectMembersBlockId', document.getElementById('projectMembersMinusId'), this, false);">
			<i class="icon icon-normal icon-WCR_Down" id="projectMembersMinusId" title="Hide Section"></i>
		</button>
		<span id="PROJ_CREATION_MEMBERS"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBERS')"/></span>
			</h4>
		</div>
		<div class="panel-body no-padding-with-overflow" id="projectMembersBlockId">
			<div class="form-group no-vertical-margins" id="replaceGroupsRowId">
				<div class="wcr-table" data-init="component/table/Table" id="RoleManagementHolderTable">
					<div class="wcr-table-section no-overflow" id="RoleManagementHolder">
				
					</div>
				</div>
			</div>  
			<div class="form-group no-vertical-margins add-spacing-top" id="inviteMembersRowId">
				<label id="PROJ_CREATION_INVITE_MEMBERS" for="inviteMembersSelectId"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_INVITE_MEMBERS')"/></label>
				<div class="form-entry">
					<div id="inviteMembersSelectId"></div>
					<ul id="InviteMembersSelectDivId" class="list-unstyled">  								
					</ul>
				</div>
			</div> 					
		</div>
	</div>

	</xsl:template>
	
	<!--
		Template to show attributes
	-->
	<xsl:template name="MainAttributes">

		<div class="panel panel-default">
			<div class="panel-heading">
				<h4 class="panel-title">
					<button class="btn btn-xs btn-icon-only" type="button" onclick="slide('projectAttributesBlockId', document.getElementById('projectAttributesMinusId'), this, false);">
				<i class="icon icon-normal icon-WCR_Down" id="projectAttributesMinusId" title="Hide Section"></i>
			</button>
			<span id="PROJ_CREATION_ATTRIBUTES"><xsl:value-of select="Lang:getStr(&lk;,'PROJ_CREATION_ATTRIBUTES')"/></span>
				</h4>  						
			</div>
			<div class="panel-body no-padding-with-overflow">
				<table class="wcr-table table-full-width no-margin no-border">
					<tr>
						<td>
							<div id="projectAttributesBlockId">
							
							</div>
						</td>
					</tr>
				</table>
			</div>
		</div>
	</xsl:template>
	
	<!--
		Main Buttons Section
	-->
	<xsl:template name="MainButtons">
	
		<div class="form-group">
			<div class="form-entry">
				<input id="CreateProjectButton" class="btn btn-primary" type="button" onclick="validatePasswordAndCreate();" value="{Lang:getStr(&lk;,'PROJ_CREATION_CREATE')}">
				</input>
			</div>
		</div>
	</xsl:template>
	
	<!--
		Template Used for Thumbnail Selection
	-->
	<xsl:template name="ThumbnailOptionsModalBox">
		<xsl:param name="ThumbnailSize" select="'100'"></xsl:param>
		<xsl:param name="ShowDefaultThumbnail" select="true()"></xsl:param>
  	
		<xsl:variable name="defaultThumbnailSrc" select="default_thumbnail_url"/>	
	
		<div id="thumbnailOptionsDialog" name="thumbnail-options" title="{Lang:getStr(&lk;,'PROJ_CREATION_THUMBNAIL')}" style="display:none;">
			<input type="hidden" name="templateThumbnail" id="templateThumbnailId" value=""/>
			<input type="hidden" name="systemThumbnail"   id="systemThumbnail" value="0"/>
			<input type="hidden" name="defaultThumbnail" id="defaultThumbnailId" value="{$defaultThumbnailSrc}"/>
			<input type="hidden" name="emptyImage" id="emptyImageId" value="images/clearpixel.gif"/>
			<input type="hidden" name="selectedImage" id="selectedImageId" value=""/>
			
			<div class="wcr-form form-no-labels add-padding-top add-padding-right">
				<div class="form-section">
					<!-- Set new thumbnail -->
					<div class="form-group" id="ThumbURLRow" name="ThumbURLRow">
						<label class="offset-label"></label>
						<div class="form-entry" id="ThumbRowOther" name="ThumbRowOther">
							<div class="radio">
								<label>
									<input type="radio"  name="thumbUrlOption" id="thumbUrlOptionId1" tabindex="3" value=""  onclick="javascript:SelectRadioThumbnail(this, 'ThumbRowOther'); " >
									</input>
									<xsl:value-of select="Lang:getStr(&lk;,'SPECIFYNEWTHUMB')"/>
								</label>
							</div>
						</div>
						
						<div class="form-entry">
							<!-- Enable it only if Specify new thumbnail option is set  -->
							<!-- if click on Browse then change main thumbnail  -->
							<div id="ThumbRow" class="browse-file">
								<div class="file-input-selector" data-init="component/styledfileinput/StyledFileInput">
									<input type="file" name="Thumbnail" tabindex="4" id="ThumbnailId" disabled="disabled" onchange="javascript:SetCurThumbnailSrc(this.value);readURL(this, 'showThumbnailId');" value=""/>
									<a class="btn btn-primary"><xsl:value-of select="Lang:getStrBundle(&lk;, 'StyledFileInput', 'OPEN_FILE_BROWSER')"/></a>
								</div>
							</div>
						</div>
					</div>
					
								
		<!-- 				Set new thumbnail -->
					
					<!-- Default thumbnail -->
					<div class="form-group" id="ThumbURLRow0" name="ThumbURLRow0">
						<label class="offset-label"></label>
						<div class="form-entry" id="ThumbRowDefaultId" name="ThumbRowDefault">
							<div class="radio">
								<label>
									<input type="radio" name="thumbUrlOption" id="thumbUrlOptionId2" tabindex="5" value="0" align="middle" onclick="javascript:SelectRadioThumbnail(this, 'ThumbRowDefault')"/>
									<img border="0" src="{default_thumbnail_url}"  width="{$ThumbnailSize}" height="{$ThumbnailSize}" />
									&nbsp;<span><xsl:value-of select="Lang:getStr(&lk;,'USEDEFTHUMB')"/></span>
								</label>
							</div>
						</div>
					</div>
		
					<!-- Template thumbnail -->
					<div class="form-group" id="ThumbURLRow1" name="ThumbURLRow1">
						<label class="offset-label"></label>
						<div class="form-entry" id="ThumbRowTemplateId" name="ThumbRowTemplate">
							<div class="radio">
								<label>
									<input type="radio" name="thumbUrlOption" id="thumbUrlOptionId3" value="1" tabindex="6" align="middle" onclick="javascript:SelectRadioThumbnail(this, 'ThumbRowTemplate')" />
									<img id="templateImageId" border="0" src="" width="50" height="50" />
									&nbsp;<span>(<xsl:value-of select="Lang:getStr(&lk;,'USETEMPLATETHUMB')"/>)</span>
								</label>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</xsl:template>  
	
	
	<!--
		Modal Box for Copy Project Selections
	-->
	<xsl:template name="CopyProjectModalBox">
		<xsl:param name="wcTaskLicense"/>
		<div id="projectCopyDialog" title="{Lang:getStr(&lk;,'COPYPROJECT')}" style="display:none;">
			<!-- 
				javascript that controls this table is located in pages/projectcreation/CopyProjectOptionsTable as you can see on the line below
				Note that all interactions with this table should go through that object. (!!!)
				You can access the object by the function withCopyTable (see scriptings)
				OR if you are 100% sure the component was already loaded: $("#projectCopyOptionsTable").get(0).CopyProjectOptionsTable
				
				! Do not access this table manually... (always use the object)
			 -->
			
			<table id="projectCopyOptionsTable" name="copyproject-options" data-init="pages/projectcreation/CopyProjectOptionsTable">
				<tbody>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionPM" value="on"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTPM')"/>
								</label>
							</div>
						</td>
					</tr>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionMembers" value="on"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTMEMBERS')"/>
								</label>
							</div>
						</td>
					</tr>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionApproval" value="on" data-copyoptiondependson="copyOptionMembers"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTAPPROVERS')"/>
								</label>
							</div>
						</td>
					</tr>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionFolders" value="on"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTFOLDER')"/>
								</label>
							</div>
						</td>
					</tr>
					<tr>
						<td class="child-options">
							<div class="checkbox">
								<label>
									<input type="checkbox" data-valuefortemplate="off" name="copyOptionDocs" value="on" data-copyoptiondependson="copyOptionFolders"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTFOLDERWITHDOCS')"/>
								</label>
							</div>
						</td>
					</tr>
					<xsl:if test="bom_enabled = '1'">
						<tr>
							<td class="child-options">
								<div class="checkbox">
									<label>
										<input type="checkbox" data-valuefortemplate="off" name="copyOptionBOM" value="on" data-copyoptiondependson="copyOptionFolders"/>
										<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTDOCSWITHBOM')"/>
									</label>
								</div>
							</td>
						</tr>
					</xsl:if>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionAttr" value="on"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTATTR')"/>
								</label>
							</div>
						</td>
					</tr>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionChars" value="on"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTCHAR')"/>
								</label>
							</div>
						</td>
					</tr>
					<xsl:if test="$wcTaskLicense">
						<!-- Rows to select if we want to copy tasks and from the project or any template... -->
						<!-- The javascript is attached to the table as a "component" (see wcr-components: init) -->
						<tr class="taskCopyRow rowA">
							<td>
								<div class="checkbox">
									<label>
										<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionTasks" value="on" data-copyoptiondependson="copyOptionMembers"/>
										<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTTASKS')"/>&#160;
									</label>
									
									<select name="copyOptionTasksSource" data-valuefortemplate="project">
										<option value="project"><xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTTASKSFROMSOURCEPROJECT')"/></option>
										<option value="template"><xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTTASKSFROMATEMPLATE')"/></option>
									</select>
								</div>
							</td>
						</tr>
						<!-- Row to select a template (with an SDrop), managed by the same javascript as the row above -->
						<tr class="taskCopyRow rowB" style="display:none;">
							<td>
								<!-- will show the SDrop, controlled by the script that controls the table -->
								<select data-sdropselectorwidth="202" name="copyOptionTasksTemplate"></select>
								<img src="images/loaderTransparent.gif" alt="Loading..." />
							</td>
						</tr>
						<tr class="taskCopyRow rowError">
							<td>
								<p class="help-block"><xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTTASKSFROMATEMPLATE_NOTEMPLATESELECTED')"/></p>
							</td>
						</tr>
					</xsl:if>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionSecurity" value="on" data-copyoptiondependson="copyOptionMembers"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTSECURITY')"/>
								</label>
							</div>
						</td>
					</tr>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" checked="" data-valuefortemplate="on" name="copyOptionEvents" value="on"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYPROJECTEVENTS')"/>
								</label>
							</div>
						</td>
					</tr>
					<tr>
						<td>
							<div class="checkbox">
								<label>
									<input type="checkbox" data-valuefortemplate="on" name="copyOptionDiscussions" value="on"/>
									<xsl:value-of select="Lang:getStr(&lk;,'COPYDISCUSSIONS')"/>
								</label>
							</div>
						</td>
					</tr>
				</tbody>
			</table>
			
		</div>
	</xsl:template>
	
	<!--
		Template that controls the inclusion of javascript functionality
	-->
	<xsl:template name="scriptincs">
<!--   JIDO (quirks-strict hack): in header.css there is specified width style for mainContentContainer class as 100%(targeted for IE7 and lower), but in IE7 in strict mode it causes scroll bar appearance due to some different margin(or something else?) computations -->
<!--   Rather then changing it in header.css(that style is used in framework.xsl, so like for the many/most pages in WCR), the change is made directly in this place(and target it to IE7 and lower), so it will influence only task type pages -->
<!--   I vote for strict mode, as many times before :) -->
	    <style>
			.mainContentContainer {
			    *width: 98%;
			}
		</style> 

		<script src="javascript/search.js" type="text/javascript"/>
		<script src="javascript/popup.js" type="text/javascript"/>
		<script src="javascript/extpopup.js" type="text/javascript"/>
		<script src="javascript/detailswin.js" type="text/javascript"/>

		<script src="javascript/AddDocument.js" type="text/javascript"/>
		<script src="javascript/DocumentsTable.js" type="text/javascript"/>
		<script src="javascript/ProjectCreation.js" type="text/javascript"/>
		<script src="javascript/sdrop_common.js" type="text/javascript"/>
		<script src="javascript/webcenter_ajax.js" type="text/javascript"/>
		<script src="javascript/webcenter_xml.js" type="text/javascript"/>
		<script src="javascript/webcenter_html.js" type="text/javascript"/>
		<script src="javascript/hover.js" type="text/javascript"/>
		<script src="javascript/validate.js" type="text/javascript"></script>
		
		<!-- Language keys for: BOM JS + RoleManagement Widget -->
		<xsl:call-template name="i18n">
			<xsl:with-param name="keys">
				|BOM_LOADING_FAILED|
				|PROJ_CREATION_SOURCE|
				|PROJ_CREATION_NAME|
				|DESCRIPTION|
				|INVALID_COUNT|
				|INVALID_COUNT_EMPTY|
				|MANAGEROLESCOMMENT_PT1|
    			|MANAGEROLESCOMMENT_PT2|
    			|ROLE|
   		 		|GROUP|
    			|USER|
    			|ASSIGNEE|
    			|NEW_GROUP_OPTION|
    			|ACTIONS|
    			|CHANGE|
    			|CANCEL|
    			|REQUIRED_FIELD_CHAR|
    			|ADD|
    			|REMOVE|
			</xsl:with-param>
		</xsl:call-template>
		
		<script type="text/javascript">
			<xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>&#xA;
			
			var gMenu_file = '<xsl:value-of select="/webcenter_page/menu_file" />';
			
			<xsl:choose> 
				<xsl:when test="count(/webcenter_page/has_task_management_license) &gt; 0">
					var gHas_task_management_license = true;
				</xsl:when>
				<xsl:otherwise>
					var gHas_task_management_license = false;
				</xsl:otherwise>
			</xsl:choose>
			
			<xsl:text disable-output-escaping="yes">//--&gt;</xsl:text>&#xA;
		</script>
		
		<script src="javascript/projdetailsbom.js" type="text/javascript" />
		<script type="text/javascript">
			<xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>&#xA;
				// Attribute Categories
				var aCatOptionsArrBOM = new Array();
				var aCatArrBOM = new Array();
				
				gBOMEnabled = <xsl:value-of select="/webcenter_page/bom_enabled"/>;
				gNrOfColumns = 5;
			<xsl:text disable-output-escaping="yes">//--&gt;</xsl:text>&#xA;
		</script>
				
		<script type="text/javascript">
			<xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>&#xA;
				var gThumbnailSelectDlg = null;

				<!-- generate language tags array 'i18nDocUConfLangArr' for Doc. Upload Config. feature -->
				<xsl:call-template name="docUploadConfigJSLangTags">
					<xsl:with-param name="langArrName" select="'i18nDocUConfLangArr'"/>
				</xsl:call-template>
				
				//load EventBasedValidator
				require(["utils/EventBasedValidator"],function(EventBasedValidator){
					EventBasedValidator.getInstance();
				});
				
				var isAccessedFromProjectDetails = false;
				
			
				require(["jquery", "jqueryUI"], function($){
					// On Page Load				
					$(function() {
						var gGoBackToPreviousPageOnCancelCopyOptionsDialog = false;					
					
						// Initialize Project Copy Dialog
						$("#projectCopyDialog").dialog({
						
							// do not close without validation (hide close button when opening the dialog + do not allow escape to close the dialog)
							closeOnEscape: false,
							closeText: "",
							width: '350',
							open:function(ev, ui){$(".ui-dialog-titlebar-close", $(this).parent()).hide();},
							
							autoOpen: false, 
							modal: true,  
							buttons: {
								"Cancel": function(){
									withCopyTable(this, function(copyTable){
										copyTable.cancelAndRestore();
									});
									$('select').not('.sdrop').show();  
									$(this).dialog("close"); 
									
									// If we cancel and got here from project details => more actions => copy project...
									// Go back to that page...
									if(gGoBackToPreviousPageOnCancelCopyOptionsDialog){
										window.history.back();
									}
								}, 
								"OK": function(){
									withCopyTable(this, function(copyTable){
										if(copyTable.validateAndSave()) {
											$(this).dialog("close"); createProject(i18nDocUConfLangArr);
										}
									});
								}
							} 
						});
						
						gThumbnailSelectDlg = $("#thumbnailOptionsDialog").dialog({
							close: function(ev, ui){ 
								$('select').not('.sdrop').show(); 
							},
							closeText: "",
							width: '400',
							autoOpen: false, 
							modal: true, 
							buttons: {
								"OK": function(){
									 if (ValidateThumbnail()) { 
									 	$('select').not('.sdrop').show(); 
									 	$(this).dialog("close");}  
									}
								}
							});
						
						// set the source project id 
						gSourceProjectID = '<xsl:value-of select="/webcenter_page/source_project_id"/>';
						<!-- Check to see if  all templates should be shown-->
					 	<xsl:if test="/webcenter_page/show_templates_only">
					 		gProjectCreationTypeFixed = true;
					 		gProjectCreationType = "TemplateProject";
							resetPage();
							$("#projectTypeSelectId").prop("disabled",true);
					 	</xsl:if>
						<xsl:if test="count(/webcenter_page/project_creation/template) > 0">
							gProjectCreationType = "TemplateProject";
							$("#creationTypeId").val(gProjectCreationType);
							gProjectCreationTypeFixed = true;
						</xsl:if>
						<xsl:if test="count(/webcenter_page/project_creation/template) = 1">
							<xsl:choose>
								<!-- we are dealing with a template -->
								<xsl:when test="/webcenter_page/project_creation/template/istemplate = '1'">
									selectCopyOptions($("#selectTemplateId").get(0), false);	
								</xsl:when>
								<!-- we are dealing with a project -->
								<xsl:otherwise> 
									gProjectCreationType = "CopyProject";
									$("#creationTypeId").val(gProjectCreationType);
									var projectID= '<xsl:value-of select="/webcenter_page/project_creation/template/id"/>';
									gProjectID  = projectID; 
									gGoBackToPreviousPageOnCancelCopyOptionsDialog = true;
									isAccessedFromProjectDetails = true;
									selectCopyOptions($("#selectProjectId").get(0), true);
								</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
											
											
		  				ProcessEnabledDocTypes();
							
						<xsl:if test="count(/webcenter_page/doc_template_char_id) = 1">
							var charList  = new Array();
							var charList2  = new Array();
							var charList3  = new Array();
							<xsl:for-each select="//characteristic[path=/webcenter_page/doc_template_char_path]" >
								charList['<xsl:value-of select="@id"/>']=	'<xsl:value-of select="name"/>';
								var id = '<xsl:value-of select="@id"/>';
								var charList2 = new Array();
									
									'<xsl:variable name="subpath"><xsl:value-of select="concat(/webcenter_page/doc_template_char_path,@id)"/></xsl:variable>';
								<xsl:for-each select="//characteristic[path=$subpath]" >
									var index = '<xsl:value-of select="position()-1"/>';
									charList2[index] = new Array( '<xsl:value-of select="@id"/>', '<xsl:value-of select="name"/>');
								</xsl:for-each>
								charList3[id ] = charList2;
							</xsl:for-each>
							gCharacteristicsTree = charList3;
						</xsl:if>	
							
						$("#characteristicfilterrow").hide();
					});
					
					
				});
								
				
				// Intialise Language Strings Object
				var langStrings = { noTemplate: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOTMPLTAVAIL')"/></xsl:call-template>",
									noProjects: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOPROJSSAVAIL')"/></xsl:call-template>",
									noDocuments: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NODOCSAVAIL')"/></xsl:call-template>",
									noProjectSelected: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_NO_PROJ_SEL')"/></xsl:call-template>",
									loading: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_LOADING')"/></xsl:call-template>",
									pleaseSelect: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_SELECT')"/></xsl:call-template>",
									ok: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'OK')"/></xsl:call-template>",
									cancel: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'CANCEL')"/></xsl:call-template>",
									noGroup: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NO_GROUP')"/></xsl:call-template>",
									noUsers: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'GROUPHASNOUSERS')"/></xsl:call-template>",
									projectCreationWarning: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_WARNING')"/></xsl:call-template>",
									projectMemberWarning: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBER_WARNING')"/></xsl:call-template>",
									templateExistingMemberWarning: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_EXISTING_MEMBER_WARNING')"/></xsl:call-template>",
									browse: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBER_BROWSE')"/></xsl:call-template>",
									copy: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'COPY')"/></xsl:call-template>",
									newString: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NEW_TAG')"/></xsl:call-template>",
									link: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_MEMBER_LINK')"/></xsl:call-template>",
									del: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'DELETE_TAG')"/></xsl:call-template>",
									expand: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_EXPAND')"/></xsl:call-template>",
									collapse: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_COLLAPSE')"/></xsl:call-template>",
									rootFolder: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ROOT_FOLDER_TAG')"/></xsl:call-template>",
									defaultFolder: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'DEFAULT_FOLDER')"/></xsl:call-template>",
									select: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SELECT')"/></xsl:call-template>"+"...."	,
									desThumbnailsTruncated: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'WAR_DES_THUMBNAILS_TRUNCATED')"/></xsl:call-template>",
									namesuffix: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_EDIT_FIELD')"/></xsl:call-template>",
									selectGroup: "---<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SELECT_GROUP')"/></xsl:call-template>---",
								    selectUser: "---<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SELECT_USER')"/></xsl:call-template>---",
								    loadingMsg: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'LOADINGUSERS')"/></xsl:call-template>",
								    noUsersInGroup: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NO_USER')"/></xsl:call-template>",
								    addNew: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ADD_NEW')"/></xsl:call-template>",
								    remove: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'UNINVITE')"/></xsl:call-template>",
									noGroupsAvail: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOGROUPSAVAILFORDEL')"/></xsl:call-template>",
									noUsersAvail: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOUSERSAVAILFORDEL')"/></xsl:call-template>",
									selectGroupsFirst: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SELECT_GROUP_FIRST')"/></xsl:call-template>",
									group: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'GROUP')"/></xsl:call-template>",
									role: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ROLE')"/></xsl:call-template>",
									requiredFieldChar: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'REQUIRED_FIELD_CHAR')"/></xsl:call-template>",
									notAllowedDocExtension: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'NOT_ALLOWED_DOC_EXTENSION')"/></xsl:call-template>"
				};

				//this load translations for project statuses
				langStrings.ProjectStatusesTranlation = {
		            <xsl:for-each select="/webcenter_page/project_status_list/custom_project_status/translation_tag">
		            '<xsl:value-of select="XSLUtils:encodeForJScript(.)"/>' : "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStrFallback(&lk;, ., '')"/></xsl:call-template>"
		            <xsl:if test="position() != last()" >
		            ,
		            </xsl:if>
		            </xsl:for-each>
		        };

			   	<!-- build the doc type settings array -->
				 <xsl:call-template name="scriptincsdoctypesettings"/>
		
				// Initialize default hour of day
				gDefaultHourAsHalfHours = <xsl:value-of select="/webcenter_page/default_due_date_time"/>;
				
				// Called when a new project type is selected
				// Select options for the copying of a project
				function selectCopyOptions(projectSelectBox, isProjectCopy) {
					
					// clear document gallery
					gDocumentTemplateSelectionInitialized = false;

					if (gProjectCreationType == "TemplateProject")
						gNewProjectID =	$("#selectTemplateId")[0].value;
					else if(gProjectCreationType == "CopyProject")
						gNewProjectID = $("#selectProjectId")[0].value;
					
					// Apparently, the project ID is stored in the selectTemplateId instead of 
					// selectProjectId when accessing the page from the Project Details Copy action
					if(gProjectCreationType == "CopyProject" &amp;&amp; isAccessedFromProjectDetails) 
						gNewProjectID = $("#selectTemplateId")[0].value;

					gProjectSelectBox = projectSelectBox;
					// createProject or opening the copy settings popup requires the copy table component to be loaded.
					// withCopyTable waits for that and returns the component
					withCopyTable(this, function(copyTable){
						if(isProjectCopy) {
							// hide all selects on the page because they end up showing over the popup in some browsers
							// (will be re-shown when the popup closes)
							$('select').hide();
							// do not hide selects in the dialog itself
							$("#projectCopyDialog select").not('.sdrop').show();
							// open the copy dialog
							$("#projectCopyDialog").dialog("open");
							// initialize the dialog with the settings for the selected project...
							copyTable.setProjectId(gNewProjectID);
						} else {
							createProject(i18nDocUConfLangArr);
						}
					});
				}
				
				/**
				 * Function to wait until the copy table component in the copy settings popup is loaded and if so, 
				 * call the callback with the CopyProjectOptionsTable object as the argument
				 * 
				 * @param context what should be "this"?
				 * @param callback function(CopyProjectOptionsTable) which is called when the copy settings table is loaded
				 */
				function withCopyTable(context, func) {
					require(["utils/init"], function(init) {
						init.whenInitialized($("#projectCopyOptionsTable"), function(){
							func.call(context, $("#projectCopyOptionsTable").get(0).CopyProjectOptionsTable);
						});
					});
				}
								
				
				// Function to show and hide sections
				function slide(BlockId, img, button, show) {
				
					var sectionId = "#" + BlockId;
					
					if(show) {
						img.className = "icon icon-normal icon-WCR_Down";
						button.onclick = function(){slide(BlockId, img, button, false);};
						$(sectionId).slideDown('fast');
					} else {
						img.className = "icon icon-normal icon-WCR_Right";
						button.onclick = function(){slide(BlockId, img, button, true);};
						$(sectionId).slideUp('fast');
					}					
				}
				
				// Template Thumnail
				var defaultThumbnail = "<xsl:value-of select="/webcenter_page/default_thumbnail_url"/>";
				
				// Function used in Thumbnail Selection
				function SelectRadioThumbnail(radioElem, parentNode) {
					radioElem.checked = true;
					$("#systemThumbnail")[0].value = 0;
					
					if(parentNode == 'ThumbRowOther') { // Select new icon (browse)
						// Display the icon if it was set
						if($("#ThumbnailId").val() == "") {
							$("#showThumbnailId").attr("src", $("#emptyImageId").val());
						} else {
							$("#showThumbnailId").attr("src", $("#selectedImageId").val());
						}
						// make it visible		
						$("#ThumbnailId").prop("disabled", false);
			   		} else if (parentNode == 'ThumbRowDefault') { // System default icon
			   			// make it invisible
						$("#ThumbnailId").prop("disabled", true);
						
						// Change the icon 
						$("#showThumbnailId").attr("src", $("#defaultThumbnailId").val());
						// set the value - use the system thumbbnail
						$("#systemThumbnail")[0].value = 1;
						
					} else if (parentNode == 'ThumbRowTemplate') { // Template icon
						// make it invisible
						$("#ThumbnailId").prop("disabled", true);

						// Change the icon
						$("#showThumbnailId").attr("src", $("#templateThumbnailId").val());
					} else if (parentNode == 'ThumbRowCustom') { // Other (not used)
						$("#ThumbnailId").prop("disabled", true);
						$("#showThumbnailId").attr("src", $("#customThumbnailUrlId").val());
					}
				}
				
				function SetCurThumbnailSrc(val) 
				{
					// validate the selected document
					// Analyze file ext for supported graphic doc type 
				  var found = false;
				  var suffix = val.substring(val.lastIndexOf('.'));
		
					var supported_extensions = "(" ;
					var first_elem = true ;
				  <xsl:for-each select="//supported_thumbnail_graphics/extension">
					  if (first_elem==false )
 			   		  	supported_extensions += ', ';
					  var extXml = "<xsl:value-of select="."/>";
					  supported_extensions += extXml;
					  first_elem = false ;
					  if (suffix.toUpperCase() == extXml.toUpperCase())
					    found = true; 			   		  
				  </xsl:for-each>
				  supported_extensions += ")"
		
				  // Find out the extension
				  if (found == false)		
				  {
					  $("#ThumbnailId").val('');
					  $("#selectedImageId").val('');
			          alert('<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INV_THUMBNAIL')"/></xsl:call-template>&nbsp;' + ' ' + supported_extensions);
					  return false;
				  }
				  
				  
					$("#selectedImageId").val(val);
		
			        
					// On the mac we need to prefix the path
					var fileVal = "file://" + val;
					$("#showThumbnail").attr("src", fileVal);	
					return true ;
				}
				
				function ValidateThumbnail()
				{
					// check which thumbnail option was specified
					if ($("#thumbUrlOptionId1")[0].checked == false ) 
						return true ;
				
					if ( $("#ThumbnailId")[0] !=null  )
						if ( isWhitespace( $("#ThumbnailId")[0].value ) )
						{
							var ok_empty_thumbnail = confirm('<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_THUMBNAIL_EMPTY')"/></xsl:call-template>') ;
							if (ok_empty_thumbnail)
							{
								// put back the default thumbnail 
								$("#showThumbnailId")[0].src= $("#templateThumbnailId")[0].value;
							}	
							return ok_empty_thumbnail ;
						}
						else
						{
						}
			        return true;
				}
				
				function closeDialog()
				{
					if( gProjectCreationType != "BlankProject") 
					{
						var boxId = "#" + gProjectSelectBox.id + " option[value='" + gProjectID + "']"; // jQuery selector
						$(boxId).prop("selected", true);
					}
				}
				
				function CancelCopyDialog() 
				{
					// when we came from within a project amd we click cancel on the copy options dialog, return to the original project
					if( gProjectCreationType == "CopyProject"  &amp;&amp; gProjectCreationTypeFixed )
					{
						var projectUrl = "projdetails.jsp?projectID=" + gProjectID + "&amp;<xsl:call-template name="menuFileUrlParameter"/>";
						window.location = projectUrl ;
        				return;
					}
					else {				
						closeDialog();
						
					}
				}
				
				
				function Reset(templateThumb, fullReset) {
					if(fullReset)
						document.actionform.reset();
					
					if (templateThumb != null &amp;&amp; templateThumb.length &gt; 0 &amp;&amp; templateThumb != defaultThumbnail) {
						$("#templateThumbnailId").val(templateThumb);
						$("#templateImageId").attr("src", templateThumb);
						$("input[name='thumbUrlOption']")[2].checked = true;
						SelectRadioThumbnail($("input[name='thumbUrlOption']")[2], 'ThumbRowTemplate');
						$("#ThumbURLRow1").show();
					} else {
						$("input[name='thumbUrlOption']")[1].checked = true;
						SelectRadioThumbnail($("input[name='thumbUrlOption']")[1], 'ThumbRowDefault');
						$("#ThumbURLRow1").hide();
					}
				}
				
				function validatePasswordAndCreate() {				
					var asyncWorkPromises = [];

					// gather "when all async work" promises of all main attribute categories and document table(s) on the page
					// "Documents" section (implemented using DocTableX)
					if (window.docTableObj) {
						asyncWorkPromises.push(window.docTableObj.whenAllAsyncWorkDone());
					}
					// project attribute category
					var aCatObj = document.getElementById("projectAttributesBlockId");
					if (aCatObj &amp;&amp; aCatObj.ACatObj) {
						asyncWorkPromises.push(aCatObj.ACatObj.whenAllAsyncWorkDone());
					}
					// attribute categories of documents in BOM section
					for (var docAttIdx = 1; docAttIdx &lt;= gBOMDocumentCounter; docAttIdx++) {
						var bomDocACatObj = document.getElementById("documentDivIdBOM"+ docAttIdx + "Attributes");
						if (bomDocACatObj &amp;&amp; bomDocACatObj.ACatObj) {
							asyncWorkPromises.push(bomDocACatObj.ACatObj.whenAllAsyncWorkDone());
						}
					}

					// proceed with validation and submit only after all the data on the page are loaded and ready
					Promise.all(asyncWorkPromises).then(function() {
						if (aCatObj &amp;&amp; aCatObj.ACatObj) {
			    			// before submit check for the password
						    aCatObj.ACatObj.checkPasswordAndSave(function() {
					    		ValidateFormParams();
						    });
					    } else {
					    	ValidateFormParams();
					    }
					});
					
					return false;   // the create project page is submited explicitely in JavaScript
				}
				
				
				/**
				 * This method assumes all asynchronous work is done prior it's called. Make sure it is always the case!
				 * (currently called only from validatePasswordAndCreate() method)
				 */
				var alreadysubmitted = false;
				function ValidateFormParams()
				{	
					if (alreadysubmitted){
						return false;
					}
				
					var months = new Array(12);
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH1')"/></xsl:call-template>'] = 1 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH2')"/></xsl:call-template>'] = 2 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH3')"/></xsl:call-template>'] = 3 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH4')"/></xsl:call-template>'] = 4 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH5')"/></xsl:call-template>'] = 5 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH6')"/></xsl:call-template>'] = 6 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH7')"/></xsl:call-template>'] = 7 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH8')"/></xsl:call-template>'] = 8 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH9')"/></xsl:call-template>'] = 9 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH10')"/></xsl:call-template>'] = 10 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH11')"/></xsl:call-template>'] = 11 ;
					months['<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'MONTH12')"/></xsl:call-template>'] = 12 ;
					
					var langStrings = { 
						invalidCustomer		: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_CUST')"/></xsl:call-template>",
						invalidDescription	: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_DESCRIPTION')"/></xsl:call-template>",
						invalidManager		: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_MANAGER')"/></xsl:call-template>",
						invalidDueDate 		: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_DUEDATE')"/></xsl:call-template>",
						wrongFormatDueDate 	: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_WRONG_FORMAT_DUEDATE')"/></xsl:call-template>",
						invalidDueDate_DateInPast	: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_DUEDATE_IN_PAST')"/></xsl:call-template>",
						invalidDocument 	: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_DOCUMENT')"/></xsl:call-template>",
						invalidDocDescription	: "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_DOC_DESCR')"/></xsl:call-template>",									
						selectAtLeastOneDoc : "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_SELECT_DOCUMENT')"/></xsl:call-template>",	
						selectAtLeastOneBOMDoc : "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_SELECT_BOM_DOCUMENT')"/></xsl:call-template>",									
						docNamesNotUnique   : "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_SPECIFY_UNIQUE_DOCNAMES')"/></xsl:call-template>",
						invalidRolesSelection:  "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INV_ROLES')"/></xsl:call-template>",
						invalidPlanning:  "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVALID_PLANNING')"/></xsl:call-template>",
						invalidPlanning_DateInPast:  "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_INVPLAN_DATE_IN_PAST')"/></xsl:call-template>",
						invalidProjectName  : "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'BADPROJNAME')"/></xsl:call-template>",
						duplicateProjectName  : "<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_DUPLICATE_PROJECTNAME')"/></xsl:call-template>"
					};
					
					// create object for unique name checking
					var uniqueNameCheckObj  = window.eventBasedValidator.createUniqueNamesObj();
					// For CopyProject, if documents are not copied, don't check for document names of source project
					var copyDocuments = $('input[name="copyOptionDocs"]').prop("checked");
					var createType = $("#creationTypeId").val();
					if(createType === 'CopyProject' &amp;&amp; !copyDocuments){
						uniqueNameCheckObj.excludeProject(document.actionform.projectID.value);
					}
					
					// validation of project creation page fields + BOM and Documents section
					if (!validateProjectCreationForm( langStrings,  uniqueNameCheckObj, false)) {
						return false;
					}
				
					// project attribute validation
					var aCatObj = document.getElementById("projectAttributesBlockId");
					if (aCatObj &amp;&amp; aCatObj.ACatObj) {
						if (!aCatObj.ACatObj.syncPrepareForSubmit()) {
							return false;
						}
					}					
					
					// Do global name checking
					window.eventBasedValidator.validateNamesGlobally(uniqueNameCheckObj);
					if(!uniqueNameCheckObj.isOk()){
						return false;
					}
										
					gThumbnailSelectDlg.parent().appendTo($("#actionformId"));	// put it back in the form
					
					// this condition makes sure the project creation form can only be submitted once
					// without it, you will create multiple projects if you click multiple times
					// (only needed with autonaming, without it, an exception will be thrown that project already exists)
			    	alreadysubmitted = true;
			    	
			    	// Show loading indicator that also prevents user to do interaction with the page.
			    	require(["component/overlaymessage/OverlayMessage"], function(OverlayMessage) {
						var overlayMessage = new OverlayMessage($("#actionformId"), "", {overlayClass: "fixed"});
			    		overlayMessage.showLoading();
			    		
			    		var asyncWorkAfterValidation = [];

						// gather "when all async work" promises of all main attribute categories and document table(s) on the page
						// "Documents" section (implemented using DocTableX)
						if (window.docTableObj &amp;&amp; !window.docTableObj.isDestroyed) {
							asyncWorkAfterValidation.push(window.docTableObj.whenAllAsyncWorkDone());
						}
						// project attribute category
						var aCatObj = document.getElementById("projectAttributesBlockId");
						if (aCatObj &amp;&amp; aCatObj.ACatObj &amp;&amp; !aCatObj.ACatObj.isDestroyed) {
							asyncWorkAfterValidation.push(aCatObj.ACatObj.whenAllAsyncWorkDone());
						}
						// attribute categories of documents in BOM section
						for (var docAttIdx = 1; docAttIdx &lt;= gBOMDocumentCounter; docAttIdx++) {
							var bomDocACatObj = document.getElementById("documentDivIdBOM"+ docAttIdx + "Attributes");
							if (bomDocACatObj &amp;&amp; bomDocACatObj.ACatObj &amp;&amp; !bomDocACatObj.ACatObj.isDestroyed) {
								asyncWorkAfterValidation.push(bomDocACatObj.ACatObj.whenAllAsyncWorkDone());
							}
						}
			    		
			    		Promise.all(asyncWorkAfterValidation).then(function() {
							if (window.docTableObj) {
				    			// generate XML representing the documents table content
								window.docTableObj.onSubmit();
							}
				    		if (aCatObj &amp;&amp; aCatObj.ACatObj) {
								aCatObj.ACatObj.convertDocReferencesToXML();
							}
							for (var docAttIdx = 1; docAttIdx &lt;= gBOMDocumentCounter; docAttIdx++) {
								var bomDocACatObj = document.getElementById("documentDivIdBOM"+ docAttIdx + "Attributes");
								if (bomDocACatObj &amp;&amp; bomDocACatObj.ACatObj) {
									bomDocACatObj.ACatObj.convertDocReferencesToXML();
								}
							}

							document.actionform.submit();
			    		})
			    		.catch(function(reason) {
							// the form not submitted (probably due to validation issue detected) - enable all submit buttons again
							EnableMainButtons(true);
							if (console &amp;&amp; console.error) {
								console.error("Exception in asynchronous task: " + reason);
							} else {
								alert("Exception in asynchronous task: " + reason);
							}
						});
					});
					
					return true;
				}
				
		
				function ShowTemplateDetails(templateID)
		        {
					window.location = "javascript:OpenNewWindow('templatedetailsdocs.jsp?templateID=" + templateID + "');"; 
		        }
		        
				function OpenNewWindow(href)
				{
				  window.open(href)
				}
				
				function ShowSelectedTemplateDetails(type, event)
				{	
					event.preventDefault();			
															
					if (type == 0)
					{
						if ( $("#selectTemplateId")[0] != null  )
						{
							if ($("#selectTemplateId")[0].value == '')
								alert('<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'SELECTTMPLT')"/></xsl:call-template>');
							else
							 	ShowTemplateDetails($("#selectTemplateId")[0].value);													
						}
					}					
					else 										
					{																				
						if ( $("#selectProjectId")[0] != null  )
						{
							if ($("#selectProjectId")[0].value == '')
								alert('<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PLEASESELECTPROJECT')"/></xsl:call-template>');
							else
							 	ShowTemplateDetails($("#selectProjectId")[0].value);													
						}
					}
					
				}
				
				function projectPlanningChanged() {
					try {
						var lastTaskEnds = '<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_LAST_TASK_DATE')"/></xsl:call-template>';
						var firstTaskStarts = '<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'PROJ_CREATION_FIRST_TASK_DATE')"/></xsl:call-template>';
						var current = $.trim($("#planningLastTask").text());

						if ( $("#projectPlanningId")[0].value == 'backward' &amp;&amp; current.indexOf(firstTaskStarts) === 0) { // only overwrite if it uses a default label
							$("#planningLastTask").html(lastTaskEnds);
							$("#planningLastTask").addClass("form-required");
							$("#longFormat_projectTaskDate")[0].value = $("#longFormat_projectDueDate")[0].value;
							$("#projectTaskDate")[0].value = $("#projectDueDate")[0].value;
							if ($("#projectTaskDatePeriodOfDay").length &gt; 0) {
								$("#projectTaskDatePeriodOfDay")[0].selectedIndex = $("#projectDueDatePeriodOfDay")[0].selectedIndex;
							}
						} else if($("#projectPlanningId")[0].value == 'forward' &amp;&amp; current.indexOf(lastTaskEnds) === 0) { // only overwrite if it uses a default label
							$("#planningLastTask").html(firstTaskStarts);
							
							var today = new Date();
	
							$("#longFormat_projectTaskDate").val(formatDate(today, "NNN dd, yyyy"));
							$("#projectTaskDate").val(formatDate(today, "MM/dd/yyyy")); 
							var timeElem = $("#projectTaskDatePeriodOfDay")[0];
							if (timeElem)  {
								var halfHours = today.getHours() * 2 + Math.floor(today.getMinutes()/30);
								timeElem.selectedIndex = halfHours + 2;
							}
							if(gProjectCreationForm.planning == "REQUIRED"){
								$("#planningLastTask").addClass("form-required");
							} else {
								$("#planningLastTask").removeClass("form-required");
							}
						}
					} catch (err) {
						alert("Problem in projectPlanningChanged() function: " + err);
					}
				
				}

				function DueDateChanged()
				{
					try
					{
						if ($("#projectPlanningId") != null) 					
						{
							if ( $("#projectPlanningId")[0].value == 'backward')
							{
								$("#longFormat_projectTaskDate")[0].value = $("#longFormat_projectDueDate")[0].value;
								// the short-format is not yet generated when change() is called so we calculate the value here
								var date = new Date($("#longFormat_projectDueDate")[0].value);
								$("#projectTaskDate").val(formatDate(date, "MM/dd/yyyy"));
								var timeElem = $("#projectDueDatePeriodOfDay")[0];
								if (timeElem) 
								{
									if (timeElem.selectedIndex == 0) $("#projectTaskDatePeriodOfDay")[0].selectedIndex = 36 + 1;
									else $("#projectTaskDatePeriodOfDay")[0].selectedIndex = timeElem.selectedIndex;
								}
							}
						}
					}
					catch (err) 
					{
						alert("Problem in DueDateChanged() function: " + err);
					}
				}

				function DueDateChangedTime()
				{
					try
					{
						if ($("#projectPlanningId") != null)
						{
							if ( $("#projectPlanningId")[0].value == 'backward')
							{
								var timeElem = $("#projectDueDatePeriodOfDay")[0];
								if (timeElem &amp;&amp; (timeElem.selectedIndex == 0)) $("#projectTaskDatePeriodOfDay")[0].selectedIndex = 36 + 1;
								else $("#projectTaskDatePeriodOfDay")[0].selectedIndex = timeElem.selectedIndex;
							}
						}
					}
					catch (err)
					{
						alert("Problem in DueDateChangedTime() function: " + err);
					}					
				}
				
				function openThumbnailDialog() {
					require(["jquery", "jqueryUI"], function($){
						$('select').hide(); 
						$('#thumbnailOptionsDialog').dialog('open');					
					});
				}
				
			<xsl:text disable-output-escaping="yes">//--&gt;</xsl:text>&#xA;
		</script>
	
		<xsl:call-template name="DateJavaScript"/>
	</xsl:template>
	
</xsl:stylesheet>
